/*************************************
 * Adconverter.c
 *   
 * : 06.10.2018 11:04:47
 * :  .
 *************************************/

#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include "Adconverter.h"
#include "Main.h"
#include "Systemcontrol.h"
#include "Operatingmode.h"

EEMEM static word Adc_DividerVoltage[51]={0,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,
											ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,ADCNMC_DIVIDER,
											ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,
											ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,ADCLPI_DIVIDER,
											ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER,ADCLFE_DIVIDER}; //        
EEMEM static word Adc_AsymmOffsetvoltage=0; //     
EEMEM static dword Adc_ArefVoltage=ADCAREF_VOLTAGE; //   1100  
EEMEM static dword Adc_FirstchargeResistance=ADCMEASCUR_RESISTOR; //      1
EEMEM static dword Adc_FirstdischargeResistance=ADCMEASCUR_RESISTOR; //      1
EEMEM static dword Adc_SecondchargeResistance=ADCMEASCUR_RESISTOR; //      2
EEMEM static dword Adc_SeconddischargeResistance=ADCMEASCUR_RESISTOR; //      2

word ADC_ReadMeasuredata(byte measureinput_prm) //    
	{
	word adconvertdata_tmp=0; //  
	dword measurevoltage_tmp=0;
	ADMUX=measureinput_prm|(ADCBASE_REFTYPE&255); //   
	_delay_loop_2(40); // 10       
	ADCSRA|=64; //  
	while((ADCSRA&16)==0); //   
	ADCSRA|=16; //    
	adconvertdata_tmp=ADCW; //   
	measurevoltage_tmp=(dword)adconvertdata_tmp*eeprom_read_dword(&Adc_ArefVoltage)/1024; //     
	return (word)measurevoltage_tmp; //    
	}

void ADC_InitializeDevice(void) //   
	{
	word measuredata_tmp=0; // 
	ADMUX=ADCBASE_REFTYPE&255; //   1100 
	ADCSRA=ADCMODE_DATA; //   125 
	_delay_loop_2(640); //     160 
	measuredata_tmp=ADC_ReadMeasuredata(ADCOFFSET_AGND); //    
	if((eeprom_read_word(&Adc_AsymmOffsetvoltage)==0)&&(measuredata_tmp>0)) ADC_OffsetMeasure(); //       
	}

void ADC_OffsetMeasure(void) //     
	{
	byte countcycle_tmp=0; //  
	word measuredata_tmp=0;
	while(countcycle_tmp<100) //    
		{
		measuredata_tmp+=ADC_ReadMeasuredata(ADCOFFSET_AGND); //       
		countcycle_tmp++; //  
		SYS_TimeWaiting(10); // 10 
		}
	measuredata_tmp/=countcycle_tmp; //    
	eeprom_update_word(&Adc_AsymmOffsetvoltage,measuredata_tmp); //     
	}

word ADC_AverageMeasuredata(byte numbercycle_prm,byte measureinput_prm) //     
	{
	byte countmeasure_tmp=0; // 
	dword measurevoltage_tmp=0; 
	word offsetdata_tmp=0;
	while(countmeasure_tmp<numbercycle_prm) //   
		{
		measurevoltage_tmp+=ADC_ReadMeasuredata(measureinput_prm); //  
		offsetdata_tmp+=eeprom_read_word(&Adc_AsymmOffsetvoltage); //   
		countmeasure_tmp++; //  
		SYS_TimeWaiting(1); // 1 
		}
	if(measurevoltage_tmp>=offsetdata_tmp) measurevoltage_tmp-=offsetdata_tmp; //  
	measurevoltage_tmp/=countmeasure_tmp; //  
	return (word)measurevoltage_tmp; //  
	}

word ADC_MeasureVoltage(byte numbercycle_prm,byte measureinput_prm) //    
	{
	byte numbersensor_tmp=0; // 
	word measurevoltage_tmp=0; 
	dword datadivider_tmp=0; 
	dword extrameasuredata_tmp=0;
	measurevoltage_tmp=ADC_AverageMeasuredata(numbercycle_prm,measureinput_prm); //    
	switch(measureinput_prm) //   
		{
		case ADCFIRST_VOLTAGE: numbersensor_tmp=OPR_ReadnumberSensor(FALSE); //    1 
								datadivider_tmp=(dword)ADC_ReadingDivider(numbersensor_tmp); //    
								extrameasuredata_tmp=(dword)measurevoltage_tmp*datadivider_tmp/1000; //     
								break;
		case ADCSECOND_VOLTAGE: numbersensor_tmp=OPR_ReadnumberSensor(TRUE); //    2
								datadivider_tmp=(dword)ADC_ReadingDivider(numbersensor_tmp); //   
								extrameasuredata_tmp=(dword)measurevoltage_tmp*datadivider_tmp/1000; //    
		}
	switch(numbersensor_tmp) //    
		{
		case 1 ... 20: if(extrameasuredata_tmp>100) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMITNMC_VOLTAGE/extrameasuredata_tmp; //     Ni-Cd  Ni-Mh 
				break;
		case 21 ... 40: if(extrameasuredata_tmp>500) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMITLPI_VOLTAGE/extrameasuredata_tmp; //     Li-Po  Li-Ion  
				break;
		case 41 ... 50: if(extrameasuredata_tmp>400) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMITLFE_VOLTAGE/extrameasuredata_tmp; //     Li-Fe  
		}
	return (word)extrameasuredata_tmp; //   
	}

word ADC_MeasureCurrent(byte numbercycle_prm,byte measureinput_prm) //   /  
	{
	word measurevoltage_tmp=0; // 
	dword extrameasuredata_tmp=0;
	measurevoltage_tmp=ADC_AverageMeasuredata(numbercycle_prm,measureinput_prm); //      
	switch(measureinput_prm) //  
		{
		case ADCSECOND_CURRCHARGE: extrameasuredata_tmp=(dword)measurevoltage_tmp*10000/eeprom_read_dword(&Adc_SecondchargeResistance); //    2
									break;
		case ADCSECOND_CURRDISCHARGE: extrameasuredata_tmp=(dword)measurevoltage_tmp*10000/eeprom_read_dword(&Adc_SeconddischargeResistance); //    2
									break;
		case ADCFIRST_CURRCHARGE: extrameasuredata_tmp=(dword)measurevoltage_tmp*10000/eeprom_read_dword(&Adc_FirstchargeResistance); //    1
									break;
		case ADCFIRST_CURRDISCHARGE: extrameasuredata_tmp=(dword)measurevoltage_tmp*10000/eeprom_read_dword(&Adc_FirstdischargeResistance); //    1
		}
	if(extrameasuredata_tmp>99) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMIT_CURRENT/extrameasuredata_tmp; //      100  
	else if((extrameasuredata_tmp>4)&&(extrameasuredata_tmp<100)) extrameasuredata_tmp=extrameasuredata_tmp+ADCLIMIT_CURRENT/120; //     100 
	return (word)extrameasuredata_tmp; //  
	}

dword ADC_ReadingConstants(byte numbergconstants_prm) //         
	{
	dword dataconstants_tmp=0; // 
	switch(numbergconstants_prm) // 
		{
		case 0: dataconstants_tmp=eeprom_read_dword(&Adc_ArefVoltage); //     
				break;
		case 1: dataconstants_tmp=eeprom_read_dword(&Adc_FirstchargeResistance); //      1
				break;
		case 2: dataconstants_tmp=eeprom_read_dword(&Adc_SecondchargeResistance); //      2
				break;
		case 3: dataconstants_tmp=eeprom_read_dword(&Adc_FirstdischargeResistance); //      1
				break;
		case 4: dataconstants_tmp=eeprom_read_dword(&Adc_SeconddischargeResistance); //      2
		}
	return dataconstants_tmp; //   
	}

void ADC_UpdateDivider(byte numbersensor_prm,word divisionfactor_prm) //     
	{
	eeprom_update_word(&Adc_DividerVoltage[numbersensor_prm],divisionfactor_prm); //     
	}

void ADC_UpdateResistance(byte countmodecalibrate_prm,dword measuredvaluesdata_prm) //    
	{
	switch(countmodecalibrate_prm) //  
		{
		case 0 ... 1: asm("nop"); // 
				break;
		case 2: eeprom_update_dword(&Adc_FirstchargeResistance,measuredvaluesdata_prm); //      1
				break;
		case 3: eeprom_update_dword(&Adc_SecondchargeResistance,measuredvaluesdata_prm); //      2
				break;
		case 4: eeprom_update_dword(&Adc_FirstdischargeResistance,measuredvaluesdata_prm); //      1
				break;
		case 5: eeprom_update_dword(&Adc_SeconddischargeResistance,measuredvaluesdata_prm); //      2
		}
	}

word ADC_ReadingDivider(byte numbersensor_prm) //    
	{
	word datadivider_tmp=0; // 
	datadivider_tmp=eeprom_read_word(&Adc_DividerVoltage[numbersensor_prm]); //     
	return datadivider_tmp; //   
	}

void ADC_DefaultDivider(bit numberbattery_prm) //      
	{
	byte numbersensor_tmp=0; //  
	word valuedivider_tmp=0; 
	numbersensor_tmp=OPR_ReadnumberSensor(numberbattery_prm); //    
	switch(numbersensor_tmp) //    
		{
		case 1 ... 20: valuedivider_tmp=ADCNMC_DIVIDER; //      Ni-Cd  Ni-Mh  
				break;
		case 21 ... 40: valuedivider_tmp=ADCLPI_DIVIDER; //      Li-Po  Li-Ion  
				break;
		case 41 ... 50: valuedivider_tmp=ADCLFE_DIVIDER; //      Li-Fe  
		}
	ADC_UpdateDivider(numbersensor_tmp,valuedivider_tmp); //     
	}

void ADC_DefaultResistance(byte countmodecalibrate_prm) //      
	{
	ADC_UpdateResistance(countmodecalibrate_prm,ADCMEASCUR_RESISTOR); //     
	}






