/***********************************************
* Calibrationmode.c
*    
* : 08.06.2022 10:26:31
* :  .
************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <math.h>
#include "Main.h"
#include "Calibrationmode.h"
#include "Systemcontrol.h"
#include "Symbolout.h"
#include "Keybuttscan.h"
#include "Adconverter.h"
#include "Operatingmode.h"

bit_cal indx_cal={0,0,0,0}; // 
var_cal alter_cal={0,0}; // 

void CAL_MainMode(bit indxupdateline_prm) //   
	{
	byte datacodecontrol_tmp=0; // 
	byte spotpositioncursor_tmp=0; 
	byte numbersensor_tmp=0; 
	word measuredvaluesdata_tmp=0; 
	if(indxupdateline_prm==TRUE) indx_cal.updatecalibrateline=TRUE; //         
	datacodecontrol_tmp=KEY_DecoderButton(); //  
	if(datacodecontrol_tmp>0) CAL_ControlCalibrate(datacodecontrol_tmp); //    
	switch(alter_cal.counterpositioncursor) //  
		{
		case 0: spotpositioncursor_tmp=0; //     
				break;
		case 1: spotpositioncursor_tmp=4; //    
				break;
		case 2:	spotpositioncursor_tmp=11; //    
				break;
		case 3: spotpositioncursor_tmp=12; //    
		}
	if(indx_cal.updatecalibrateline==TRUE) //    
		{
		indx_cal.updatecalibrateline=FALSE; // 
		switch(alter_cal.countermodecalibrate) //   
			{
			case 0: SYM_LineOut(3,0,FALSE,FALSE,2); //     1
					break;
			case 1: SYM_LineOut(3,0,FALSE,TRUE,2); //     2 
					break;
			case 2: SYM_LineOut(4,0,FALSE,FALSE,1); //      1
					break;
			case 3: SYM_LineOut(4,0,FALSE,TRUE,1); //      2
					break;
			case 4: SYM_LineOut(5,0,FALSE,FALSE,1); //      1
					break;
			case 5: SYM_LineOut(5,0,FALSE,TRUE,1); //      2	
			}
		}
	switch(alter_cal.countermodecalibrate) //   
		{
		case 0 ... 1: switch(indx_cal.numberbattery) //  
						{
						case FALSE: measuredvaluesdata_tmp=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //   1
									break;
						case TRUE: measuredvaluesdata_tmp=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //   2
						}
					if(indx_cal.calibrationvoltage==TRUE) //    
						{
						indx_cal.calibrationvoltage=FALSE; // 
						numbersensor_tmp=OPR_ReadnumberSensor(indx_cal.numberbattery); //   
						CAL_CalibrmeasVoltage(numbersensor_tmp,measuredvaluesdata_tmp); //  
						}
					SYM_OutdataNumber0_000(measuredvaluesdata_tmp,9); //  
					break;
		case 2 ... 3: switch(indx_cal.numberbattery) //  
						{
						case FALSE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //    1
									break;
						case TRUE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //    2
						}
					if(indx_cal.calibrationcurrent==TRUE) //    
						{
						indx_cal.calibrationcurrent=FALSE; // 
						CAL_CalibrmeasCurrent(measuredvaluesdata_tmp); //   
						}
					SYM_OutdataNumber0_000(measuredvaluesdata_tmp,8); //  
					break;
		case 4 ... 5: switch(indx_cal.numberbattery) //  
						{
						case FALSE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRDISCHARGE); //    1
									break;
						case TRUE: measuredvaluesdata_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRDISCHARGE); //    2
						}
					if(indx_cal.calibrationcurrent==TRUE) //    
						{
						indx_cal.calibrationcurrent=FALSE; // 
						CAL_CalibrmeasCurrent(measuredvaluesdata_tmp); //   
						}
					SYM_OutdataNumber0_000(measuredvaluesdata_tmp,8); //  
		}
	SYM_CursorPosition(spotpositioncursor_tmp); //   
	SYS_TimeWaiting(300); // 300  
	}
	
void CAL_CalibrmeasVoltage(byte numbersensor_prm,word measuredvaluesdata_prm) //   
	{
	dword divisionfactor_tmp=0; //  
	dword divisibledata_tmp=0;
	switch(numbersensor_prm) //    
		{
		case 1 ... 20: if((measuredvaluesdata_prm>CALMINNMC_RANGE)&&(measuredvaluesdata_prm<CALMAXNMC_RANGE)) //      
						{
						divisibledata_tmp=CALIBRNMC_VOLTAGE; // 
						divisibledata_tmp*=CALIBRNMC_DIVIDER;
						divisionfactor_tmp=divisibledata_tmp/measuredvaluesdata_prm; //    Ni-Mh  Ni-Cd  
						}
				break;
		case 21 ... 40: if((measuredvaluesdata_prm>CALMINLPI_RANGE)&&(measuredvaluesdata_prm<CALMAXLPI_RANGE)) //      
						{
						divisibledata_tmp=CALIBRLPI_VOLTAGE; //  
						divisibledata_tmp*=CALIBRLPI_DIVIDER; 
						divisionfactor_tmp=divisibledata_tmp/measuredvaluesdata_prm; //    Li-Po  Li-Ion  
						}
				break;
		case 41 ... 50: if((measuredvaluesdata_prm>CALMINLFE_RANGE)&&(measuredvaluesdata_prm<CALMAXLFE_RANGE)) //      
						{
						divisibledata_tmp=CALIBRLFE_VOLTAGE; // 
						divisibledata_tmp*=CALIBRLFE_DIVIDER; 
						divisionfactor_tmp=divisibledata_tmp/measuredvaluesdata_prm; //    Li-Fe 
						}
		}
	ADC_UpdateDivider(numbersensor_prm,(word)divisionfactor_tmp); //   
	}

void CAL_CalibrmeasCurrent(word measuredvaluesdata_prm) //    
	{
	dword resistancedata_tmp=0; // 
	resistancedata_tmp=(dword)measuredvaluesdata_prm*CALVALUE_RESISTOR/CALIBRMEAS_CURRENT; //    
	if((resistancedata_tmp>CALMIN_RESISTANCE)&&(resistancedata_tmp<CALMAX_RESISTANCE)&&(resistancedata_tmp!=CALIBRMEAS_CURRENT)) //      
		{
		ADC_UpdateResistance(alter_cal.countermodecalibrate,resistancedata_tmp); //     
		}
	}

void CAL_ControlCalibrate(byte datacodecontrol_prm) //   
	{
	word comparedata_tmp=0; // 
	switch(datacodecontrol_prm) //  
		{
		case 1: switch(alter_cal.countermodecalibrate) //      Left
					{
					case 0 ... 3: switch(alter_cal.counterpositioncursor) //   
									{
									case 0: alter_cal.counterpositioncursor=1; //  1
											break;
									case 1: alter_cal.counterpositioncursor=0; //  0
									}
								break;
					case 4 ... 5: if(alter_cal.counterpositioncursor>0) alter_cal.counterpositioncursor--; //         
								else alter_cal.counterpositioncursor=3; //    
					}
				break;
		case 2: switch(alter_cal.countermodecalibrate) //      Rigt
					{
					case 0 ... 3: switch(alter_cal.counterpositioncursor) //   
									{
									case 0: alter_cal.counterpositioncursor=1; //  1
											break;
									case 1: alter_cal.counterpositioncursor=0; //  0
									}
								break;
					case 4 ... 5: alter_cal.counterpositioncursor++; //      
								if(alter_cal.counterpositioncursor>3) alter_cal.counterpositioncursor=0; //     
					}
				break;
		case 3: switch(alter_cal.counterpositioncursor) //      Up
					{
					case 0: alter_cal.countermodecalibrate++; //  
							if(alter_cal.countermodecalibrate>5) alter_cal.countermodecalibrate=0; //    
							CAL_SettnumberBattery(); //   
							break;
					case 1: CAL_SettdefaultDivider(); //     
							break;
					case 2: switch(alter_cal.countermodecalibrate) //  
								{
								case 0 ... 3: asm("nop"); // 
											break;
								case 4: comparedata_tmp=OPRFIRST_DISCHARGE; //        1
										if(comparedata_tmp>10) comparedata_tmp-=10; //    10    10 
										OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
								case 5: comparedata_tmp=OPRSECOND_DISCHARGE; //        2
										if(comparedata_tmp>10) comparedata_tmp-=10; //    10    10 
										OPRSECOND_DISCHARGE=comparedata_tmp; //      2
								}
							break;
					case 3: switch(alter_cal.countermodecalibrate) //  
								{
								case 0 ... 3: asm("nop"); // 
											break;
								case 4: comparedata_tmp=OPRFIRST_DISCHARGE; //        1
										if(comparedata_tmp>1) comparedata_tmp--; //     1 
										OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
								case 5: comparedata_tmp=OPRSECOND_DISCHARGE; //        2
										if(comparedata_tmp>1) comparedata_tmp--; //     1
										OPRSECOND_DISCHARGE=comparedata_tmp; //      2
								}
					}
				break;
		case 4: switch(alter_cal.counterpositioncursor) //      Down 
					{
					case 0: if(alter_cal.countermodecalibrate>0) alter_cal.countermodecalibrate--; //     
							else alter_cal.countermodecalibrate=5; //     
							CAL_SettnumberBattery(); //   
							break;
					case 1: CAL_SettdefaultDivider(); //     
							break;
					case 2: switch(alter_cal.countermodecalibrate) //   
								{
								case 0 ... 3: asm("nop"); //  
											break;
								case 4: comparedata_tmp=OPRFIRST_DISCHARGE; //        1
										if(comparedata_tmp<245) comparedata_tmp+=10; //    10    245
										OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
								case 5: comparedata_tmp=OPRSECOND_DISCHARGE; //        2
										if(comparedata_tmp<245) comparedata_tmp+=10; //    10    245
										OPRSECOND_DISCHARGE=comparedata_tmp; //      2
								}
							break;
					case 3: switch(alter_cal.countermodecalibrate) //  
								{
								case 0 ... 3: asm("nop"); // 
											break;
								case 4: comparedata_tmp=OPRFIRST_DISCHARGE; //        1
										if(comparedata_tmp<254) comparedata_tmp++; //     254 
										OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
								case 5: comparedata_tmp=OPRSECOND_DISCHARGE; //        2
										if(comparedata_tmp<254) comparedata_tmp++; //     254 
										OPRSECOND_DISCHARGE=comparedata_tmp; //      2
								}
					}
				break;
		case 5: switch(alter_cal.countermodecalibrate) //      Enter
					{
					case 0: switch(alter_cal.counterpositioncursor) //   
								{
								case 0: SYS_SwitchWorkmode(); //     
										break;
								case 1: indx_cal.calibrationvoltage=TRUE; //       1
								}
							break;
					case 1: switch(alter_cal.counterpositioncursor) //  
								{
								case 0: asm("nop"); // 
										break;
								case 1: indx_cal.calibrationvoltage=TRUE; //       2
								}
							break; 
					case 2 ... 5: switch(alter_cal.counterpositioncursor) //    
								{
								case 0: asm("nop"); // 
										break;
								case 1: indx_cal.calibrationcurrent=TRUE; //         
										break;
								case 2 ... 3: asm("nop"); // 
								}
					}
		}
	}

void CAL_SettnumberBattery(void) //   
	{
	switch(alter_cal.countermodecalibrate) //  
		{
		case 0: if(indx_cal.numberbattery==TRUE) indx_cal.numberbattery=FALSE; //     1
				break;
		case 1: if(indx_cal.numberbattery==FALSE) indx_cal.numberbattery=TRUE; //     2
				break;
		case 2: if(indx_cal.numberbattery==TRUE) indx_cal.numberbattery=FALSE; //     1
				break;
		case 3: if(indx_cal.numberbattery==FALSE) indx_cal.numberbattery=TRUE; //     2
				break;
		case 4: if(indx_cal.numberbattery==TRUE) indx_cal.numberbattery=FALSE; //     1
				break;
		case 5: if(indx_cal.numberbattery==FALSE) indx_cal.numberbattery=TRUE; //     2
		}
	indx_cal.updatecalibrateline=TRUE; //    
	}

void CAL_SettdefaultDivider(void) //     
	{
	switch(alter_cal.countermodecalibrate) //  
		{
		case 0 ... 1: ADC_DefaultDivider(indx_cal.numberbattery); //      
				break;
		case 2 ... 5: ADC_DefaultResistance(alter_cal.countermodecalibrate); //     
		}
	}


















