/********************************************
* Calibrationmode.h
*    
* : 08.06.2022 10:23:50
* :  .
*********************************************/

#pragma once

#include "Main.h"

#define CALIBRNMC_DIVIDER 2000 //      Ni-Cd  Ni-Mh  
#define CALIBRLPI_DIVIDER 4533 //      Li-Po  Li-Ion  
#define CALIBRLFE_DIVIDER 3767 //      Li-Fe  
#define CALIBRNMC_VOLTAGE 1500 //    Ni-Cd  Ni-Mh  
#define CALIBRLPI_VOLTAGE 4200 //    Li-Po  Li-Ion  
#define CALIBRLFE_VOLTAGE 3600 //    Li-Fe  
#define CALIBRMEAS_CURRENT 1250 //   
#define CALVALUE_RESISTOR 2000 //     0,2 
#define CALMIN_RESISTANCE 1800 //     0,18  
#define CALMAX_RESISTANCE 2200 //     0,22  
#define CALMINNMC_RANGE 1350 //     Ni-Cd  Ni-Mh  
#define CALMAXNMC_RANGE 1650 //     Ni-Cd  Ni-Mh  
#define CALMINLPI_RANGE 3780 //     Li-Po  Li-Ion  
#define CALMAXLPI_RANGE 4620 //     Li-Po  Li-Ion  
#define CALMINLFE_RANGE 3240 //     Li-Fe  
#define CALMAXLFE_RANGE 3960 //     Li-Fe  

typedef struct
	{
	bit updatecalibrateline:1; //   
	bit numberbattery:1; //     
	bit calibrationvoltage:1; //   
	bit calibrationcurrent:1; //   
	}bit_cal;

typedef struct
	{
	byte countermodecalibrate; //  
	byte counterpositioncursor; //  
	}var_cal;

void CAL_MainMode(bit indxupdateline_prm); //   
void CAL_CalibrmeasVoltage(byte numbersensor_prm,word measuredvaluesdata_prm); //   
void CAL_CalibrmeasCurrent(word measuredvaluesdata_prm); //   
void CAL_ControlCalibrate(byte datacodecontrol_prm); //   
void CAL_SettnumberBattery(void); //    
void CAL_SettdefaultDivider(void); //      











