/*******************************************************
* Lcdworkunit.c
*     LCD  WH1601L
* : 10.06.2022 10:54:01
* :  .
*******************************************************/

#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/sfr_defs.h>
#include "Lcdworkunit.h"
#include "Systemcontrol.h"

void LCD_CommonFunction(byte commondata_prm) //      LCD  4- 
	{
	byte outputdata_tmp=0; // 
	outputdata_tmp=LCD_SwapNibbles(commondata_prm); //      
	LCD_SetbyteData(outputdata_tmp); //      LCD
	_delay_loop_2(8); // 2 
	SetBit(LCD_STROBE,LCD_EN); //     LCD
	_delay_loop_2(20); // 5 
	ClearBit(LCD_STROBE,LCD_EN); // 
	outputdata_tmp=commondata_prm; //      
	LCD_SetbyteData(outputdata_tmp); //      LCD
	_delay_loop_2(8); // 2 
	SetBit(LCD_STROBE,LCD_EN); //     LCD
	_delay_loop_2(20); // 5 
	ClearBit(LCD_STROBE,LCD_EN); // 
	_delay_loop_2(200); // 50 
	}

void LCD_SetbyteData(byte outputdata_prm) //       LCD
	{
	byte settbytedata_tmp=0; // 
	settbytedata_tmp=outputdata_prm&1; //  PD0
	if((settbytedata_tmp>0)&&(bit_is_clear(PIND,PIND0))) SetBit(LCD_DATA,LCD_BYTE0); //  PD0  
	else if((settbytedata_tmp==0)&&(bit_is_set(PIND,PIND0))) ClearBit(LCD_DATA,LCD_BYTE0); //  PD0  
	settbytedata_tmp=outputdata_prm&2; //  PD1
	if((settbytedata_tmp>0)&&(bit_is_clear(PIND,PIND1))) SetBit(LCD_DATA,LCD_BYTE1); //  PD1  
	else if((settbytedata_tmp==0)&&(bit_is_set(PIND,PIND1))) ClearBit(LCD_DATA,LCD_BYTE1); //  PD1  
	settbytedata_tmp=outputdata_prm&4; //  PD2
	if((settbytedata_tmp>0)&&(bit_is_clear(PIND,PIND2))) SetBit(LCD_DATA,LCD_BYTE2); //  PD2  
	else if((settbytedata_tmp==0)&&(bit_is_set(PIND,PIND2))) ClearBit(LCD_DATA,LCD_BYTE2); //  PD2  
	settbytedata_tmp=outputdata_prm&8; //  PD3
	if((settbytedata_tmp>0)&&(bit_is_clear(PIND,PIND3))) SetBit(LCD_DATA,LCD_BYTE3); //  PD3  
	else if((settbytedata_tmp==0)&&(bit_is_set(PIND,PIND3))) ClearBit(LCD_DATA,LCD_BYTE3); //  PD3  
	}

void LCD_WaitDevice(void) //   LCD
	{
	byte numberdata_tmp=0; // 
	LCD_DIRECT&=240; //  4-    
	LCD_DATA|=15; //   
	SetBit(LCD_DATA,LCD_RW); //    LCD
	_delay_loop_2(8); // 2 
	ClearBit(LCD_DATA,LCD_RS); //    LCD
	do //   LCD
		{
		_delay_loop_2(8); // 2 
		SetBit(LCD_STROBE,LCD_EN);	//  
		_delay_loop_2(20); // 5 
		numberdata_tmp=PIND&15; //      LCD
		ClearBit(LCD_STROBE,LCD_EN); //  
		numberdata_tmp=LCD_SwapNibbles(numberdata_tmp); //   
		_delay_loop_2(8); // 2 
		SetBit(LCD_STROBE,LCD_EN); //  
		_delay_loop_2(20); // 5 
		numberdata_tmp|=PIND&15; //      LCD
		ClearBit(LCD_STROBE,LCD_EN); //  
		}
	while((numberdata_tmp&(1<<WAIT_FLAG))!=0); //   LCD 
	ClearBit(LCD_DATA,LCD_RW); //    LCD
	LCD_DIRECT|=15; //   
	_delay_loop_2(200); // 50 
	}

void LCD_WriteCommon(byte commondata_prm) //    LCD
	{
	LCD_WaitDevice(); //  LCD
	ClearBit(LCD_DATA,LCD_RS); //   
	_delay_loop_2(8); // 2 
	LCD_CommonFunction(commondata_prm); //   
	}

void LCD_WriteData(byte outputdata_prm) //     LCD
	{
	LCD_WaitDevice(); //  LCD
	SetBit(LCD_DATA,LCD_RS); //   
	_delay_loop_2(8); // 2 
	LCD_CommonFunction(outputdata_prm); //  
	}

void LCD_InitializeDevice(void) //  LCD
	{
	LCD_WaitingTime(60); // 60  
	LCD_WriteCommon(40); //  4-  
	_delay_loop_2(200); // 50 
	LCD_WriteCommon(12);  //   LCD,   
	_delay_loop_2(200); // 50 
	LCD_WriteCommon(1); // 
	LCD_WaitingTime(3); // 3 
	}

void LCD_SetpositionCursor(byte spotpositioncursor_prm) //   
	{
	byte cursorposity_tmp=0; // 
	if(spotpositioncursor_prm>7) cursorposity_tmp=spotpositioncursor_prm+56; //     8
	else cursorposity_tmp=spotpositioncursor_prm; //     8
	LCD_WriteCommon(128+cursorposity_tmp); //  
	LCD_WaitingTime(3); // 3 
	}

byte LCD_SwapNibbles(byte numberdata_prm) //     
	{
	asm volatile("swap %0":"=r"(numberdata_prm):"0"(numberdata_prm)); //   
	return numberdata_prm; //  
	}

void LCD_WaitingTime(word milliseconds_prm) //    
	{
	word milliseconds_tmp; // 
	milliseconds_tmp=milliseconds_prm; //  
	while(milliseconds_tmp>0) //   
		{
		_delay_loop_2(4000); // 1    
		milliseconds_tmp--; //  
		}
	}




