/***********************************************************
* Lifebattery.c
*     Li-Fe 
* : 17.06.2022 21:55:51
* :  .
************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Lifebattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

bit_lfe indx_lfe={0,0}; //  
var_lfe alter_lfe={{0,0},{0,0},{0,0},{0,0,0,0},{0,0,0,0}}; //  

PROGMEM const byte Lfe_DischargeBattery[2][4]={{1,0,64,0}, //  : I<=1 U>=2800  <40*
											{4,1,0,100}}; // : I=0,25C U>=2400   I<0.01C  10   
PROGMEM const byte Lfe_ChargeBattery[2][4]={{1,0,64,0}, //   1: I<=1C U<=3600  <40*C
											{4,1,0,100}}; // : I<=0,25C U<=3650   I<0,01C  10   

EEMEM static byte Lfe_CountcycleAlgorithm[2]={0,0}; //      
EEMEM static byte Lfe_CurrentStatusprocess[2]={0,0}; //      

word LFE_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //   Li-Fe 
	{
	word settingcurrentbattery_tmp=0; //  
	switch(indxnumberbattery_prm) //   
		{
		case FALSE: if(indx_lfe.updatingfirstdata==FALSE) //     1  
						{
						indx_lfe.updatingfirstdata=TRUE; //     
						LFE_DefiningParameters(FALSE,indxchargedischarge_prm,settcapacitybattery_prm); //     
						}
					settingcurrentbattery_tmp=LFE_DetermCurrentcontrol(FALSE,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //     / 
					break;
		case TRUE: if(indx_lfe.updatingseconddata==FALSE) //     2  
						{
						indx_lfe.updatingseconddata=TRUE; //     
						LFE_DefiningParameters(TRUE,indxchargedischarge_prm,settcapacitybattery_prm); //     
						}
					settingcurrentbattery_tmp=LFE_DetermCurrentcontrol(TRUE,indxchargedischarge_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //     / 
		}
	return settingcurrentbattery_tmp; //   
	}

void LFE_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm) //    Li-Fe  
	{
	switch(indxchargedischarge_prm) // / 
		{
		case FALSE: LFE_ChargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
					break;
		case TRUE: LFE_DischargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
		}
	}

word LFE_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //      
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxchargedischarge_prm) // /
		{
		case FALSE: settingcurrentbattery_tmp=LFE_ChargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //  
					break;
		case TRUE: settingcurrentbattery_tmp=LFE_DischargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredtemperature_prm); //  
		}
	return settingcurrentbattery_tmp; //    /
	}

void LFE_ResetVariables(bit indxnumberbattery_prm) //  
	{
	byte counterindxarray_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: while(counterindxarray_tmp<4) //     1 
						{
						alter_lfe.limitfirstparameters[counterindxarray_tmp]=0; //  
						counterindxarray_tmp++; //   
						}
					if(indx_lfe.updatingfirstdata==TRUE) indx_lfe.updatingfirstdata=FALSE; //      
					break;
		case TRUE: while(counterindxarray_tmp<4) //     2 
			{
			alter_lfe.limitsecondparameters[counterindxarray_tmp]=0; //  
			counterindxarray_tmp++; //   
			}
		if(indx_lfe.updatingseconddata==TRUE) indx_lfe.updatingseconddata=FALSE; //      
		}
	alter_lfe.countergeneralusage[indxnumberbattery_prm]=0; //    
	alter_lfe.countercyclesalgorithm[indxnumberbattery_prm]=0; //   / 
	alter_lfe.currentstatusprocess[indxnumberbattery_prm]=0; //   
	}

void LFE_WritelifeDeferred(bit indxnumberbattery_prm) //     Li-Fe 
	{
	eeprom_write_byte(&Lfe_CountcycleAlgorithm[indxnumberbattery_prm],alter_lfe.countercyclesalgorithm[indxnumberbattery_prm]); //     
	eeprom_write_byte(&Lfe_CurrentStatusprocess[indxnumberbattery_prm],alter_lfe.currentstatusprocess[indxnumberbattery_prm]); //    
	}

void LFE_ReadlifeDeferred(bit indxnumberbattery_prm) //     Li-Fe 
	{
	alter_lfe.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Lfe_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	alter_lfe.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Lfe_CurrentStatusprocess[indxnumberbattery_prm]); //    
	}

void LFE_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][0]); //   
					alter_lfe.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_lfe.limitfirstparameters[0]>LFEMAXLIMIT_CURRENT) alter_lfe.limitfirstparameters[0]=LFEMAXLIMIT_CURRENT; //     2500  
					algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][1]); //   
					if(algoritmdata_tmp==0) alter_lfe.limitfirstparameters[1]=LFEMAXBATT_VOLTAGE; //           3600  
					else alter_lfe.limitfirstparameters[1]=LFEMAXFINAL_VOLTAGE; //           3650  
					algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][2]); //   
					alter_lfe.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40* 
					algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][3]); //   
					if(algoritmdata_tmp>0) //      
						{
						alter_lfe.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   /
						if(alter_lfe.limitfirstparameters[3]<LFEMINLIMIT_CURRENT) alter_lfe.limitfirstparameters[3]=LFEMINLIMIT_CURRENT; //    10    
						}
					else alter_lfe.limitfirstparameters[3]=algoritmdata_tmp; //    
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][0]); //   
					alter_lfe.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_lfe.limitsecondparameters[0]>LFEMAXLIMIT_CURRENT) alter_lfe.limitsecondparameters[0]=LFEMAXLIMIT_CURRENT; //     2500  
					algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][1]); //    
					if(algoritmdata_tmp==0) alter_lfe.limitsecondparameters[1]=LFEMAXBATT_VOLTAGE; //           3600  
					else alter_lfe.limitsecondparameters[1]=LFEMAXFINAL_VOLTAGE; //           3650  
					algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][2]); //   
					alter_lfe.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40* 
					algoritmdata_tmp=pgm_read_byte(&Lfe_ChargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_lfe.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //   /
						if(alter_lfe.limitsecondparameters[3]<LFEMINLIMIT_CURRENT) alter_lfe.limitsecondparameters[3]=LFEMINLIMIT_CURRENT; //    10    
						}
					else alter_lfe.limitsecondparameters[3]=algoritmdata_tmp; //   
		}
	}

void LFE_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][0]); //   
					alter_lfe.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_lfe.limitfirstparameters[0]>LFEMAXLIMIT_CURRENT) alter_lfe.limitfirstparameters[0]=LFEMAXLIMIT_CURRENT; //     2500  
					algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][1]); //   
					if(algoritmdata_tmp==0) alter_lfe.limitfirstparameters[1]=LFEMINBATT_VOLTAGE; //           2800  
					else alter_lfe.limitfirstparameters[1]=LFEMINFINAL_VOLTAGE; //          2400  
					algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][2]); //    
					alter_lfe.limitfirstparameters[2]=(word)algoritmdata_tmp*10; //     40* 
					algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[FALSE]][3]); //   
					if(algoritmdata_tmp>0) //      
						{
						alter_lfe.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    /
						if(alter_lfe.limitfirstparameters[3]<LFEMINLIMIT_CURRENT) alter_lfe.limitfirstparameters[3]=LFEMINLIMIT_CURRENT; //    10    
						}
					else alter_lfe.limitfirstparameters[3]=algoritmdata_tmp; //  
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][0]); //   
					alter_lfe.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_lfe.limitsecondparameters[0]>LFEMAXLIMIT_CURRENT) alter_lfe.limitsecondparameters[0]=LFEMAXLIMIT_CURRENT; //     2500  
					algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][1]); //   
					if(algoritmdata_tmp>0) alter_lfe.limitsecondparameters[1]=LFEMINBATT_VOLTAGE; //           2800  
					else alter_lfe.limitsecondparameters[1]=LFEMINFINAL_VOLTAGE; //          2400  
					algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][2]); //   
					alter_lfe.limitsecondparameters[2]=(word)algoritmdata_tmp*10; //     40* 
					algoritmdata_tmp=pgm_read_byte(&Lfe_DischargeBattery[alter_lfe.countercyclesalgorithm[TRUE]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_lfe.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    /
						if(alter_lfe.limitsecondparameters[3]<LFEMINLIMIT_CURRENT) alter_lfe.limitsecondparameters[3]=LFEMINLIMIT_CURRENT; //    10    
						}
					else alter_lfe.limitsecondparameters[3]=algoritmdata_tmp; //  
		}
	}

word LFE_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_lfe.countercyclesalgorithm[FALSE]) //    1
						{
						case 0:	if(measuredtemperature_prm>=alter_lfe.limitfirstparameters[2]) limitcurrentparameters_tmp=alter_lfe.limitfirstparameters[0]/4; //   0,25    40*  
								else limitcurrentparameters_tmp=alter_lfe.limitfirstparameters[0]; //   1     40* 
								limitvoltageparameters_tmp=alter_lfe.limitfirstparameters[1]; //     3600  
								settingcurrentbattery_tmp=LFE_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[FALSE]!=2) alter_lfe.currentstatusprocess[FALSE]=2; // :   
								if(measuredvoltagebattery_prm>=alter_lfe.limitfirstparameters[1]) //   3600    
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //      
									alter_lfe.countercyclesalgorithm[FALSE]++; //      
									indx_lfe.updatingfirstdata=FALSE; //     
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<LFEMINFINAL_VOLTAGE)) //   5     1  2400 
									{
									settingcurrentbattery_tmp=0; //          
									alter_lfe.countercyclesalgorithm[FALSE]=0; //   
									alter_lfe.currentstatusprocess[FALSE]=9; // :   
									indx_lfe.updatingfirstdata=FALSE; //     
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lfe.limitfirstparameters[0]; //    0,25  
								limitvoltageparameters_tmp=alter_lfe.limitfirstparameters[1]; //     3650  
								settingcurrentbattery_tmp=LFE_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[FALSE]!=3) alter_lfe.currentstatusprocess[FALSE]=3; // : 
								if((measuredcurrentbattery_prm<=alter_lfe.limitfirstparameters[3])&&(measuredvoltagebattery_prm>=alter_lfe.limitfirstparameters[1])) //            3650  
									{
									settingcurrentbattery_tmp=0; //          1
									alter_lfe.countercyclesalgorithm[FALSE]=0; //   
									alter_lfe.currentstatusprocess[FALSE]=4; // :    
									indx_lfe.updatingfirstdata=FALSE; //     
									}
						}
					break;
		case TRUE: switch(alter_lfe.countercyclesalgorithm[TRUE]) //    2
						{
						case 0: if(measuredtemperature_prm>=alter_lfe.limitsecondparameters[2]) limitcurrentparameters_tmp=alter_lfe.limitsecondparameters[0]/4; //    0,25    40*  
								else limitcurrentparameters_tmp=alter_lfe.limitsecondparameters[0]; //    1     40*
								limitvoltageparameters_tmp=alter_lfe.limitsecondparameters[1]; //     3600 
								settingcurrentbattery_tmp=LFE_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[TRUE]!=2) alter_lfe.currentstatusprocess[TRUE]=2; // :  
								if(measuredvoltagebattery_prm>=alter_lfe.limitsecondparameters[1]) //   3600    
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //      
									alter_lfe.countercyclesalgorithm[TRUE]++; //      
									indx_lfe.updatingseconddata=FALSE; //     
									}
								else if((measuredchargebattery_prm>4)&&(measuredvoltagebattery_prm<LFEMINFINAL_VOLTAGE)) //   5      2400 
									{
									settingcurrentbattery_tmp=0; //          2
									alter_lfe.countercyclesalgorithm[TRUE]=0; //   
									alter_lfe.currentstatusprocess[TRUE]=9; // :   
									indx_lfe.updatingseconddata=FALSE; //     
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lfe.limitsecondparameters[0]; //    0,25 
								limitvoltageparameters_tmp=alter_lfe.limitsecondparameters[1]; //     4200  
								settingcurrentbattery_tmp=LFE_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[TRUE]!=3) alter_lfe.currentstatusprocess[TRUE]=3; // : 
								if((measuredcurrentbattery_prm<=alter_lfe.limitsecondparameters[3])&&(measuredvoltagebattery_prm>=alter_lfe.limitsecondparameters[1])) //            3650 
									{
									settingcurrentbattery_tmp=0; //          2
									alter_lfe.countercyclesalgorithm[TRUE]=0; //   
									alter_lfe.currentstatusprocess[TRUE]=4; // :   
									indx_lfe.updatingseconddata=FALSE; //     
									}
						}
		}
	return settingcurrentbattery_tmp; //     
	}

word LFE_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0;
	word limitvoltageparameters_tmp=0;
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_lfe.countercyclesalgorithm[FALSE]) //    1
						{
						case 0: if(measuredtemperature_prm>=alter_lfe.limitfirstparameters[2]) limitcurrentparameters_tmp=alter_lfe.limitfirstparameters[0]/4; //    0,25    40*  
								else limitcurrentparameters_tmp=alter_lfe.limitfirstparameters[0]; //    1     40*
								limitvoltageparameters_tmp=alter_lfe.limitfirstparameters[1]; //       2800  
								settingcurrentbattery_tmp=LFE_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[FALSE]!=6) alter_lfe.currentstatusprocess[FALSE]=6; // :  
								if(measuredvoltagebattery_prm<=alter_lfe.limitfirstparameters[1]) //      2800 
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_lfe.countercyclesalgorithm[FALSE]++; //      
									indx_lfe.updatingfirstdata=FALSE; //     
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lfe.limitfirstparameters[0]; //    0,25 
								limitvoltageparameters_tmp=alter_lfe.limitfirstparameters[1]; //      2400  
								settingcurrentbattery_tmp=LFE_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[FALSE]!=7) alter_lfe.currentstatusprocess[FALSE]=7; // : 
								if((measuredcurrentbattery_prm<=alter_lfe.limitfirstparameters[3])&&(measuredvoltagebattery_prm<=alter_lfe.limitfirstparameters[1])) //            2400 
									{
									settingcurrentbattery_tmp=0; //          1
									alter_lfe.countercyclesalgorithm[FALSE]=0; //   
									alter_lfe.currentstatusprocess[FALSE]=8; // :   
									indx_lfe.updatingfirstdata=FALSE; //     
									}
						}
					break;
		case TRUE: switch(alter_lfe.countercyclesalgorithm[TRUE]) //    2
						{
						case 0: if(measuredtemperature_prm>=alter_lfe.limitsecondparameters[2]) limitcurrentparameters_tmp=alter_lfe.limitsecondparameters[0]/4; //    0,25    2 40*  
								else limitcurrentparameters_tmp=alter_lfe.limitsecondparameters[0]; //    1    2  40*
								limitvoltageparameters_tmp=alter_lfe.limitsecondparameters[1]; //      2800   2
								settingcurrentbattery_tmp=LFE_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[TRUE]!=6) alter_lfe.currentstatusprocess[TRUE]=6; // :  
								if(measuredvoltagebattery_prm<=alter_lfe.limitsecondparameters[1]) //   2    2800 
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_lfe.countercyclesalgorithm[TRUE]++; //      
									indx_lfe.updatingseconddata=FALSE; //     
									}
								break;
						case 1: limitcurrentparameters_tmp=alter_lfe.limitsecondparameters[0]; //    0,25 
								limitvoltageparameters_tmp=alter_lfe.limitsecondparameters[1]; //      2400  
								settingcurrentbattery_tmp=LFE_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_prm,limitcurrentparameters_tmp,limitvoltageparameters_tmp,measuredvoltagebattery_prm,measvoltageloadedbattery_prm); //  
								if(alter_lfe.currentstatusprocess[TRUE]!=7) alter_lfe.currentstatusprocess[TRUE]=7; // : 
								if((measuredcurrentbattery_prm<=alter_lfe.limitsecondparameters[3])&&(measuredvoltagebattery_prm<=alter_lfe.limitsecondparameters[1])) //            2400 
									{
									settingcurrentbattery_tmp=0; //          2
									alter_lfe.countercyclesalgorithm[TRUE]=0; //   
									alter_lfe.currentstatusprocess[TRUE]=8; // :   
									indx_lfe.updatingseconddata=FALSE; //     
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word LFE_ChargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	word settingcurrentbattery_tmp=0; // 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm<LFEMAXLOAD_VOLTAGE)) settingcurrentbattery_tmp++; //             
	else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm>limitvoltageparameters_prm)||(measvoltageloadedbattery_prm>=LFEMAXLOAD_VOLTAGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //             
	else asm("nop"); //  
	return settingcurrentbattery_tmp; //    
	}

word LFE_DischargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm) //   
	{
	word settingcurrentbattery_tmp=0; // 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	if((measuredcurrentbattery_prm<limitcurrentparameters_prm)&&(measuredvoltagebattery_prm>limitvoltageparameters_prm)&&(measvoltageloadedbattery_prm>LFEMINLOAD_VOLTAGE)) settingcurrentbattery_tmp++; //             
	else
		{
		if((limitvoltageparameters_prm==LFEMINFINAL_VOLTAGE)&&(measuredvoltagebattery_prm<limitvoltageparameters_prm)&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp/=2; //        2400 
		else if(((measuredcurrentbattery_prm>limitcurrentparameters_prm)||(measuredvoltagebattery_prm<limitvoltageparameters_prm)||(measvoltageloadedbattery_prm<=LFEMINLOAD_VOLTAGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //              
		else asm("nop"); //  
		}
	return settingcurrentbattery_tmp; //   
	}

byte LFE_ReadcurrentStatus(bit indxnumberbattery_prm) //   
	{
	byte currentstatusprocess_tmp=0; // 
	currentstatusprocess_tmp=alter_lfe.currentstatusprocess[indxnumberbattery_prm]; //    
	return currentstatusprocess_tmp; //   
	}



















