/**************************************************************
* Lifebattery.h
*     Li-Fe 
* : 17.06.2022 21:54:38
* :  .
***************************************************************/

#pragma once

#include "Main.h"

#define LFEMINBATT_VOLTAGE 2800 //        
#define LFEMINFINAL_VOLTAGE 2400 //      
#define LFEMAXBATT_VOLTAGE 3600 //        
#define LFEMAXFINAL_VOLTAGE 3650 //      
#define LFEMINLOAD_VOLTAGE 2300 //   
#define LFEMAXLOAD_VOLTAGE 3750 //   
#define LFEMAXLIMIT_CURRENT 2500 //   / 
#define LFEMINLIMIT_CURRENT 10 //   / 

typedef struct
	{
	bit updatingfirstdata:1; //      1 
	bit updatingseconddata:1; //      2 
	}bit_lfe;

typedef struct
	{
	byte countergeneralusage[2]; //   
	byte countercyclesalgorithm[2]; //    / 
	byte currentstatusprocess[2]; //     1[0]  2[1]
	word limitfirstparameters[4]; //   ,     1 
	word limitsecondparameters[4]; //   ,     2 
	}var_lfe;

void LFE_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm); //   
void LFE_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LFE_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LFE_ResetVariables(bit indxnumberbattery_prm); //  
void LFE_WritelifeDeferred(bit indxnumberbattery_prm); //     Li-Fe 
void LFE_ReadlifeDeferred(bit indxnumberbattery_prm); //     Li-Fe 
byte LFE_ReadcurrentStatus(bit indxnumberbattery_prm); //   
word LFE_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //    
word LFE_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //     
word LFE_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word LFE_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word LFE_ChargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LFE_DischargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   

















