/************************************************************************
* Lionlipobattery.h
*     Li-Ion  Li-Po 
* : 16.06.2022 19:28:08
* :  .
*************************************************************************/

#pragma once

#include "Main.h"

#define LPIMINBATT_VOLTAGE 3000 //    
#define LPIMAXBATT_VOLTAGE 4190 //      0,5 
#define LPIMINLOAD_VOLTAGE 2800 //    
#define LPIMAXLOAD_VOLTAGE 4300 //    
#define LPIMAXLIMIT_CURRENT 2500 //   / 
#define LPIMINLIMIT_CURRENT 10 //   / 

typedef struct
	{
	bit updatingfirstdata:1; //     1 
	bit updatingseconddata:1; //     2 
	}bit_lpi;

typedef struct
	{
	byte countergeneralusage[2]; //   
	byte countercyclesalgorithm[2]; //   / 
	byte currentstatusprocess[2]; //    1[0]  2[1]
	word limitfirstparameters[4]; //   ,     1
	word limitsecondparameters[4]; //   ,     2
	}var_lpi;

void LPI_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm); //   
void LPI_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LPI_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //   
void LPI_ResetVariables(bit indxnumberbattery_prm); //   
void LPI_WritelipoDeferred(bit indxnumberbattery_prm); //     Li-Po 
void LPI_ReadlipoDeferred(bit indxnumberbattery_prm); //     Li-Po 
void LPI_WritelionDeferred(bit indxnumberbattery_prm); //     Li-Ion 
void LPI_ReadlionDeferred(bit indxnumberbattery_prm); //     Li-Ion 
byte LPI_ReadcurrentStatus(bit indxnumberbattery_prm); //   
word LPI_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //     
word LPI_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //     
word LPI_ChargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word maximumoverheating_prm); //  
word LPI_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word maximumoverheating_prm); //  
word LPI_ChargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   
word LPI_DischargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitcurrentparameters_prm,word limitvoltageparameters_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm); //   











	
	