/*********************************************
 * Marksensors.c
 *     DS18B20
 * : 02.06.2022 18:24:47
 *  :  .
 **********************************/

 // 
 #include <avr/io.h>
 #include "Marksensors.h"
 #include "Main.h"
 #include "Systemcontrol.h"
 #include "Symbolout.h"
 #include "Keybuttscan.h"
 #include "Owids18b20.h"

 bit_msn indx_msn={0,0,0,0}; // 
 var_msn alter_msn={0,0,0,0}; // 
 byte buffermemramdata[3]={0,0,0}; //    

void MSN_MainMode(bit indxupdateline_prm) //     
	{
	byte spotpositioncursor_tmp=0; // 
	byte datacodecontrol_tmp=0;
	if(indxupdateline_prm==TRUE) indx_msn.updateworkline=TRUE; //         
	datacodecontrol_tmp=KEY_DecoderButton(); //  
	if(datacodecontrol_tmp>0) MSN_ControlMarksensor(datacodecontrol_tmp); //    
	switch(alter_msn.counterpositioncursor) //  
		{
		case 0: spotpositioncursor_tmp=0; //     
				break;
		case 1: spotpositioncursor_tmp=6; //   
				break;
		case 2: spotpositioncursor_tmp=11; //      
				break;
		case 3: spotpositioncursor_tmp=12; //     
		}
	switch(alter_msn.counterworkmode) //   
		{
		case 0: if(indx_msn.updateworkline==TRUE) //    
					{
					SYM_LineOut(6,0,FALSE,FALSE,0); //      
					indx_msn.updateworkline=FALSE; //    
					}
				if(indx_msn.outmarkingsensor==TRUE) SYM_OutdataNumber00(buffermemramdata[0],12); //      
				MSN_SearchTestsensor(); //   
				break;
		case 1: if(indx_msn.updateworkline==TRUE) //    
					{
					SYM_LineOut(7,0,FALSE,FALSE,0); //    
					indx_msn.updateworkline=FALSE; //    
					}
				if(indx_msn.outmarkingsensor==TRUE) SYM_OutdataNumber00(buffermemramdata[0],13); //      
				MSN_ReadmarkSensor(); //  
				break;
		case 2: if(indx_msn.updateworkline==TRUE) //    
					{
					SYM_LineOut(8,0,FALSE,FALSE,0); //    
					indx_msn.updateworkline=FALSE; //    
					}
				SYM_OutdataNumber00(alter_msn.countermarksensor,11); //    
				if(indx_msn.outmarkingsensor==TRUE) SYM_OutdataNumber00(buffermemramdata[0],14); //      
				MSN_MarkingSensors(); // 
		}
	SYM_CursorPosition(spotpositioncursor_tmp); //   
	SYS_TimeWaiting(300); // 300  
	}

void MSN_ControlMarksensor(byte datacodecontrol_prm) //    
	{
	switch(datacodecontrol_prm) //  
		{
		case 1: switch(alter_msn.counterworkmode) //   Left
					{
					case 0 ... 1: switch(alter_msn.counterpositioncursor) //  
									{
									case 0: alter_msn.counterpositioncursor=1; //     
											break;
									case 1: alter_msn.counterpositioncursor=0; //   
									}
							break;
					case 2: if(alter_msn.counterpositioncursor>0) alter_msn.counterpositioncursor--; //     
							else alter_msn.counterpositioncursor=3; //      
							
					}
				if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
				break;
		case 2: switch(alter_msn.counterworkmode) //   Rigt
					{
					case 0 ... 1: switch(alter_msn.counterpositioncursor) //  
									{
									case 0: alter_msn.counterpositioncursor=1; //     
											break;
									case 1: alter_msn.counterpositioncursor=0; //   
									}
							break;
					case 2: alter_msn.counterpositioncursor++; //  
							if(alter_msn.counterpositioncursor>3) alter_msn.counterpositioncursor=0; //      
					}
				if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
				break;
		case 3: switch(alter_msn.counterpositioncursor) //   Up
					{
					case 0: alter_msn.counterworkmode++; //   
							if(alter_msn.counterworkmode>2) alter_msn.counterworkmode=0; //    
							break;
					case 1: asm("nop"); // 
							break;
					case 2: if(alter_msn.countermarksensor<90) alter_msn.countermarksensor+=10; //    10   90
							else asm("nop"); // 
							break;
					case 3: if(alter_msn.countermarksensor<99) alter_msn.countermarksensor++; //     99
							else asm("nop"); // 
					}
				indx_msn.updateworkline=TRUE; //    
				if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
				break;
		case 4: switch(alter_msn.counterpositioncursor) //   Down
					{
					case 0: if(alter_msn.counterworkmode>0) alter_msn.counterworkmode--; //    
							else alter_msn.counterworkmode=2; //      
							break;
					case 1: asm("nop"); // 
							break;
					case 2: if(alter_msn.countermarksensor>9) alter_msn.countermarksensor-=10; //    10   9
							else asm("nop"); // 
							break;
					case 3: if(alter_msn.countermarksensor>0) alter_msn.countermarksensor--; //     
							else asm("nop"); // 
					}
				indx_msn.updateworkline=TRUE; //    
				if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
				break;
		case 5: switch(alter_msn.counterpositioncursor) //    
					{
					case 0: switch(alter_msn.counterworkmode) //  
								{
								case 0: SYS_SwitchWorkmode(); //    
										break;
								case 1 ... 2: asm("nop"); // 
								}
							break;
					case 1: if(indx_msn.startworkcycle==FALSE) indx_msn.startworkcycle=TRUE; //   Enter    
							if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
					case 2 ... 3: asm("nop"); // 
					}
				
		}
	}

void MSN_SearchTestsensor(void) //    
	{
	if(indx_msn.startworkcycle==TRUE) //       
		{
		if(indx_msn.readerrorsensor==TRUE) indx_msn.readerrorsensor=FALSE; //  
		if(OWI_DetectPresence()==0) //  
			{
			OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
			if(OWI_ReadramSensor()==TRUE) //      
				{
				MSN_ReadwriteBuffer(FALSE); //    
				alter_msn.counterdatatested++; //    
				if(alter_msn.counterdatatested==11) //    10
					{
					indx_msn.startworkcycle=FALSE; //     
					alter_msn.counterdatatested=0; //     
					}
				buffermemramdata[0]=alter_msn.counterdatatested; //     
				buffermemramdata[1]=alter_msn.counterdatatested;
				OWI_DetectPresence(); // 
				OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
				OWI_TransferByte(OWIORDER_WRITESCR); //      
				MSN_ReadwriteBuffer(TRUE); //    3-     
				OWI_DetectPresence(); // 
				OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
				OWI_TransferByte(OWIORDER_COPYSCR); //   3-      eeprom 
				OWI_DetectPresence(); // 
				OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
				OWI_TransferRecall(); //   eeprom   
				indx_msn.updateworkline=TRUE; //    
				indx_msn.outmarkingsensor=TRUE; //    
				}
			else indx_msn.readerrorsensor=TRUE; //      
			}
		else indx_msn.readerrorsensor=TRUE; //      
		if(indx_msn.readerrorsensor==TRUE) //   
			{
			indx_msn.startworkcycle=FALSE; //     
			indx_msn.updateworkline=TRUE; //    
			if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
			}
		}
	}

void MSN_ReadmarkSensor(void) //   
	{
	if(indx_msn.startworkcycle==TRUE) //     
		{
		if(indx_msn.readerrorsensor==TRUE) indx_msn.readerrorsensor=FALSE; //  
		if(OWI_DetectPresence()==0) //  
			{
			OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
			OWI_TransferRecall(); //   eeprom   
			OWI_DetectPresence(); // 
			OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
			if(OWI_ReadramSensor()==TRUE) //     
				{
				MSN_ReadwriteBuffer(FALSE); //      
				indx_msn.updateworkline=TRUE; //    
				if(indx_msn.outmarkingsensor==FALSE) indx_msn.outmarkingsensor=TRUE; //    
				indx_msn.startworkcycle=FALSE; //     
				}
			else indx_msn.readerrorsensor=TRUE; //      
			}
		else indx_msn.readerrorsensor=TRUE; //      
		if(indx_msn.readerrorsensor==TRUE) //   
			{
			indx_msn.startworkcycle=FALSE; //     
			indx_msn.updateworkline=TRUE; //    
			if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
			}
		}
	}

void MSN_MarkingSensors(void) //  
	{
	if(indx_msn.startworkcycle==TRUE) //     
		{
		if(indx_msn.readerrorsensor==TRUE) indx_msn.readerrorsensor=FALSE; //  
		if(OWI_DetectPresence()==0) //   
			{
			OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
			if(OWI_ReadramSensor()==TRUE) //     
				{
				MSN_ReadwriteBuffer(FALSE); //      
				buffermemramdata[0]=alter_msn.countermarksensor; //      
				buffermemramdata[1]=alter_msn.countermarksensor; //      
				OWI_DetectPresence(); // 
				OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
				OWI_TransferByte(OWIORDER_WRITESCR); //      
				MSN_ReadwriteBuffer(TRUE); //    3-     
				OWI_DetectPresence(); // 
				OWI_TransferByte(OWIORDER_ROMSKIP); //    ROM
				OWI_TransferByte(OWIORDER_COPYSCR); //     eeprom 
				OWI_DetectPresence(); // 
				if(OWI_ReceiveIdentifi()==TRUE) //      
					{
					OWI_ConservIdentifi(alter_msn.countermarksensor); //   eeprom 
					OWI_DetectPresence(); // 
					OWI_TransferIdentifi(alter_msn.countermarksensor); //  
					OWI_TransferRecall(); //     eeprom   
					OWI_DetectPresence(); // 
					OWI_TransferIdentifi(alter_msn.countermarksensor); //  
					if(OWI_ReadramSensor()==TRUE) //      
						{
						buffermemramdata[0]=OWI_ReadbyteBuffer(2); //   Th  
						buffermemramdata[1]=OWI_ReadbyteBuffer(3); //   Tl  
						if((buffermemramdata[0]==alter_msn.countermarksensor)&&(buffermemramdata[1]==alter_msn.countermarksensor)) //  
							{
							if(alter_msn.counterpositioncursor==1) alter_msn.countermarksensor++; //       
							if(indx_msn.outmarkingsensor==FALSE) indx_msn.outmarkingsensor=TRUE; //    
							indx_msn.updateworkline=TRUE; //    
							indx_msn.startworkcycle=FALSE; //     
							}
						else indx_msn.readerrorsensor=TRUE; //      
						}
					else indx_msn.readerrorsensor=TRUE; //      
					}
				else indx_msn.readerrorsensor=TRUE; //       
				}
			else indx_msn.readerrorsensor=TRUE; //      
			}
		else indx_msn.readerrorsensor=TRUE; //      
		if(indx_msn.readerrorsensor==TRUE) //   
			{
			if(indx_msn.startworkcycle==TRUE) indx_msn.startworkcycle=FALSE; //      
			indx_msn.updateworkline=TRUE; //    
			if(indx_msn.outmarkingsensor==TRUE) indx_msn.outmarkingsensor=FALSE; //     
			}
		}
	else asm("nop"); // 
	}

void MSN_ReadwriteBuffer(bit indxreadwritebuffer_prm) //     
	{
	switch(indxreadwritebuffer_prm) // /  
		{
		case FALSE: buffermemramdata[0]=OWI_ReadbyteBuffer(2); //   Th 
					buffermemramdata[1]=OWI_ReadbyteBuffer(3); //   Tl 
					buffermemramdata[2]=OWI_ReadbyteBuffer(4); //    
					break;
		case TRUE: OWI_TransferByte(buffermemramdata[0]); //  Th 
					OWI_TransferByte(buffermemramdata[1]); //  Tl 
					OWI_TransferByte(buffermemramdata[2]); //   
		}
	}












	 