/*******************************************************************
* Nimhnicdbattery.c
*     Ni-Mh  Ni-Cd 
* : 15.06.2022 19:32:56
* :  .
********************************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include "Main.h"
#include "Nimhnicdbattery.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"

bit_nmc indx_nmc={0,0}; //  
var_nmc alter_nmc={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0,0,0,0},{0,0,0,0,0}}; //  
	
PROGMEM const byte Nmc_DischargeBattery[3][4]={{4,105,1,0}, //  1: I<=0,25 U>=1050   0,01(1%)  U<1050 
											{2,105,0,0}, //   2: I<=0,5C U>=1050   U<1050 
											{5,80,0,100}}; //   3: I=0,2C U>=800   U<800   I<0.01C
PROGMEM const byte Nmc_ChargeBattery[3][4]={{10,100,1,0}, //  1: I<=0,1C U>1000   0,0033(0,33%)   0,01C(1%) 
											{1,0,105,40}, //   2: I<=1C  */>1000, /=0  >0,8C  >40*C  >1,05C 
											{10,0,0,0}}; //  3:  5  I<=0,1C 

EEMEM static byte Nmh_CountcycleAlgorithm[2]={0,0}; //      Ni-Mh  
EEMEM static byte Nmh_CurrentStatusprocess[2]={0,0}; //      Ni-Mh  
EEMEM static word Nmh_LimitsParameters[2]={0,0}; //     Ni-Mh  
EEMEM static byte Ncd_CountcycleAlgorithm[2]={0,0}; //      Ni-Cd 
EEMEM static byte Ncd_CurrentStatusprocess[2]={0,0}; //      Ni-Cd 
EEMEM static word Ncd_LimitsParameters[2]={0,0}; //     Ni-Cd 

word NMC_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //    Ni-Mh 
	{
	word settingcurrentbattery_tmp=0; //  
	switch(indxnumberbattery_prm) //   
		{
		case FALSE: if(indx_nmc.updatingfirstdata==FALSE) //     1  
						{
						indx_nmc.updatingfirstdata=TRUE; //     
						NMC_DefiningParameters(FALSE,indxchargedischarge_prm,settcapacitybattery_prm); //    
						}
					settingcurrentbattery_tmp=NMC_DetermCurrentcontrol(FALSE,indxchargedischarge_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      1 
					break;
		case TRUE: if(indx_nmc.updatingseconddata==FALSE) //     2  
						{
						indx_nmc.updatingseconddata=TRUE; //     
						NMC_DefiningParameters(TRUE,indxchargedischarge_prm,settcapacitybattery_prm); //    
						}
					settingcurrentbattery_tmp=NMC_DetermCurrentcontrol(TRUE,indxchargedischarge_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //      2 
		}
	return settingcurrentbattery_tmp; //     
	}

void NMC_IncreaseParameters(bit indxnumberbattery_prm,word measuredvoltagebattery_prm,word measuredtemperature_prm) //       
	{
	dword oneratechangedata_tmp=0; //  
	dword tworatechangedata_tmp=0; 
	if(measuredtemperature_prm>alter_nmc.previoustemperature[indxnumberbattery_prm]) //     
		{
		if(alter_nmc.previoustemperature[indxnumberbattery_prm]==0) alter_nmc.previoustemperature[indxnumberbattery_prm]=measuredtemperature_prm; //   
		oneratechangedata_tmp=(dword)measuredtemperature_prm*625; //     
		tworatechangedata_tmp=(dword)alter_nmc.previoustemperature[indxnumberbattery_prm]*625; //     
		oneratechangedata_tmp-=tworatechangedata_tmp; //      
		tworatechangedata_tmp=60*oneratechangedata_tmp/88; //     / 
		alter_nmc.increasetemperature[indxnumberbattery_prm]=(word)tworatechangedata_tmp; //      
		if(alter_nmc.increasetemperature[indxnumberbattery_prm]>alter_nmc.maximumtemperature[indxnumberbattery_prm]) alter_nmc.maximumtemperature[indxnumberbattery_prm]=alter_nmc.increasetemperature[indxnumberbattery_prm]; //     
		alter_nmc.previoustemperature[indxnumberbattery_prm]=measuredtemperature_prm; //    
		}
	if(measuredvoltagebattery_prm>alter_nmc.previousvoltagebattery[indxnumberbattery_prm]) //      
		{
		oneratechangedata_tmp=600*((dword)measuredvoltagebattery_prm-(dword)alter_nmc.previousvoltagebattery[indxnumberbattery_prm])/88; //     / 
		alter_nmc.increaseratevoltage[indxnumberbattery_prm]=(word)oneratechangedata_tmp; //      
		alter_nmc.previousvoltagebattery[indxnumberbattery_prm]=measuredvoltagebattery_prm; //    
		}
	else alter_nmc.increaseratevoltage[indxnumberbattery_prm]=0; //             
	}

bit NMC_DetectionDerivative(bit indxnumberbattery_prm) //          
	{
	bit indxdetectiondelta_tmp=FALSE; //  
	if(alter_nmc.increaseratevoltage[indxnumberbattery_prm]==0) alter_nmc.counterdeltadetected[indxnumberbattery_prm]++; //         
	else if((alter_nmc.increaseratevoltage[indxnumberbattery_prm]>0)&&(alter_nmc.counterdeltadetected[indxnumberbattery_prm]>0)) alter_nmc.counterdeltadetected[indxnumberbattery_prm]=0; //             
	if((alter_nmc.maximumtemperature[indxnumberbattery_prm]>800)&&(alter_nmc.counterdeltadetected[indxnumberbattery_prm]>=15)) indxdetectiondelta_tmp=TRUE; //    2-            0,8*/ 
	return indxdetectiondelta_tmp; //   
	}

void NMC_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm) //    Ni-Mh  
	{
	switch(indxchargedischarge_prm) //  / 
		{
		case FALSE: NMC_ChargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //   
					break;
		case TRUE: NMC_DischargeParameters(indxnumberbattery_prm,settcapacitybattery_prm); //  
		}
	}

word NMC_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //     
	{
	word settingcurrentbattery_tmp=0; // 
	switch(indxchargedischarge_prm) // / 
		{
		case FALSE: NMC_IncreaseParameters(indxnumberbattery_prm,measuredvoltagebattery_prm,measuredtemperature_prm); //       1 
					settingcurrentbattery_tmp=NMC_ChargeController(indxnumberbattery_prm,indxonlycharging_prm,measuredcurrentbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredtemperature_prm); //  
					break;
		case TRUE: settingcurrentbattery_tmp=NMC_DischargeController(indxnumberbattery_prm,measuredcurrentbattery_prm,measuredvoltagebattery_prm,measvoltageloadedbattery_prm,measuredchargebattery_prm,settingcurrentbattery_prm,measuredtemperature_prm); //  
		}
	return settingcurrentbattery_tmp; //    / 
	}

void NMC_ResetVariables(bit indxnumberbattery_prm) //   
	{
	byte counterindxarray_tmp=0; // 
	switch(indxnumberbattery_prm) //   
		{
		case FALSE: while(counterindxarray_tmp<5) //    
						{
						alter_nmc.limitfirstparameters[counterindxarray_tmp]=0; //   
						counterindxarray_tmp++; //    
						}
					if(indx_nmc.updatingfirstdata==TRUE) indx_nmc.updatingfirstdata=FALSE; //       
					break;
		case TRUE: while(counterindxarray_tmp<5) //    
						{
						alter_nmc.limitsecondparameters[counterindxarray_tmp]=0; //   
						counterindxarray_tmp++; //    
						}
					if(indx_nmc.updatingseconddata==TRUE) indx_nmc.updatingseconddata=FALSE; //       
		}
	alter_nmc.countergeneralusage[indxnumberbattery_prm]=0; //    
	alter_nmc.counterdeltadetected[indxnumberbattery_prm]=0; //     
	alter_nmc.countercyclesalgorithm[indxnumberbattery_prm]=0; //   /  
	alter_nmc.currentstatusprocess[indxnumberbattery_prm]=0; //  
	alter_nmc.previousvoltagebattery[indxnumberbattery_prm]=0; //    
	alter_nmc.previoustemperature[indxnumberbattery_prm]=0; //    
	alter_nmc.increaseratevoltage[indxnumberbattery_prm]=0; //     
	alter_nmc.increasetemperature[indxnumberbattery_prm]=0; //     
	}

void NMC_WritenimhDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Mh 
	{
	eeprom_write_byte(&Nmh_CountcycleAlgorithm[indxnumberbattery_prm],alter_nmc.countercyclesalgorithm[indxnumberbattery_prm]); //      
	eeprom_write_byte(&Nmh_CurrentStatusprocess[indxnumberbattery_prm],alter_nmc.currentstatusprocess[indxnumberbattery_prm]); //     
	if(indxchargedischarge_prm==FALSE) //     
		{
		switch(indxnumberbattery_prm) //   
			{
			case FALSE: eeprom_write_word(&Nmh_LimitsParameters[FALSE],alter_nmc.limitfirstparameters[4]); //       1 
						break;
			case TRUE: eeprom_write_word(&Nmh_LimitsParameters[TRUE],alter_nmc.limitsecondparameters[4]); //       2 
			}
		}
	}

void NMC_WritenicdDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Cd 
	{
	eeprom_write_byte(&Ncd_CountcycleAlgorithm[indxnumberbattery_prm],alter_nmc.countercyclesalgorithm[indxnumberbattery_prm]); //     
	eeprom_write_byte(&Ncd_CurrentStatusprocess[indxnumberbattery_prm],alter_nmc.currentstatusprocess[indxnumberbattery_prm]); //    
	if(indxchargedischarge_prm==FALSE) //     
		{
		switch(indxnumberbattery_prm) //   
			{
			case FALSE: eeprom_write_word(&Ncd_LimitsParameters[FALSE],alter_nmc.limitfirstparameters[4]); //       1
						break;
			case TRUE: eeprom_write_word(&Ncd_LimitsParameters[TRUE],alter_nmc.limitsecondparameters[4]); //       2
			}
		}
	}

void NMC_ReadnimhDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Mh 
	{
	alter_nmc.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Nmh_CountcycleAlgorithm[indxnumberbattery_prm]); //       
	alter_nmc.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Nmh_CurrentStatusprocess[indxnumberbattery_prm]); //     
	if(indxchargedischarge_prm==FALSE) //    
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: alter_nmc.limitfirstparameters[4]=eeprom_read_word(&Nmh_LimitsParameters[FALSE]); //       1 
						break;
			case TRUE: alter_nmc.limitsecondparameters[4]=eeprom_read_word(&Nmh_LimitsParameters[TRUE]); //       2 
			}
		}
	}

void NMC_ReadnicdDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm) //     Ni-Cd 
	{
	alter_nmc.countercyclesalgorithm[indxnumberbattery_prm]=eeprom_read_byte(&Ncd_CountcycleAlgorithm[indxnumberbattery_prm]); //     
	alter_nmc.currentstatusprocess[indxnumberbattery_prm]=eeprom_read_byte(&Ncd_CurrentStatusprocess[indxnumberbattery_prm]); //    
	if(indxchargedischarge_prm==FALSE) //     
		{
		switch(indxnumberbattery_prm) //  
			{
			case FALSE: alter_nmc.limitfirstparameters[4]=eeprom_read_word(&Ncd_LimitsParameters[FALSE]); //       1
						break;
			case TRUE: alter_nmc.limitsecondparameters[4]=eeprom_read_word(&Ncd_LimitsParameters[TRUE]); //       2
			}
		}
	}

void NMC_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //    
	{
	byte algoritmdata_tmp=0; // 
	dword chargedischargedata_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][0]); //   
					alter_nmc.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_nmc.limitfirstparameters[0]>NMCMAX_CURRENT) alter_nmc.limitfirstparameters[0]=NMCMAX_CURRENT; //     1 
					algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][1]); //   
					if(algoritmdata_tmp>0) alter_nmc.limitfirstparameters[1]=(word)algoritmdata_tmp*10; //     1      
					else alter_nmc.limitfirstparameters[1]=algoritmdata_tmp; //   
					algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][2]); //    
					chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      1
					alter_nmc.limitfirstparameters[2]=(word)chargedischargedata_tmp; //     
					algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][3]); //   
					if(algoritmdata_tmp>0) //      
						{
						chargedischargedata_tmp=(dword)algoritmdata_tmp*10000/625; //       
						alter_nmc.limitfirstparameters[3]=(word)chargedischargedata_tmp; //    
						}
					else alter_nmc.limitfirstparameters[3]=algoritmdata_tmp; //    
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][0]); //   
					alter_nmc.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_nmc.limitsecondparameters[0]>NMCMAX_CURRENT) alter_nmc.limitsecondparameters[0]=NMCMAX_CURRENT; //     2 
					algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][1]); //   
					if(algoritmdata_tmp>0) alter_nmc.limitsecondparameters[1]=(word)algoritmdata_tmp*10; //     2     
					else alter_nmc.limitsecondparameters[1]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][2]); //   
					chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      2 
					alter_nmc.limitsecondparameters[2]=(word)chargedischargedata_tmp; //    
					algoritmdata_tmp=pgm_read_byte(&Nmc_ChargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][3]); //   
					if(algoritmdata_tmp>0) //      
						{
						chargedischargedata_tmp=(dword)algoritmdata_tmp*10000/625; //      
						alter_nmc.limitsecondparameters[3]=(word)chargedischargedata_tmp; //   
						}
					else alter_nmc.limitsecondparameters[3]=algoritmdata_tmp; //    
		}
	}

void NMC_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm) //   
	{
	byte algoritmdata_tmp=0; // 
	dword chargedischargedata_tmp=0;
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][0]); //   
					alter_nmc.limitfirstparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    1
					if(alter_nmc.limitfirstparameters[0]<NMCMIN_CURRENT) alter_nmc.limitfirstparameters[0]=NMCMIN_CURRENT; //     10-  
					else if(alter_nmc.limitfirstparameters[0]>NMCMAX_CURRENT) alter_nmc.limitfirstparameters[0]=NMCMAX_CURRENT; //     2500  
					algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][1]); //    
					alter_nmc.limitfirstparameters[1]=(word)algoritmdata_tmp*10; //     1
					algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][2]); //   
					if(algoritmdata_tmp>0) //    
						{
						chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      1
						alter_nmc.limitfirstparameters[2]=(word)chargedischargedata_tmp; //    
						}
					else alter_nmc.limitfirstparameters[2]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[FALSE]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_nmc.limitfirstparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_nmc.limitfirstparameters[3]<NMCMIN_CURRENT) alter_nmc.limitfirstparameters[3]=NMCMIN_CURRENT; //     10-  
						}
					else alter_nmc.limitfirstparameters[3]=algoritmdata_tmp; //  
					break;
		case TRUE: algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][0]); //   
					alter_nmc.limitsecondparameters[0]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    2
					if(alter_nmc.limitsecondparameters[0]<NMCMIN_CURRENT) alter_nmc.limitsecondparameters[0]=NMCMIN_CURRENT; //     10-  
					else if(alter_nmc.limitsecondparameters[0]>NMCMAX_CURRENT) alter_nmc.limitsecondparameters[0]=NMCMAX_CURRENT; //     2500  
					algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][1]); //   
					alter_nmc.limitsecondparameters[1]=(word)algoritmdata_tmp*10; //     2
					algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][2]); //   
					if(algoritmdata_tmp>0) //    
						{
						chargedischargedata_tmp=(dword)settcapacitybattery_prm*(dword)algoritmdata_tmp/100; //      2
						alter_nmc.limitsecondparameters[2]=(word)chargedischargedata_tmp; //   
						}
					else alter_nmc.limitsecondparameters[2]=algoritmdata_tmp; //  
					algoritmdata_tmp=pgm_read_byte(&Nmc_DischargeBattery[alter_nmc.countercyclesalgorithm[TRUE]][3]); //   
					if(algoritmdata_tmp>0) //     
						{
						alter_nmc.limitsecondparameters[3]=settcapacitybattery_prm/(word)algoritmdata_tmp; //    
						if(alter_nmc.limitsecondparameters[3]<NMCMIN_CURRENT) alter_nmc.limitsecondparameters[3]=NMCMIN_CURRENT; //     10-  
						}
					else alter_nmc.limitsecondparameters[3]=algoritmdata_tmp; //  
		}
	}

word NMC_ChargeController(bit indxnumberbattery_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm) //    
	{
	bit indxdetectdelta_tmp=FALSE; //  
	word settingcurrentbattery_tmp=0; 
	word minimumchargebattery_tmp=0; 
	word limitcurrentparameters_tmp=0; 
	dword generalpurpose_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //   
		{
		case FALSE: switch(alter_nmc.countercyclesalgorithm[FALSE]) //    1
						{
						case 0: if((measuredchargebattery_prm>=alter_nmc.limitfirstparameters[4])&&(measuredchargebattery_prm<alter_nmc.limitfirstparameters[2])) //    0,01C(1%)
									{
									settingcurrentbattery_tmp=NMC_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitfirstparameters[0],measvoltageloadedbattery_prm); //    0,1
									if(alter_nmc.currentstatusprocess[FALSE]!=1) alter_nmc.currentstatusprocess[FALSE]=1; // :  
									}
								minimumchargebattery_tmp=alter_nmc.limitfirstparameters[2]/3; //     0,0033C
								if((measuredchargebattery_prm>=minimumchargebattery_tmp)&&(measuredvoltagebattery_prm>=alter_nmc.limitfirstparameters[1])) //      0,0033C    1000 
									{
									alter_nmc.limitfirstparameters[4]=minimumchargebattery_tmp; //     
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_nmc.countercyclesalgorithm[FALSE]++; //       
									indx_nmc.updatingfirstdata=FALSE; //        
									}
								else if((measuredchargebattery_prm>=alter_nmc.limitfirstparameters[2])&&(measuredvoltagebattery_prm<alter_nmc.limitfirstparameters[1])) //    0,01C(1%)    1  1000  
									{
									settingcurrentbattery_tmp=0; //          1
									alter_nmc.countercyclesalgorithm[FALSE]=0; //   
									alter_nmc.limitfirstparameters[4]=0; //    
									alter_nmc.currentstatusprocess[FALSE]=9; // :   1 
									indx_nmc.updatingfirstdata=FALSE; //      
									}
								break;
						case 1: if((measuredchargebattery_prm>=alter_nmc.limitfirstparameters[4])&&(measuredchargebattery_prm<alter_nmc.limitfirstparameters[2])) //    0,0033    1,05C(105%)
									{
									if(indxonlycharging_prm==FALSE) //     
										{
										if(measuredtemperature_prm>=alter_nmc.limitfirstparameters[3]) limitcurrentparameters_tmp=alter_nmc.limitfirstparameters[0]/4; //   0,25    1 40*   
										else limitcurrentparameters_tmp=alter_nmc.limitfirstparameters[0]; //   1     40* 
										}
									else limitcurrentparameters_tmp=alter_nmc.limitfirstparameters[0]; //       1 
									settingcurrentbattery_tmp=NMC_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measvoltageloadedbattery_prm); //    1C 
									if(alter_nmc.currentstatusprocess[FALSE]!=2) alter_nmc.currentstatusprocess[FALSE]=2; // :   
									}
								indxdetectdelta_tmp=NMC_DetectionDerivative(FALSE); //  
								if(indxonlycharging_prm==TRUE) //     
									{
									if((indxdetectdelta_tmp==TRUE)||(measuredtemperature_prm>(alter_nmc.limitfirstparameters[3]))||(measuredchargebattery_prm>=alter_nmc.limitfirstparameters[2])) //       40*       105%   
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_nmc.countercyclesalgorithm[FALSE]++; //      
										alter_nmc.countergeneralusage[FALSE]=7; //    1  
										indx_nmc.updatingfirstdata=FALSE; //      
										}
									}
								else //     
									{
									generalpurpose_tmp=(dword)alter_nmc.limitfirstparameters[2]*80/105; //     0,8C
									minimumchargebattery_tmp=(word)generalpurpose_tmp; //   0,8 
									if(measuredchargebattery_prm<minimumchargebattery_tmp) //    0,8 
										{
										if(alter_nmc.maximumtemperature[FALSE]>0) alter_nmc.maximumtemperature[FALSE]=0; //      
										}
									else if(((indxdetectdelta_tmp==TRUE)&&(measuredchargebattery_prm>=minimumchargebattery_tmp))||(measuredchargebattery_prm>=alter_nmc.limitfirstparameters[2])) //      0,8C        105% 
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //      
										alter_nmc.countercyclesalgorithm[FALSE]++; //      
										alter_nmc.countergeneralusage[FALSE]=35; //    5  
										indx_nmc.updatingfirstdata=FALSE; //       
										}
									}
								break;
						case 2: if(alter_nmc.countergeneralusage[FALSE]>0) //      
									{
									settingcurrentbattery_tmp=NMC_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitfirstparameters[0],measvoltageloadedbattery_prm); //    0,1C 
									alter_nmc.countergeneralusage[FALSE]--; //    
									if(alter_nmc.currentstatusprocess[FALSE]!=3) alter_nmc.currentstatusprocess[FALSE]=3; // :  
									}
								else //    
									{
									settingcurrentbattery_tmp=0; //          1
									alter_nmc.countercyclesalgorithm[FALSE]=0; //   
									alter_nmc.limitfirstparameters[4]=0; //     
									alter_nmc.currentstatusprocess[FALSE]=4; // :   
									indx_nmc.updatingfirstdata=FALSE; //      
									}
						}
					break;
		case TRUE: switch(alter_nmc.countercyclesalgorithm[TRUE]) //    2
						{
						case 0: if((measuredchargebattery_prm>=alter_nmc.limitsecondparameters[4])&&(measuredchargebattery_prm<alter_nmc.limitsecondparameters[2])) //    0,01C(1%)
									{
									settingcurrentbattery_tmp=NMC_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitsecondparameters[0],measvoltageloadedbattery_prm); //    0,1C 
									if(alter_nmc.currentstatusprocess[TRUE]!=1) alter_nmc.currentstatusprocess[TRUE]=1; // :  
									}
								minimumchargebattery_tmp=alter_nmc.limitsecondparameters[2]/3; //     0,0033C
								if((measuredchargebattery_prm>=minimumchargebattery_tmp)&&(measuredvoltagebattery_prm>=alter_nmc.limitsecondparameters[1])) //      0,0033C    1000 
									{
									alter_nmc.limitsecondparameters[4]=minimumchargebattery_tmp; //     
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_nmc.countercyclesalgorithm[TRUE]++; //        
									indx_nmc.updatingseconddata=FALSE; //      
									}
								else if((measuredchargebattery_prm>=alter_nmc.limitsecondparameters[2])&&(measuredvoltagebattery_prm<alter_nmc.limitsecondparameters[1])) //    0,01C    2  1000  
									{
									settingcurrentbattery_tmp=0; //          2
									alter_nmc.countercyclesalgorithm[TRUE]=0; //   
									alter_nmc.limitsecondparameters[4]=0; //    
									alter_nmc.currentstatusprocess[TRUE]=9; // :   2
									indx_nmc.updatingseconddata=FALSE; //      
									}
								break;
						case 1: if((measuredchargebattery_prm>=alter_nmc.limitsecondparameters[4])&&(measuredchargebattery_prm<alter_nmc.limitsecondparameters[2])) //    0,0033   1,05(105%) 
									{
									if(indxonlycharging_prm==FALSE) //     
										{
										if(measuredtemperature_prm>=alter_nmc.limitsecondparameters[3]) limitcurrentparameters_tmp=alter_nmc.limitsecondparameters[0]/4;//   0,25    2 40*  
										else limitcurrentparameters_tmp=alter_nmc.limitsecondparameters[0]; //   1     40*
										}
									else limitcurrentparameters_tmp=alter_nmc.limitsecondparameters[0]; //       1
									settingcurrentbattery_tmp=NMC_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measvoltageloadedbattery_prm); //    
									if(alter_nmc.currentstatusprocess[TRUE]!=2) alter_nmc.currentstatusprocess[TRUE]=2; // :   
									}
								indxdetectdelta_tmp=NMC_DetectionDerivative(TRUE); // 
								if(indxonlycharging_prm==TRUE) //     
									{
									if((indxdetectdelta_tmp==TRUE)||(measuredtemperature_prm>=(alter_nmc.limitsecondparameters[3]))||(measuredchargebattery_prm>=alter_nmc.limitsecondparameters[2])) //       2 40*       105%
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_nmc.countercyclesalgorithm[TRUE]++; //      
										alter_nmc.countergeneralusage[TRUE]=7; //    1  
										indx_nmc.updatingseconddata=FALSE; //     
										}
									}
								else //     
									{
									generalpurpose_tmp=(dword)alter_nmc.limitsecondparameters[2]*80/105; //     0,8C
									minimumchargebattery_tmp=(word)generalpurpose_tmp; //   0,8
									if(measuredchargebattery_prm<minimumchargebattery_tmp) //    0,8 
										{
										if(alter_nmc.maximumtemperature[TRUE]>0) alter_nmc.maximumtemperature[TRUE]=0; //      
										}
									else if(((indxdetectdelta_tmp==TRUE)&&(measuredchargebattery_prm>=minimumchargebattery_tmp))||(measuredchargebattery_prm>=alter_nmc.limitsecondparameters[2])) //    0,8C        105%
										{
										if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
										alter_nmc.countercyclesalgorithm[TRUE]++; //      
										alter_nmc.countergeneralusage[TRUE]=35; //    5  
										indx_nmc.updatingseconddata=FALSE; //      
										}
									}
								break;
						case 2: if(alter_nmc.countergeneralusage[indxnumberbattery_prm]>0) //      
									{
									settingcurrentbattery_tmp=NMC_ChargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitsecondparameters[0],measvoltageloadedbattery_prm); //    0,1C 
									alter_nmc.countergeneralusage[TRUE]--; //   
									if(alter_nmc.currentstatusprocess[TRUE]!=3) alter_nmc.currentstatusprocess[TRUE]=3; // :  
									}
								else //   
									{
									settingcurrentbattery_tmp=0; //          2 
									alter_nmc.countercyclesalgorithm[TRUE]=0; //   
									alter_nmc.limitsecondparameters[4]=0; //    
									alter_nmc.currentstatusprocess[TRUE]=4; // :   
									indx_nmc.updatingseconddata=FALSE; //     
									}
						}
		}
	return settingcurrentbattery_tmp; //    
	}

word NMC_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm) //  
	{
	word settingcurrentbattery_tmp=0; // 
	word limitcurrentparameters_tmp=0; 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	switch(indxnumberbattery_prm) //  
		{
		case FALSE: switch(alter_nmc.countercyclesalgorithm[FALSE]) //    1
						{
						case 0: if((measuredchargebattery_prm<alter_nmc.limitfirstparameters[2])&&(measuredvoltagebattery_prm>=alter_nmc.limitfirstparameters[1])) //    0,01(1%)      1050 
									{
									settingcurrentbattery_tmp=NMC_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitfirstparameters[0],measvoltageloadedbattery_prm); //    0,25 
									if(alter_nmc.currentstatusprocess[FALSE]!=5) alter_nmc.currentstatusprocess[FALSE]=5; // :   
									}
								else if((measuredchargebattery_prm<alter_nmc.limitfirstparameters[2])&&(measuredvoltagebattery_prm<alter_nmc.limitfirstparameters[1])) //    0,01(1%)    1050  
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nmc.countercyclesalgorithm[FALSE]=2; //          
									indx_nmc.updatingfirstdata=FALSE; //     
									}
								else if((measuredchargebattery_prm>=alter_nmc.limitfirstparameters[2])&&(measuredvoltagebattery_prm>=alter_nmc.limitfirstparameters[1])) //    0,01(1%)    1050  
									{
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_nmc.countercyclesalgorithm[FALSE]++; //       
									indx_nmc.updatingfirstdata=FALSE; //     
									}
								break;
						case 1: if(measuredvoltagebattery_prm>=alter_nmc.limitfirstparameters[1]) //      1050  
									{
									if(measuredtemperature_prm>=640) limitcurrentparameters_tmp=alter_nmc.limitfirstparameters[0]/2; //  0,25       40* 
									else limitcurrentparameters_tmp=alter_nmc.limitfirstparameters[0]; //  0,5     40* 
									settingcurrentbattery_tmp=NMC_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measvoltageloadedbattery_prm); //    
									if(alter_nmc.currentstatusprocess[FALSE]!=6) alter_nmc.currentstatusprocess[FALSE]=6; // :   
									}
								else //    1050  
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nmc.countercyclesalgorithm[FALSE]++; //       
									indx_nmc.updatingfirstdata=FALSE; //     
									}
								break;
						case 2: if(measuredvoltagebattery_prm>=alter_nmc.limitfirstparameters[1]) //   1    800  
									{
									settingcurrentbattery_tmp=NMC_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitfirstparameters[0],measvoltageloadedbattery_prm); //    
									if(alter_nmc.currentstatusprocess[FALSE]!=7) alter_nmc.currentstatusprocess[FALSE]=7; // :   
									}
								else //    800  
									{
									if((measuredcurrentbattery_prm>alter_nmc.limitfirstparameters[3])&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //         0,01
									else if(measuredcurrentbattery_prm<=alter_nmc.limitfirstparameters[3]) //      0,01   10  
										{
										settingcurrentbattery_tmp=0; //         
										alter_nmc.countercyclesalgorithm[FALSE]=0; //   
										alter_nmc.currentstatusprocess[FALSE]=8; // :   
										indx_nmc.updatingfirstdata=FALSE; //   
										}
									}
						}
					break;
		case TRUE: switch(alter_nmc.countercyclesalgorithm[TRUE]) //    2
						{
						case 0: if((measuredchargebattery_prm<alter_nmc.limitsecondparameters[2])&&(measuredvoltagebattery_prm>=alter_nmc.limitsecondparameters[1])) //    0,01(1%)      1050  
									{
									settingcurrentbattery_tmp=NMC_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitsecondparameters[0],measvoltageloadedbattery_prm); //    
									if(alter_nmc.currentstatusprocess[TRUE]!=5) alter_nmc.currentstatusprocess[TRUE]=5; // :    
									}
								else if((measuredchargebattery_prm<alter_nmc.limitsecondparameters[2])&&(measuredvoltagebattery_prm<alter_nmc.limitsecondparameters[1])) //    0,01(1%)    1050  
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nmc.countercyclesalgorithm[TRUE]=2; //         
									indx_nmc.updatingseconddata=FALSE; //     
									}
								else if((measuredchargebattery_prm>=alter_nmc.limitsecondparameters[2])&&(measuredvoltagebattery_prm>=alter_nmc.limitsecondparameters[1])) //    0,01(1%)    1050  
									{
									settingcurrentbattery_tmp=settingcurrentbattery_tmp*3/2; //     
									alter_nmc.countercyclesalgorithm[TRUE]++; //       
									indx_nmc.updatingseconddata=FALSE; //     
									}
								break;
						case 1: if(measuredvoltagebattery_prm>=alter_nmc.limitsecondparameters[1]) //      1050  
									{
									if(measuredtemperature_prm>=640) limitcurrentparameters_tmp=alter_nmc.limitsecondparameters[0]/2; //  0,25    2    40* 
									else limitcurrentparameters_tmp=alter_nmc.limitsecondparameters[0]; //  0,5    2  40* 
									settingcurrentbattery_tmp=NMC_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,limitcurrentparameters_tmp,measvoltageloadedbattery_prm); //   
									if(alter_nmc.currentstatusprocess[TRUE]!=6) alter_nmc.currentstatusprocess[TRUE]=6; // :   
									}
								else //    1050  
									{
									if(settingcurrentbattery_tmp>1) settingcurrentbattery_tmp/=2; //     
									alter_nmc.countercyclesalgorithm[TRUE]++; //       
									indx_nmc.updatingseconddata=FALSE; //     
									}
								break;
						case 2: if(measuredvoltagebattery_prm>=alter_nmc.limitsecondparameters[1]) //   2    800  
									{
									settingcurrentbattery_tmp=NMC_DischargingCurrent(measuredcurrentbattery_prm,settingcurrentbattery_tmp,alter_nmc.limitsecondparameters[0],measvoltageloadedbattery_prm); //    
									if(alter_nmc.currentstatusprocess[TRUE]!=7) alter_nmc.currentstatusprocess[TRUE]=7; // :   
									}
								else //    800  
									{
									if((measuredcurrentbattery_prm>alter_nmc.limitsecondparameters[3])&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //         0,01
									else if(measuredcurrentbattery_prm<=alter_nmc.limitsecondparameters[3]) //      0,01   10  
										{
										settingcurrentbattery_tmp=0; //         
										alter_nmc.countercyclesalgorithm[TRUE]=0; //   
										alter_nmc.currentstatusprocess[TRUE]=8; // :   
										indx_nmc.updatingseconddata=FALSE; //   
										}
									}
						}
		}
	return settingcurrentbattery_tmp; //     
	}

word NMC_ReadcurrentStatus(bit indxnumberbattery_prm,byte numberparameters_prm) //       
	{
	word dataparameters_tmp=0; // 
	switch(numberparameters_prm) //   
		{
		case 0: dataparameters_tmp=(word)alter_nmc.currentstatusprocess[indxnumberbattery_prm]; //     
				break;
		case 1: dataparameters_tmp=alter_nmc.increaseratevoltage[indxnumberbattery_prm]; //      
				break;
		case 2: dataparameters_tmp=alter_nmc.increasetemperature[indxnumberbattery_prm]; //      
		}
	return dataparameters_tmp; //      
	}

word NMC_ChargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitsparameters_prm,word measvoltageloadedbattery_prm) //   
	{
	word settingcurrentbattery_tmp=0; //  
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //     
	if((measuredcurrentbattery_prm<limitsparameters_prm)&&(measvoltageloadedbattery_prm<NMCMAX_VOLTAGE)) settingcurrentbattery_tmp++; //              
	else if(measuredcurrentbattery_prm==limitsparameters_prm) asm("nop"); //        
	else if(((measuredcurrentbattery_prm>limitsparameters_prm)||(measvoltageloadedbattery_prm>=NMCMAX_VOLTAGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //              
	return settingcurrentbattery_tmp; //    
	}

word NMC_DischargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitsparameters_prm,word measvoltageloadedbattery_prm) //   
	{
	word settingcurrentbattery_tmp=0; // 
	settingcurrentbattery_tmp=settingcurrentbattery_prm; //    
	if((measuredcurrentbattery_prm<limitsparameters_prm)&&(measvoltageloadedbattery_prm>NMCMIN_VOLTAGE)) settingcurrentbattery_tmp++; //              
	else if(measuredcurrentbattery_prm==limitsparameters_prm) asm("nop"); //       
	else if(((measuredcurrentbattery_prm>limitsparameters_prm)||(measvoltageloadedbattery_prm<=NMCMIN_VOLTAGE))&&(settingcurrentbattery_tmp>1)) settingcurrentbattery_tmp--; //             
	return settingcurrentbattery_tmp; //   
	}





