/**********************************************************************
* Nimhnicdbattery.h
*     Ni-Mh  Ni-Cd 
* : 15.06.2022 19:19:05
* :  .
***********************************************************************/

#pragma once

#include "Main.h"

#define NMCMIN_VOLTAGE 700 //     
#define NMCMAX_VOLTAGE 1800 //     
#define NMCMAX_CURRENT 2500 //   / 
#define NMCMIN_CURRENT 10 //   / 

typedef struct
	{
	bit updatingfirstdata:1; //     1 
	bit updatingseconddata:1; //     2 
	}bit_nmc;

typedef struct
	{
	byte countergeneralusage[2]; //   
	byte counterdeltadetected[2]; //    
	byte countercyclesalgorithm[2]; //   /  
	byte currentstatusprocess[2]; //     1[0]  2[1] 
	word previousvoltagebattery[2]; //    1[0]  2[1] 
	word previoustemperature[2]; //    1[0]  2[1] 
	word increaseratevoltage[2]; //       1[0]  2[1] 
	word increasetemperature[2]; //       1[0]  2[1] 
	word maximumtemperature[2]; //      1[0]  2[1] 
	word limitfirstparameters[5]; //   ,      1 
	word limitsecondparameters[5]; //   ,      2 
	}var_nmc; 

void NMC_DefiningParameters(bit indxnumberbattery_prm,bit indxchargedischarge_prm,word settcapacitybattery_prm); //    
void NMC_ChargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //    
void NMC_DischargeParameters(bit indxnumberbattery_prm,word settcapacitybattery_prm); //    
void NMC_ResetVariables(bit indxnumberbattery_prm); //   
void NMC_WritenimhDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm); //     Ni-Mh 
void NMC_ReadnimhDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm); //     Ni-Mh 
void NMC_WritenicdDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm); //     Ni-Cd 
void NMC_ReadnicdDeferred(bit indxnumberbattery_prm,bit indxchargedischarge_prm); //     Ni-Cd 
void NMC_IncreaseParameters(bit indxnumberbattery_prm,word measuredvoltagebattery_prm,word measuredtemperature_prm); //        
bit NMC_DetectionDerivative(bit indxnumberbattery_prm); //          
word NMC_ReadcurrentStatus(bit indxnumberbattery_prm,byte numberparameters_prm); //     
word NMC_MainMode(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settcapacitybattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //     
word NMC_DetermCurrentcontrol(bit indxnumberbattery_prm,bit indxchargedischarge_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm); //      
word NMC_ChargeController(bit indxnumberbattery_prm,bit indxonlycharging_prm,word measuredcurrentbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredtemperature_prm); //   
word NMC_DischargeController(bit indxnumberbattery_prm,word measuredcurrentbattery_prm,word measuredvoltagebattery_prm,word measvoltageloadedbattery_prm,word measuredchargebattery_prm,word settingcurrentbattery_prm,word measuredtemperature_prm); //   
word NMC_ChargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitparameters_prm,word measvoltageloadedbattery_prm); //     
word NMC_DischargingCurrent(word measuredcurrentbattery_prm,word settingcurrentbattery_prm,word limitparameters_prm,word measvoltageloadedbattery_prm); //    














