/*********************************
* Operatingmode.c
*    
* : 02.11.2021 20:02:56
* :  .
**********************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include "Main.h"
#include "Operatingmode.h"
#include "Systemcontrol.h"
#include "Symbolout.h"
#include "Adconverter.h"
#include "Keybuttscan.h"
#include "Nimhnicdbattery.h"
#include "Owids18b20.h"
#include "Lionlipobattery.h"
#include "Lifebattery.h"

bit_opr indx_opr={0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // 
var_opr alter_opr={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{100,100},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},0,{0,0},{0,0},{0,0},{0,0},{0,0}}; // 

EEMEM static byte Opr_IndxonlyCharging[2]={0,0}; //    
EEMEM static byte Opr_IndxfullCharging[2]={0,0}; //    /  
EEMEM static byte Opr_IndexoutDeferred[2]={0,0}; //    
EEMEM static byte Opr_TypemodeBattery[4][2]={{0,0},{0,0},{0,0},{0,0}}; // , ,        
EEMEM static word Opr_ParametersDeferred[5][2]={{0,0},{0,0},{0,0},{0,0},{0,0}}; //   
EEMEM static word Opr_DataitemsProtocol[18][2]={{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}; //     
EEMEM static word Opr_SettingCapacity[2]={0,0}; //   
EEMEM static dword Opr_SummaChargedischarge[2]={0,0}; // /  /  

ISR(TIMER1_OVF_vect) //     1
	{
	alter_opr.counterinterrupt++; //  
	if(alter_opr.counterinterrupt>=12500) //     0,8 
		{
		alter_opr.counterinterrupt=0; //  
		indx_opr.startingworkcycle=TRUE; //      
		}
	}

void OPR_StartstopWorkcycle(bit indxstartstop_prm) //        0,8  
	{
	switch(indxstartstop_prm) //  /
		{
		case FALSE: if(indx_opr.onoffworkingservice==TRUE) //      
						{
						cli(); //  
						ClearBit(TIMSK1,TOIE1); //    1 
						indx_opr.onoffworkingservice=FALSE; //     
						}
					break;
		case TRUE: if(indx_opr.onoffworkingservice==FALSE) //       
						{
						SetBit(TIMSK1,TOIE1); //    1
						sei(); //  
						indx_opr.onoffworkingservice=TRUE; //      
						}
		}
	}

void OPR_MainMode(bit indxupdateline_prm) //      
	{
	byte datacodecontrol_tmp=0; //  
	if(indxupdateline_prm==TRUE) indx_opr.updatetextstring=TRUE; //         
	datacodecontrol_tmp=KEY_DecoderButton(); //  
	if(datacodecontrol_tmp>0) OPR_ControlWorkcycle(datacodecontrol_tmp); //    
	switch(alter_opr.counterworkcycle[indx_opr.processnumber]) //        
		{
		case 0: OPR_SettingParameters(); //     
				break;
		case 1: OPR_SearchBattery(); //  
				break;
		case 2: OPR_NotconnectBattery(); //   
				break;
		case 3: OPR_DefineModeservice(); //        
				break;
		case 4: OPR_OperationalBattery(); //   
				break;
		case 5: OPR_CancellOperational(); //    
				break;
		case 6: OPR_CompleteOperational(); //    
		}
	switch(indx_opr.processnumber) //     
		{
		case FALSE: indx_opr.processnumber=TRUE; //    2 
					break;
		case TRUE: indx_opr.processnumber=FALSE; //    1 
		}
	SYM_CursorPosition(alter_opr.locationcursorline[indx_opr.settingnumber]); //   
	OPR_WorkcycleService(); //   
	SYS_TimeWaiting(10); // 10 
	}

void OPR_SettingParameters(void) //    
	{
	if((indx_opr.updatetextstring==TRUE)&&(indx_opr.processnumber==indx_opr.settingnumber)&&(indx_opr.prioritycomplete==FALSE)) //    ,        
		{
		indx_opr.updatetextstring=FALSE; //  
		switch(alter_opr.counteroutitems[indx_opr.processnumber]) //    
			{
			case 0: OPR_OutitemBatterytype(); //    
					break;
			case 1: SYM_LineOut(14,0,FALSE,indx_opr.processnumber,1); //     : :  00000  
					SYM_OutdataNumber00000(alter_opr.settcapacitybattery[indx_opr.processnumber],6); //    
					break;
			case 2: OPR_OutitemBatterymode(); //    
					break;
			case 3: SYM_LineOut(28,0,FALSE,indx_opr.processnumber,1); //    : : 
					if(((indx_opr.startsecondservices==TRUE)&&(indx_opr.processnumber==TRUE))||((indx_opr.startfirstservices==TRUE)&&(indx_opr.processnumber==FALSE))) //      
						{
						alter_opr.counterworkcycle[indx_opr.processnumber]++; //       
						indx_opr.updatetextstring=TRUE; //    
						}
					break;
			case 4: switch(indx_opr.processnumber) //      
						{
						case FALSE: switch(indx_opr.outputfirstprotocol) //    1 
										{
										case FALSE: SYM_LineOut(42,0,FALSE,FALSE,1); //  : :1  
													break;
										case TRUE: OPR_OutputitemsProtocol(FALSE); //    1 
										}
									break;
						case TRUE: switch(indx_opr.outputsecondprotocol) //    2 
										{
										case FALSE: SYM_LineOut(42,0,FALSE,TRUE,1); //  : :2 
													break;
										case TRUE: OPR_OutputitemsProtocol(TRUE); //    2
										}
						} 
			}
		}
	}

void OPR_SearchBattery(void) //   
	{
	bit indxconnectbattery_tmp=0; // 
	if(indx_opr.processnumber==indx_opr.settingnumber) //    
		{
		if(indx_opr.updatetextstring==TRUE) //    
			{
			indx_opr.updatetextstring=FALSE; // 
			SYM_LineOut(2,0,FALSE,indx_opr.processnumber,1); // : : 
			}
		indxconnectbattery_tmp=OPR_DetectBattery(); //  
		if(indxconnectbattery_tmp==TRUE) //     
			{
			if(alter_opr.countgeneralpurpose[0]<34) alter_opr.countgeneralpurpose[0]++; //    2      
			else //   
				{
				while(OWI_MeasuredTemperature(TRUE,alter_opr.datanumbersensors[indx_opr.processnumber])>=1360) //        
				alter_opr.countgeneralpurpose[0]=0; //   
				alter_opr.counterworkcycle[indx_opr.processnumber]=3; //      
				SYS_OutsignalBeep(10,2); //     10 
				}
			}
		else //   
			{
			if(alter_opr.countgeneralpurpose[0]<34) alter_opr.countgeneralpurpose[0]++; //      2 
			else //   
				{
				alter_opr.countgeneralpurpose[0]=0; //   
				alter_opr.counterworkcycle[indx_opr.processnumber]++; //         
				indx_opr.updatetextstring=TRUE; //   
				}
			}
		}
	}

void OPR_NotconnectBattery(void) //    
	{
	bit indxconnectbattery_tmp=0; // 
	if(indx_opr.processnumber==indx_opr.settingnumber) //    
		{
		if(indx_opr.updatetextstring==TRUE) //    
			{
			indx_opr.updatetextstring=FALSE; // 
			SYM_LineOut(1,0,FALSE,indx_opr.processnumber,1); // : : 
			}
		indxconnectbattery_tmp=OPR_DetectBattery(); //  
		if(indxconnectbattery_tmp==TRUE) //  
			{
			alter_opr.countgeneralpurpose[0]=0; //    1 
			alter_opr.countgeneralpurpose[1]=0; //    2 
			alter_opr.counterworkcycle[indx_opr.processnumber]++; //      
			}
		else //   
			{
			if(alter_opr.countgeneralpurpose[0]<167) //     10  
				{
				if(alter_opr.countgeneralpurpose[1]<8) alter_opr.countgeneralpurpose[1]++; //    
				else //    
					{
					SYS_OutsignalBeep(10,4); //     10 
					alter_opr.countgeneralpurpose[1]=0; //    
					}
				alter_opr.countgeneralpurpose[0]++; //      
				}
			else OPR_ResetVariables(); //              
			}
		}
	}

void OPR_DefineModeservice(void) //    
	{
	OPR_StartstopWorkcycle(TRUE); //       
	switch(indx_opr.processnumber) //  
		{
		case FALSE: switch(alter_opr.countermodebattery[FALSE]) //    1
						{
						case 0: if(indx_opr.firstfullservice==FALSE) indx_opr.firstfullservice=TRUE; //    /
								if(indx_opr.firstchargedischarge==FALSE) indx_opr.firstchargedischarge=TRUE; //    
								break;
						case 1: if(indx_opr.firstchargedischarge==FALSE) indx_opr.firstchargedischarge=TRUE; //    
								break;
						case 2: if(indx_opr.firstchargedischarge==TRUE) indx_opr.firstchargedischarge=FALSE; //    
								break;
						case 3 ... 4: asm("nop"); // 
						}
					indx_opr.connectfirstbattery=TRUE; //    1
					break;
		case TRUE: switch(alter_opr.countermodebattery[TRUE]) //    2
						{
						case 0: if(indx_opr.secondfullservice==FALSE) indx_opr.secondfullservice=TRUE; 
								if(indx_opr.secondchargedischarge==FALSE) indx_opr.secondchargedischarge=TRUE; //    
								break;
						case 1: if(indx_opr.secondchargedischarge==FALSE) indx_opr.secondchargedischarge=TRUE; //    
								break;
						case 2: if(indx_opr.secondchargedischarge==TRUE) indx_opr.secondchargedischarge=FALSE; //    
								break;
						case 3 ... 4: asm("nop"); // 
						}
					indx_opr.connectsecondbattery=TRUE; //    2
		}
	indx_opr.updatetextstring=TRUE; //   
	indx_opr.updateparameters=TRUE; //    
	alter_opr.counterworkcycle[indx_opr.processnumber]++; //       
	}

void OPR_OperationalBattery(void) //     
	{
	
	if((indx_opr.firstviolacontact==FALSE)&&(indx_opr.secondviolacontact==FALSE)&&(indx_opr.prioritycomplete==FALSE)) //         
		{
		if(indx_opr.processnumber==indx_opr.settingnumber) //    
			{
			if(indx_opr.updatetextstring==TRUE) //    
				{
				indx_opr.updatetextstring=FALSE; // 
				OPR_OutserviceBatterymode(); //    
				}
			if(indx_opr.updateparameters==TRUE) //    
				{
				indx_opr.updateparameters=FALSE; // 
				OPR_OutserviceParameters(); //     
				}
			}
		}
	else if(((indx_opr.firstviolacontact==TRUE)||(indx_opr.secondviolacontact==TRUE))&&(indx_opr.prioritycomplete==FALSE)) OPR_NocontactBattery(); //               
	if((indx_opr.processnumber==FALSE)&&(indx_opr.finishfirstonecycle==TRUE)&&(indx_opr.startfirstservices==TRUE)) //     1      
		{
		indx_opr.finishfirstonecycle=FALSE; //      
		alter_opr.settingcurrentbattery[FALSE]=OPR_MonitoringParameters(); //    1 
		if(alter_opr.settingcurrentbattery[FALSE]==0) indx_opr.startfirstservices=FALSE;  //         1       
		}
	else if((indx_opr.processnumber==FALSE)&&(indx_opr.finishfirstonecycle==FALSE)&&(indx_opr.startfirstservices==FALSE)) //    1  
		{
		if(indx_opr.prioritycomplete==FALSE) //      
			{
			indx_opr.prioritycomplete=TRUE; //         1 
			indx_opr.updatetextstring=TRUE; //    
			alter_opr.counterworkcycle[FALSE]+=2; //      1 
			}
		else asm("nop"); //     
		}
	if((indx_opr.processnumber==TRUE)&&(indx_opr.finishsecondonecycle==TRUE)&&(indx_opr.startsecondservices==TRUE)) //     2      
		{
		indx_opr.finishsecondonecycle=FALSE; //      
		alter_opr.settingcurrentbattery[TRUE]=OPR_MonitoringParameters(); //    2 
		if(alter_opr.settingcurrentbattery[TRUE]==0) indx_opr.startsecondservices=FALSE;  //         2       
		}
	else if((indx_opr.finishsecondonecycle==FALSE)&&(indx_opr.processnumber==TRUE)&&(indx_opr.startsecondservices==FALSE)) //    2  
		{
		if(indx_opr.prioritycomplete==FALSE) //      
			{
			indx_opr.prioritycomplete=TRUE; //         2
			indx_opr.updatetextstring=TRUE; //    
			alter_opr.counterworkcycle[TRUE]+=2; //      2 
			}
		else asm("nop"); //     
		}
	}

word OPR_MonitoringParameters(void) //      
	{
	word settingcurrentbattery_tmp=0; //  
	if(OPR_ControlStopindex()==TRUE) //        
		{
		SYM_LineOut(36,0,FALSE,indx_opr.settingnumber,1); // : :  
		indx_opr.updatetextstring=TRUE; //   
		alter_opr.counterworkcycle[indx_opr.processnumber]++; //      
		}
	else //   
		{
		switch(indx_opr.processnumber) //  
			{
			case FALSE: if(indx_opr.firstviolacontact==FALSE) //      1  
							{
							OPR_CalculationParameters(); //   , / ,     
							settingcurrentbattery_tmp=OPR_MonitoringTypebattery(); //     
							}
						else settingcurrentbattery_tmp=alter_opr.settingcurrentbattery[FALSE]; //         
						break;
			case TRUE: if(indx_opr.secondviolacontact==FALSE) //      2  
							{
							OPR_CalculationParameters(); //   , / ,     
							settingcurrentbattery_tmp=OPR_MonitoringTypebattery(); //     
							}
						else settingcurrentbattery_tmp=alter_opr.settingcurrentbattery[TRUE]; //         
			}
		indx_opr.updateparameters=TRUE; //    
		}
	return settingcurrentbattery_tmp; //         
	}

word OPR_MonitoringTypebattery(void) //      
	{
	bit indxchargedischarge_tmp=FALSE; //  
	bit indxonlycharging_tmp=FALSE; 
	word currentstatus_tmp=0; 
	word settingcurrentbattery_tmp=0; 
	switch(indx_opr.processnumber) //  
		{
		case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1 
					indxonlycharging_tmp=indx_opr.onlyfirstcharging; //     1 
					break;
		case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2 
					indxonlycharging_tmp=indx_opr.onlysecondcharging; //     2 
		}
	switch(alter_opr.countertypebattery[indx_opr.processnumber]) //    
		{
		case 0: settingcurrentbattery_tmp=NMC_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Ni-Mh  
				currentstatus_tmp=NMC_ReadcurrentStatus(indx_opr.processnumber,0); //   
				alter_opr.increaseratevoltage[indx_opr.processnumber]=NMC_ReadcurrentStatus(indx_opr.processnumber,1); //     
				alter_opr.increasetemperature[indx_opr.processnumber]=NMC_ReadcurrentStatus(indx_opr.processnumber,2); //     
				break;
		case 1: settingcurrentbattery_tmp=NMC_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,indxonlycharging_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Ni-Cd 
				currentstatus_tmp=NMC_ReadcurrentStatus(indx_opr.processnumber,0); //  
				alter_opr.increaseratevoltage[indx_opr.processnumber]=NMC_ReadcurrentStatus(indx_opr.processnumber,1); //    
				alter_opr.increasetemperature[indx_opr.processnumber]=NMC_ReadcurrentStatus(indx_opr.processnumber,2); //    
				break;
		case 2: settingcurrentbattery_tmp=LPI_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Po 
				currentstatus_tmp=LPI_ReadcurrentStatus(indx_opr.processnumber); //   
				break;
		case 3: settingcurrentbattery_tmp=LPI_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Ion 
				currentstatus_tmp=LPI_ReadcurrentStatus(indx_opr.processnumber); //   
				break;
		case 4: settingcurrentbattery_tmp=LFE_MainMode(indx_opr.processnumber,indxchargedischarge_tmp,alter_opr.measuredcurrentbattery[indx_opr.processnumber],alter_opr.measuredvoltagebattery[indx_opr.processnumber],alter_opr.measvoltageloadedbattery[indx_opr.processnumber],alter_opr.measuredchargebattery[indx_opr.processnumber],alter_opr.settcapacitybattery[indx_opr.processnumber],alter_opr.settingcurrentbattery[indx_opr.processnumber],alter_opr.measuredtemperature[indx_opr.processnumber]); //   Li-Fe 
				currentstatus_tmp=LFE_ReadcurrentStatus(indx_opr.processnumber); //   
		}
	if(currentstatus_tmp!=alter_opr.currentstatusprocess[indx_opr.processnumber]) //     
		{
		indx_opr.updatetextstring=TRUE; //   
		alter_opr.currentstatusprocess[indx_opr.processnumber]=(byte)currentstatus_tmp; //  
		}
	return settingcurrentbattery_tmp; //     
	}

void OPR_CancellOperational() //     
	{
	bit indxconnectbattery_tmp=FALSE; //  
	if((indx_opr.startfirstservices==FALSE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.onoffworkingservice==TRUE)) OPR_StartstopWorkcycle(FALSE); //        
	if(indx_opr.processnumber==indx_opr.settingnumber) //    
		{
		if(alter_opr.countgeneralpurpose[0]<70) alter_opr.countgeneralpurpose[0]++; //      2 
		else //  
			{
			indxconnectbattery_tmp=OPR_DetectBattery(); //   
			if(indxconnectbattery_tmp==FALSE) //  
				{
				SYS_OutsignalBeep(10,2); //     10 
				OPR_ResetVariables(); //  
				}
			else //   
				{
				if(indx_opr.updatetextstring==TRUE) //     
					{
					indx_opr.updatetextstring=FALSE; // 
					SYM_LineOut(37,0,FALSE,indx_opr.settingnumber,1); // : : 
					}
				if(alter_opr.countgeneralpurpose[1]<8) alter_opr.countgeneralpurpose[1]++; //     
				else //    
					{
					SYS_OutsignalBeep(10,4); //     10  
					alter_opr.countgeneralpurpose[1]=0; //     
					}
				}
			}
		}
	}

void OPR_CompleteOperational(void) //      
	{
	bit indxconnectbattery_tmp=FALSE; //  
	if(alter_opr.countermodebattery[indx_opr.processnumber]==0) //   /
		{
		switch(indx_opr.processnumber) //   
			{
			case FALSE: OPR_WritedataProtocol(FALSE); //      1 
						indx_opr.startfirstservices=TRUE; //      1 
						break; 
			case TRUE: OPR_WritedataProtocol(TRUE); //      2 
						indx_opr.startsecondservices=TRUE; //      2 
			}
		OPR_ResetExternaldata(indx_opr.processnumber); //       
		alter_opr.summachargebattery[indx_opr.processnumber]=0; //   / 
		alter_opr.initialvoltagebattery[indx_opr.processnumber]=0; //          
		alter_opr.maximumcurrentbattery[indx_opr.processnumber]=0; //          
		alter_opr.miniresistancebattery[indx_opr.processnumber]=0; //           
		alter_opr.maximumtemperature[indx_opr.processnumber]=0; //          
		alter_opr.maximumoverheating[indx_opr.processnumber]=0; //           
		alter_opr.countermodebattery[indx_opr.processnumber]=2; //          
		alter_opr.counterworkcycle[indx_opr.processnumber]=3; //           
		indx_opr.prioritycomplete=FALSE; //   
		}
	else //       
		{
		if((indx_opr.startfirstservices==FALSE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.onoffworkingservice==TRUE)) OPR_StartstopWorkcycle(FALSE); //        
		if((indx_opr.processnumber==FALSE)&&(indx_opr.startfirstservices==FALSE)&&(indx_opr.connectfirstbattery==TRUE)) //    1  
			{
			if(indx_opr.updatetextstring==TRUE) //     
				{
				indx_opr.updatetextstring=FALSE; // 
				if(indx_opr.settingnumber==TRUE) indx_opr.settingnumber=FALSE; //       
				switch(indx_opr.firstchargedischarge) //  / 
					{
					case FALSE: OPR_WritedataProtocol(FALSE); //     1 
								if(alter_opr.currentstatusprocess[FALSE]==4) SYM_LineOut(35,4,TRUE,FALSE,1); // : :  
								else if(alter_opr.currentstatusprocess[FALSE]==9) SYM_LineOut(39,9,TRUE,FALSE,1); // : : ! 
								break;
					case TRUE: OPR_WritedataProtocol(FALSE); //     1 
								SYM_LineOut(34,8,TRUE,FALSE,1); // : :  
					}
				}
			indxconnectbattery_tmp=OPR_DetectBattery(); //   
			if(indxconnectbattery_tmp==FALSE) //   
				{
				indx_opr.prioritycomplete=FALSE; //   
				SYS_OutsignalBeep(10,2); //     10  
				OPR_ResetVariables(); //  
				}
			else //    
				{
				if(alter_opr.countgeneralpurpose[0]<150) alter_opr.countgeneralpurpose[0]++; //     1 
				else //   
					{
					SYS_OutsignalBeep(10,4); //     10 
					alter_opr.countgeneralpurpose[0]=0; //   
					}
				}
			}
		else if((indx_opr.processnumber==TRUE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.connectsecondbattery==TRUE)) //    2  
			{
			if(indx_opr.updatetextstring==TRUE) //    
				{
				indx_opr.updatetextstring=FALSE; //  
				if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //       
				switch(indx_opr.secondchargedischarge) //  / 
					{
					case FALSE: OPR_WritedataProtocol(TRUE); //     2
								if(alter_opr.currentstatusprocess[TRUE]==4) SYM_LineOut(35,4,TRUE,TRUE,1); // : :  
								else if(alter_opr.currentstatusprocess[TRUE]==9) SYM_LineOut(39,9,TRUE,TRUE,1); // : : ! 
								break;
					case TRUE: OPR_WritedataProtocol(TRUE); //     2
								SYM_LineOut(34,8,TRUE,TRUE,1); // : :  
					}
				}
			indxconnectbattery_tmp=OPR_DetectBattery(); //   
			if(indxconnectbattery_tmp==FALSE) //  
				{
				indx_opr.prioritycomplete=FALSE; //   
				SYS_OutsignalBeep(10,2); //     10  
				OPR_ResetVariables(); // 
				}
			else //   
				{
				if(alter_opr.countgeneralpurpose[0]<150) alter_opr.countgeneralpurpose[0]++; //     1 
				else //   
					{
					SYS_OutsignalBeep(10,4); //     10  
					alter_opr.countgeneralpurpose[0]=0; //    
					}
				}
			}
		}
	}

void OPR_NocontactBattery(void) //      
	{
	if(indx_opr.firstviolacontact==TRUE) //        1 
		{
		if(indx_opr.updatetextstring==TRUE) //     
			{
			indx_opr.updatetextstring=FALSE; //    
			if(indx_opr.settingnumber==TRUE) indx_opr.settingnumber=FALSE; //     
			SYM_LineOut(1,0,FALSE,FALSE,1); // : :1  
			}
		if(alter_opr.countgeneralpurpose[0]<16) alter_opr.countgeneralpurpose[0]++; //    
		else //   
			{
			SYS_OutsignalBeep(10,4); //     10 
			alter_opr.countgeneralpurpose[0]=0; //    
			}
		}
	else if(indx_opr.secondviolacontact==TRUE) //        2 
		{
		if(indx_opr.updatetextstring==TRUE) //     
			{
			indx_opr.updatetextstring=FALSE; //    
			if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //    
			SYM_LineOut(1,0,FALSE,TRUE,1); // : :2  
			}
		if(alter_opr.countgeneralpurpose[1]<16) alter_opr.countgeneralpurpose[1]++; //     
		else //    
			{
			SYS_OutsignalBeep(10,4); //     10  
			alter_opr.countgeneralpurpose[1]=0; //     
			}
		}
	}

bit OPR_ControlStopindex(void) //      
	{
	bit indxstoppostpone_tmp=FALSE; //  
	switch(indx_opr.processnumber) //   
		{
		case FALSE: if((indx_opr.stopfirstservices==TRUE)||(indx_opr.postponefirstservice==TRUE)) //        1 
						{
						if(indx_opr.postponefirstservice==TRUE) //      1 
							{
							indx_opr.postponefirstservice=FALSE; //  
							OPR_WritevalueDeferred(FALSE); //     1 
							}
						indxstoppostpone_tmp=TRUE; //    
						}
					break;
		case TRUE: if((indx_opr.stopsecondservices==TRUE)||(indx_opr.postponesecondservice==TRUE)) //        2 
						{
						if(indx_opr.postponesecondservice==TRUE) //      2 
							{
							indx_opr.postponesecondservice=FALSE; //  
							OPR_WritevalueDeferred(TRUE); //     2 
							}
						indxstoppostpone_tmp=TRUE; //    
						}
		}
	return indxstoppostpone_tmp; //  
	}

void OPR_WorkcycleService(void) //     
	{
	static bit indxfirstcontact_tmp=FALSE; //  
	static bit indxsecondcontact_tmp=FALSE; 
	word measurecurrentbattery_tmp=0; 
	if(indx_opr.startingworkcycle==TRUE) //      
		{
		indx_opr.startingworkcycle=FALSE; //  
		if((indx_opr.connectfirstbattery==TRUE)&&(indx_opr.startfirstservices==TRUE)) //  1     
			{
			switch(alter_opr.countercycleservice[FALSE]) //     1
				{
				case 0: if(alter_opr.settingcurrentbattery[FALSE]==0) alter_opr.settingcurrentbattery[FALSE]=2; //           
						switch(indx_opr.firstchargedischarge) // /
							{
							case FALSE: OPR_SmootCurrcharge(FALSE,FALSE,alter_opr.settingcurrentbattery[FALSE]); //   
										break;
							case TRUE: OPR_SmootCurrdischarge(FALSE,FALSE,alter_opr.settingcurrentbattery[FALSE]); //   
							}
						alter_opr.countercycleservice[FALSE]++; //  
						break;
				case 1 ... 8: switch(indx_opr.firstchargedischarge) // /
								{
								case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //    1
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=5; //         
											alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //   
											break;
								case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRDISCHARGE); //    1
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=5; //         
											alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //   
								}
						alter_opr.countercycleservice[FALSE]++; //  
						break;
				case 9: alter_opr.measvoltageloadedbattery[FALSE]=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //    1
						switch(indx_opr.firstchargedischarge) // /
							{
							case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //    1
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=5; //         
										alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[FALSE]>0) //    
											{
											OPR_SmootCurrcharge(FALSE,TRUE,alter_opr.settingcurrentbattery[FALSE]); //     
											}
										break;
							case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRDISCHARGE); //    1
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[FALSE]>0)) measurecurrentbattery_tmp=5; //         
										alter_opr.summacurrentbattery[FALSE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[FALSE]>0) //    
											{
											OPR_SmootCurrdischarge(FALSE,TRUE,alter_opr.settingcurrentbattery[FALSE]); //      
											}
							}
						indxfirstcontact_tmp=OPR_ControlViolconnect(FALSE,measurecurrentbattery_tmp); //      1 
						OPR_StartConverting(FALSE,alter_opr.datanumbersensors[FALSE]); //    1 
						alter_opr.countercycleservice[FALSE]++; //  
						break;
				case 10: alter_opr.measuredvoltagebattery[FALSE]=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //     1
						if(indx_opr.firstviolacontact!=indxfirstcontact_tmp) //        1 
							{
							indx_opr.firstviolacontact=indxfirstcontact_tmp; //   
							indx_opr.updatetextstring=TRUE; //    
							}
						alter_opr.countercycleservice[FALSE]=0; //    
						indx_opr.finishfirstonecycle=TRUE; //     
				}
			}
		if((indx_opr.connectsecondbattery==TRUE)&&(indx_opr.startsecondservices==TRUE)) //  2     
			{
			switch(alter_opr.countercycleservice[TRUE]) //     2
				{
				case 0: if(alter_opr.settingcurrentbattery[TRUE]==0) alter_opr.settingcurrentbattery[TRUE]=2; //           
						switch(indx_opr.secondchargedischarge) // /
							{
							case FALSE: OPR_SmootCurrcharge(TRUE,FALSE,alter_opr.settingcurrentbattery[TRUE]); //   
										break;
							case TRUE: OPR_SmootCurrdischarge(TRUE,FALSE,alter_opr.settingcurrentbattery[TRUE]); //   
							}
						alter_opr.countercycleservice[TRUE]++; //  
						break;
				case 1 ... 8: switch(indx_opr.secondchargedischarge) // /
								{
								case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //    2
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=5; //         
											alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
											break;
								case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRDISCHARGE); //  
											if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=5; //         
											alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
								}
						alter_opr.countercycleservice[TRUE]++; //  
						break;
				case 9: alter_opr.measvoltageloadedbattery[TRUE]=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //    2
						switch(indx_opr.secondchargedischarge) // /
							{
							case FALSE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //    2
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=5; //         
										alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[TRUE]>0) //    
											{
											OPR_SmootCurrcharge(TRUE,TRUE,alter_opr.settingcurrentbattery[TRUE]); //     
											}
										break;
							case TRUE: measurecurrentbattery_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRDISCHARGE); //    2 
										if((measurecurrentbattery_tmp==0)&&(alter_opr.settingcurrentbattery[TRUE]>0)) measurecurrentbattery_tmp=5; //         
										alter_opr.summacurrentbattery[TRUE]+=measurecurrentbattery_tmp; //  
										if(alter_opr.settingcurrentbattery[TRUE]>0) //    
											{
											OPR_SmootCurrdischarge(TRUE,TRUE,alter_opr.settingcurrentbattery[TRUE]); //     
											}
							}
						indxsecondcontact_tmp=OPR_ControlViolconnect(TRUE,measurecurrentbattery_tmp); //      2 
						OPR_StartConverting(FALSE,alter_opr.datanumbersensors[TRUE]); //    2 
						alter_opr.countercycleservice[TRUE]++; //  
						break;
				case 10: alter_opr.measuredvoltagebattery[TRUE]=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //     2
						if(indx_opr.secondviolacontact!=indxsecondcontact_tmp) //        2 
							{
							indx_opr.secondviolacontact=indxsecondcontact_tmp; //   
							indx_opr.updatetextstring=TRUE; //    
							}
						alter_opr.countercycleservice[TRUE]=0; //     
						indx_opr.finishsecondonecycle=TRUE; //     
				}
			}
		OPR_ControlAircooler(); //     
		}
	}

void OPR_ControlAircooler(void) //     
	{
	static byte counterworkcycles_tmp=0; // 
	byte  comparisondata_tmp=0; 
	word temperatureheatsink_tmp=0; 
	if(counterworkcycles_tmp==0) //    
		{
		comparisondata_tmp=OPRFAN_CONTROL; //    
		temperatureheatsink_tmp=OPR_ReadTemperature(0); //  
		if((temperatureheatsink_tmp>=640)&&(comparisondata_tmp<156)) comparisondata_tmp+=5; //         40*      
		else if((temperatureheatsink_tmp<640)&&(comparisondata_tmp>14)) comparisondata_tmp-=5; //       40*      
		OPRFAN_CONTROL=comparisondata_tmp; //            
		}
	counterworkcycles_tmp++; //    
	if(counterworkcycles_tmp==6) OPR_StartConverting(FALSE,0); //       5  
	else if(counterworkcycles_tmp>=12) counterworkcycles_tmp=0; //         10  
	}

void OPR_CalculationParameters(void) //      
	{
	word basicnumberdata_tmp=0; //  
	dword generalpurpose_tmp=0; 
	if(alter_opr.initialvoltagebattery[indx_opr.processnumber]==0) alter_opr.initialvoltagebattery[indx_opr.processnumber]=alter_opr.measuredvoltagebattery[indx_opr.processnumber]; //    
	generalpurpose_tmp=alter_opr.summacurrentbattery[indx_opr.processnumber]/9; //      
	alter_opr.measuredcurrentbattery[indx_opr.processnumber]=(word)generalpurpose_tmp; //     
	generalpurpose_tmp=alter_opr.summacurrentbattery[indx_opr.processnumber]*720/32400; // /      
	alter_opr.summachargebattery[indx_opr.processnumber]+=generalpurpose_tmp; // /   
	generalpurpose_tmp=alter_opr.summachargebattery[indx_opr.processnumber]/100; // /   
	alter_opr.measuredchargebattery[indx_opr.processnumber]=(word)generalpurpose_tmp; //  /     
	alter_opr.summacurrentbattery[indx_opr.processnumber]=0; //      
	alter_opr.measuredtemperature[indx_opr.processnumber]=OPR_ReadTemperature(alter_opr.datanumbersensors[indx_opr.processnumber]); //    
	if(alter_opr.initialtemperature[indx_opr.processnumber]==0) alter_opr.initialtemperature[indx_opr.processnumber]=alter_opr.measuredtemperature[indx_opr.processnumber]; //           
	generalpurpose_tmp=(dword)alter_opr.measuredtemperature[indx_opr.processnumber]*625/10000; //      
	if((word)generalpurpose_tmp>alter_opr.maximumtemperature[indx_opr.processnumber]) alter_opr.maximumtemperature[indx_opr.processnumber]=(word)generalpurpose_tmp; //   
	alter_opr.displaytemperature[indx_opr.processnumber]=(byte)generalpurpose_tmp; //     
	if(alter_opr.measuredtemperature[indx_opr.processnumber]>alter_opr.initialtemperature[indx_opr.processnumber]) //       
		{
		basicnumberdata_tmp=alter_opr.measuredtemperature[indx_opr.processnumber]-alter_opr.initialtemperature[indx_opr.processnumber]; //         
		generalpurpose_tmp=(dword)basicnumberdata_tmp*625/10000; //      
		if((word)generalpurpose_tmp>alter_opr.maximumoverheating[indx_opr.processnumber]) alter_opr.maximumoverheating[indx_opr.processnumber]=(word)generalpurpose_tmp; //     
		}
	switch(indx_opr.processnumber) //   
		{
		case FALSE: generalpurpose_tmp=(ADC_ReadingConstants(1)+OPRCIRCUIT_RESISTANCE)*(dword)alter_opr.measuredcurrentbattery[FALSE]/10000; //         1
					switch(indx_opr.firstchargedischarge) // /  1
						{
						case FALSE:	alter_opr.measvoltageloadedbattery[FALSE]-=(word)generalpurpose_tmp; //        
									if(alter_opr.measvoltageloadedbattery[FALSE]>alter_opr.measuredvoltagebattery[FALSE]) //     
										{
										basicnumberdata_tmp=alter_opr.measvoltageloadedbattery[FALSE]-alter_opr.measuredvoltagebattery[FALSE]; //     1
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[FALSE]; //    
										alter_opr.intresistancebattery[FALSE]=(word)generalpurpose_tmp; //    
										}
									else alter_opr.intresistancebattery[FALSE]=0; //   
									break;
						case TRUE: alter_opr.measvoltageloadedbattery[FALSE]+=(word)generalpurpose_tmp; //        
									if(alter_opr.measuredvoltagebattery[FALSE]>alter_opr.measvoltageloadedbattery[FALSE]) //      
										{
										basicnumberdata_tmp=alter_opr.measuredvoltagebattery[FALSE]-alter_opr.measvoltageloadedbattery[FALSE]; //     1
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[FALSE]; //    
										alter_opr.intresistancebattery[FALSE]=(word)generalpurpose_tmp; //    
										}
									else alter_opr.intresistancebattery[FALSE]=0; //   
						}
					if(((alter_opr.currentstatusprocess[FALSE]==2)||(alter_opr.currentstatusprocess[FALSE]==6))&&(alter_opr.measuredcurrentbattery[FALSE]>(alter_opr.settcapacitybattery[FALSE]/10))) //   /      0,1   1 
						{
						if((alter_opr.miniresistancebattery[FALSE]==0)&&(alter_opr.intresistancebattery[FALSE]>0)) alter_opr.miniresistancebattery[FALSE]=alter_opr.intresistancebattery[FALSE]; //      1
						else if((alter_opr.intresistancebattery[FALSE]>0)&&(alter_opr.miniresistancebattery[FALSE]>alter_opr.intresistancebattery[FALSE])) alter_opr.miniresistancebattery[FALSE]=alter_opr.intresistancebattery[FALSE]; //      1 
						if(alter_opr.maximumcurrentbattery[FALSE]<alter_opr.measuredcurrentbattery[FALSE]) alter_opr.maximumcurrentbattery[FALSE]=alter_opr.measuredcurrentbattery[FALSE]; //   /  1 
						}
					break;
		case TRUE: generalpurpose_tmp=(ADC_ReadingConstants(2)+OPRCIRCUIT_RESISTANCE)*(dword)alter_opr.measuredcurrentbattery[TRUE]/10000; //         2
					switch(indx_opr.secondchargedischarge) // /  2
						{
						case FALSE: alter_opr.measvoltageloadedbattery[TRUE]-=(word)generalpurpose_tmp; //        
									if(alter_opr.measvoltageloadedbattery[TRUE]>alter_opr.measuredvoltagebattery[TRUE]) //     
										{
										basicnumberdata_tmp=alter_opr.measvoltageloadedbattery[TRUE]-alter_opr.measuredvoltagebattery[TRUE]; //     2
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[TRUE]; //    
										alter_opr.intresistancebattery[TRUE]=(word)generalpurpose_tmp; //   
										}
									else alter_opr.intresistancebattery[TRUE]=0; //  
									break;
						case TRUE: alter_opr.measvoltageloadedbattery[TRUE]+=(word)generalpurpose_tmp; //        
									if(alter_opr.measuredvoltagebattery[TRUE]>alter_opr.measvoltageloadedbattery[TRUE]) //     
										{
										basicnumberdata_tmp=alter_opr.measuredvoltagebattery[TRUE]-alter_opr.measvoltageloadedbattery[TRUE]; //     2
										generalpurpose_tmp=(dword)basicnumberdata_tmp*1000/(dword)alter_opr.measuredcurrentbattery[TRUE]; //    
										alter_opr.intresistancebattery[TRUE]=(word)generalpurpose_tmp; //   
										}
									else alter_opr.intresistancebattery[TRUE]=0; //   
						}
					if(((alter_opr.currentstatusprocess[TRUE]==2)||(alter_opr.currentstatusprocess[TRUE]==6))&&(alter_opr.measuredcurrentbattery[TRUE]>(alter_opr.settcapacitybattery[TRUE]/10))) //   /      0,1   2 
						{
						if((alter_opr.miniresistancebattery[TRUE]==0)&&(alter_opr.intresistancebattery[TRUE]>0)) alter_opr.miniresistancebattery[TRUE]=alter_opr.intresistancebattery[TRUE]; //      2 
						else if((alter_opr.intresistancebattery[TRUE]>0)&&(alter_opr.miniresistancebattery[TRUE]>alter_opr.intresistancebattery[TRUE])) alter_opr.miniresistancebattery[TRUE]=alter_opr.intresistancebattery[TRUE]; //      2 
						if(alter_opr.maximumcurrentbattery[TRUE]<alter_opr.measuredcurrentbattery[TRUE]) alter_opr.maximumcurrentbattery[indx_opr.processnumber]=alter_opr.measuredcurrentbattery[indx_opr.processnumber]; //   /  2 
						}
		}
	}

bit OPR_DetectBattery(void) //    
	{
	bit indxconnectbattery_tmp=FALSE; //  
	bit indxcancellsearch_tmp=FALSE; 
	word settingcurrent_tmp=1; 
	word measurevoltage_tmp=0; 
	word measurecurrent_tmp=0; 
	word detectvoltage_tmp=0;
	switch(alter_opr.countertypebattery[indx_opr.processnumber]) //  
		{
		case 0 ... 1: detectvoltage_tmp=OPRDETECTNMC_VOLTAGE; //    Ni-Mh  Ni-Cd  
				break;
		case 2 ... 3: detectvoltage_tmp=OPRDETECTLPI_VOLTAGE; //    Li-Po  Li-Ion  
				break;
		case 4: detectvoltage_tmp=OPRDETECTLFE_VOLTAGE; //    Li-Fe  
		}
	while(indxcancellsearch_tmp==FALSE) //    
		{
		OPR_SmootCurrcharge(indx_opr.settingnumber,FALSE,settingcurrent_tmp); //      
		SYS_TimeWaiting(10); // 10    
		switch(indx_opr.processnumber) //   
			{
			case FALSE: measurevoltage_tmp=ADC_MeasureVoltage(10,ADCFIRST_VOLTAGE); //   1 
						measurecurrent_tmp=ADC_MeasureCurrent(10,ADCFIRST_CURRCHARGE); //   1 
						break;
			case TRUE: measurevoltage_tmp=ADC_MeasureVoltage(10,ADCSECOND_VOLTAGE); //   2 
						measurecurrent_tmp=ADC_MeasureCurrent(10,ADCSECOND_CURRCHARGE); //   2 
			}
		if(measurevoltage_tmp<detectvoltage_tmp) //       
			{
			if(measurecurrent_tmp>10) //   10  
				{
				indxcancellsearch_tmp=TRUE; //        
				indxconnectbattery_tmp=TRUE; //    
				}
			else //   10  
				{
				OPR_SmootCurrcharge(indx_opr.settingnumber,TRUE,settingcurrent_tmp); //      
				settingcurrent_tmp++; //         
				}
			}
		else indxcancellsearch_tmp=TRUE; //             1700  
		}
	OPR_SmootCurrcharge(indx_opr.settingnumber,TRUE,settingcurrent_tmp); //      
	return indxconnectbattery_tmp; //  /  
	}

void OPR_ControlWorkcycle(byte datacodecontrol_prm) //     
	{
	switch(datacodecontrol_prm) //    
		{
		case 1: switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //       
					{
					case 0: OPR_DecodeLeftbutton(); //  Left      
							break;
					case 1 ... 3: asm("nop"); // 
							break;
					case 4: OPR_DecodeLeftbutton(); //  Left       
							indx_opr.updateparameters=TRUE; //    
							break;
					case 5 ... 6: asm("nop"); // 
					}
				break;
		case 2: switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //       
					{
					case 0: OPR_DecodeRigtbutton(); //  Rigt      
							break;
					case 1 ... 3: asm("nop"); // 
							break;
					case 4: OPR_DecodeRigtbutton(); //  Rigt       
							indx_opr.updateparameters=TRUE; //    
							break;
					case 5 ... 6: asm("nop"); // 
					}
				break;
		case 3: OPR_DecodeUpbutton(); //  Up 
				break;
		case 4: OPR_DecodeDownbutton(); //  Down 
				break;
		case 5: OPR_DecodeEnterbutton(); //  Enter 
		}
	if(indx_opr.updatetextstring==TRUE) //     1 
		{
		switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //    
			{
			case 0: alter_opr.locationcursorline[indx_opr.settingnumber]=0; //  
					break;
			case 1: alter_opr.locationcursorline[indx_opr.settingnumber]=4; //     
					break;
			case 2: if(alter_opr.counteroutitems[indx_opr.settingnumber]==0) alter_opr.locationcursorline[indx_opr.settingnumber]=9; //    
					else alter_opr.locationcursorline[indx_opr.settingnumber]=6; //          
					break;
			case 3: alter_opr.locationcursorline[indx_opr.settingnumber]=7; //      
					break;
			case 4: alter_opr.locationcursorline[indx_opr.settingnumber]=8; //      
					break;
			case 5: alter_opr.locationcursorline[indx_opr.settingnumber]=9; //      
			}
		}
	}

void OPR_SmootCurrcharge(bit numberbattery_prm,bit settingdirect_prm,word numbercycles_prm) //     
	{
	byte countcycledirect_tmp=0; // 
	word comparedata_tmp=0;
	switch(numberbattery_prm) //  
		{
		case FALSE:	comparedata_tmp=OPRFIRST_CHARGE; //       1
					break;
		case TRUE:	comparedata_tmp=OPRSECOND_CHARGE; //       2
		}
	switch(settingdirect_prm) //   
		{
		case FALSE:	while(countcycledirect_tmp<numbercycles_prm) //     
							{
							if(comparedata_tmp<1023) comparedata_tmp++; //     
							switch(numberbattery_prm) //   
								{
								case FALSE:	OPRFIRST_CHARGE=comparedata_tmp; //      1
											break;
								case TRUE: OPRSECOND_CHARGE=comparedata_tmp; //      2
								}
							SYS_TimeWaiting(1); // 1 
							countcycledirect_tmp++; //  
							} 
					break;
		case TRUE:  while(countcycledirect_tmp<numbercycles_prm) //     
							{
							if(comparedata_tmp>0) comparedata_tmp--; //     
							switch(numberbattery_prm) //     
								{
								case FALSE: OPRFIRST_CHARGE=comparedata_tmp; //      1
											break;
								case TRUE: OPRSECOND_CHARGE=comparedata_tmp; //      2
								}
							SYS_TimeWaiting(1); // 1 
							countcycledirect_tmp++; //  
							}
		}
	}

void OPR_SmootCurrdischarge(bit numberbattery_prm,bit settingdirect_prm,word numbercycles_prm) //    
	{
	byte countcycledirect_tmp=0; // 
	word comparedata_tmp=0;
	switch(numberbattery_prm) //  
		{
		case FALSE:	comparedata_tmp=OPRFIRST_DISCHARGE; //       1
					break;
		case TRUE:	comparedata_tmp=OPRSECOND_DISCHARGE; //       2
		}
	switch(settingdirect_prm) //   
		{
		case FALSE:	while(countcycledirect_tmp<numbercycles_prm) //    
						{
						if(comparedata_tmp>1) comparedata_tmp--; //      
						switch(numberbattery_prm) //   
							{
							case FALSE:	OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
							case TRUE: OPRSECOND_DISCHARGE=comparedata_tmp; //      2
							}
						SYS_TimeWaiting(1); // 1 
						countcycledirect_tmp++; //  
						}
					break;
		case TRUE:  while(countcycledirect_tmp<numbercycles_prm) //     
						{
						if(comparedata_tmp<254) comparedata_tmp++; //     254 
						switch(numberbattery_prm) //   
							{
							case FALSE: OPRFIRST_DISCHARGE=comparedata_tmp; //      1
										break;
							case TRUE: OPRSECOND_DISCHARGE=comparedata_tmp; //      2
							}
						SYS_TimeWaiting(1); // 1 
						countcycledirect_tmp++; //  
						}
		}
	}

void OPR_OutitemBatterytype(void) //    
	{
	byte datanumbersensors_tmp=0; // 
	switch(alter_opr.countertypebattery[indx_opr.settingnumber]) //   
		{
		case 0: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Ni-Mh ,      
					{
					switch(indx_opr.settingnumber) //   
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchSensors(1); //  Ni-Mh  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchSensors(6); //  Ni-Mh  2 
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Ni-Mh  
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //     
					{
					case 0: SYM_LineOut(9,0,FALSE,indx_opr.settingnumber,3); //      : : .?? Ni-Mh 
							OPR_BlockingOutitems(); //     
							break;
					case 1 ... 10: SYM_LineOut(9,0,FALSE,indx_opr.settingnumber,2); //      1  10   : : .  Ni-Mh 
							OPR_UnblockingOutitems(); //     
							break;
					case 11 ... 50: asm("nop"); // 
					}
				break;
		case 1: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Ni-Cd ,      
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchSensors(11); //  Ni-Cd  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchSensors(16); //  Ni-Cd  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Ni-Cd  
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //     
					{
					case 0: SYM_LineOut(10,0,FALSE,indx_opr.settingnumber,3); //      : : .?? Ni-Cd 
							OPR_BlockingOutitems(); //     
							break;
					case 1 ... 10: asm("nop"); //  
							break;
					case 11 ... 20: SYM_LineOut(10,0,FALSE,indx_opr.settingnumber,2); //      11  20   : : .  Ni-Cd  
							OPR_UnblockingOutitems(); //     
							break;
					case 21 ... 50: asm("nop"); //  
					}
				break;
		case 2: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Po ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchSensors(21); //  Li-Po  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchSensors(26); //  Li-Po  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Po  
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //     
					{
					case 0: SYM_LineOut(11,0,FALSE,indx_opr.settingnumber,3); //  Li-Po     : : .?? Li-Po 
							OPR_BlockingOutitems(); //     
							break;
					case 1 ... 20: asm("nop"); // 
							break;
					case 21 ... 30: SYM_LineOut(11,0,FALSE,indx_opr.settingnumber,2); //      21  30   : : .  Li-Po 
							OPR_UnblockingOutitems(); //     
							break;
					case 31 ... 50: asm("nop"); // 
					}
				break;
		case 3: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Ion ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchSensors(31); //  Li-Ion  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchSensors(36); //  Li-Ion  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Ion 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0: SYM_LineOut(12,0,FALSE,indx_opr.settingnumber,3); //      : : .?? Li-Ion 
							OPR_BlockingOutitems(); //     
							break;
					case 1 ... 30: asm("nop"); //  
							break;
					case 31 ... 40: SYM_LineOut(12,0,FALSE,indx_opr.settingnumber,2); //      31  40   : : .  Li-Ion 
							OPR_UnblockingOutitems(); //     
							break;
					case 41 ... 50: asm("nop"); // 
					}
				break;
		case 4: if(alter_opr.datanumbersensors[indx_opr.settingnumber]==0) // Li-Fe ,     
					{
					switch(indx_opr.settingnumber) //  
						{
						case FALSE: datanumbersensors_tmp=OPR_SearchSensors(41); //  Li-Fe  1
									break;
						case TRUE: datanumbersensors_tmp=OPR_SearchSensors(46); //  Li-Fe  2
						}
					alter_opr.datanumbersensors[indx_opr.settingnumber]=datanumbersensors_tmp; //   Li-Fe 
					}
				switch(alter_opr.datanumbersensors[indx_opr.settingnumber]) //    
					{
					case 0: SYM_LineOut(13,0,FALSE,indx_opr.settingnumber,3); //      : : .?? Li-Fe 
							OPR_BlockingOutitems(); //    
							break;
					case 1 ... 40: asm("nop"); //  
							break;
					case 41 ... 50: SYM_LineOut(13,0,FALSE,indx_opr.settingnumber,2); //      41  50   : : .  Li-Fe
							OPR_UnblockingOutitems(); //    
					}
		}
	}



void OPR_OutitemBatterymode(void) //     
	{
	switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //     
		{
		case 0: SYM_LineOut(25,0,FALSE,indx_opr.settingnumber,1); // : :  ./.
				break;
		case 1: SYM_LineOut(26,0,FALSE,indx_opr.settingnumber,1); // : :  
				break;
		case 2: SYM_LineOut(27,0,FALSE,indx_opr.settingnumber,1); // : :   
				break;
		case 3: SYM_LineOut(29,0,FALSE,indx_opr.settingnumber,1); // : :  
				break;
		case 4: SYM_LineOut(38,0,FALSE,indx_opr.settingnumber,1); // : :  
		}
	switch(indx_opr.settingnumber) //  
		{
		case FALSE: if(indx_opr.lockfirstonlycharge==FALSE) //   
						{
						if(alter_opr.countermodebattery[FALSE]==2) indx_opr.onlyfirstcharging=TRUE; //         1
						else indx_opr.onlyfirstcharging=FALSE; //     
						}
					break;
		case TRUE: if(indx_opr.locksecondonlycharge==FALSE) //   
						{
						if(alter_opr.countermodebattery[TRUE]==2) indx_opr.onlysecondcharging=TRUE; //         2
						else indx_opr.onlysecondcharging=FALSE; //     
						}
		}
	}

void OPR_OutserviceBatterymode(void) //     
	{
	bit indxchargedischarge_tmp=FALSE; //  
	bit indxoutstatus_tmp=FALSE; 
	byte outcodesymbol_tmp=0; 
	switch(indx_opr.settingnumber) //  
		{
		case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1
					break;
		case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2
		}
	switch(alter_opr.counteroutparameter[indx_opr.settingnumber]) //   
		{
		case 0: switch(indxchargedischarge_tmp) //  / 
					{
					case FALSE: outcodesymbol_tmp=20; //  : :       
								break;
					case TRUE: outcodesymbol_tmp=19; //  : :  -     
					}
				indxoutstatus_tmp=TRUE; //     
				indx_opr.updateparameters=TRUE; //   
				break;
		case 1: switch(indxchargedischarge_tmp) //  / 
					{
					case FALSE: outcodesymbol_tmp=16; //  : :   ,    
								break;
					case TRUE: outcodesymbol_tmp=15; //  : :   ,    	
					}
				indxoutstatus_tmp=TRUE; //     
				indx_opr.updateparameters=TRUE; //   
				break;
		case 2: switch(indxchargedischarge_tmp) //  / 
					{
					case FALSE: outcodesymbol_tmp=18; //  : :       
								break;
					case TRUE: outcodesymbol_tmp=17; //  : : -     
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 3: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: outcodesymbol_tmp=41; //  : :   ,    
								break;
					case TRUE: outcodesymbol_tmp=40; //  : :   ,    
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 4: switch(indxchargedischarge_tmp) //  / 
					{
					case FALSE: outcodesymbol_tmp=22; //  : :        
								break;
					case TRUE: outcodesymbol_tmp=21; //  : :      
					}
				indx_opr.updateparameters=TRUE; //   
				break;
		case 5: outcodesymbol_tmp=14; //  : :       
				indx_opr.updateparameters=TRUE; //   
				break;
		case 6: OPR_OutitemBatterytype(); //   
				break;
		case 7: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: outcodesymbol_tmp=32; //  : :  
								break;
					case TRUE: outcodesymbol_tmp=30; //  : :  
					}
				break;
		case 8: switch(indxchargedischarge_tmp) //  /
					{
					case FALSE: outcodesymbol_tmp=33; //  : :  
								break;
					case TRUE: outcodesymbol_tmp=31; //  : :  
					}
		}
	if(outcodesymbol_tmp>0) SYM_LineOut(outcodesymbol_tmp,alter_opr.currentstatusprocess[indx_opr.settingnumber],indxoutstatus_tmp,indx_opr.settingnumber,1); //   
	}

void OPR_OutserviceParameters(void) //     
  	{
	switch(alter_opr.counteroutparameter[indx_opr.settingnumber]) //   
		{
		case 0: SYM_OutdataNumber0000(alter_opr.measuredcurrentbattery[indx_opr.settingnumber],9); // /   
				break;
		case 1: SYM_OutdataNumber00_000(alter_opr.measuredvoltagebattery[indx_opr.settingnumber],8); //   
				break;
		case 2: SYM_OutdataNumber00000(alter_opr.measuredchargebattery[indx_opr.settingnumber],7); //      
				break;
		case 3: SYM_OutdataNumber0_000(alter_opr.intresistancebattery[indx_opr.settingnumber],7); //    
				break;
		case 4: SYM_OutdataNumber00(alter_opr.displaytemperature[indx_opr.settingnumber],11); //   
				break;
		case 5: SYM_OutdataNumber00000(alter_opr.settcapacitybattery[indx_opr.settingnumber],6); //   
				break;
		case 6 ... 8: asm("nop"); //  
		}
	} 

void OPR_DecodeLeftbutton(void) //   Left
	{
	byte countposition_tmp=0; // 
	countposition_tmp=alter_opr.counterpositioncursor[indx_opr.settingnumber]; //    
	switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //  
		{
		case 0: if(countposition_tmp>0) countposition_tmp--; //         
				else countposition_tmp=2; //     
				break;
		case 1: if(countposition_tmp>0) countposition_tmp--; //         
				else countposition_tmp=5; //     
				break;
		case 2: switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //     
					{
					case 0 ... 2: if(countposition_tmp>0) countposition_tmp--; //          
							else countposition_tmp=2; //      
							break;
					case 3 ... 4: asm("nop"); //  
					}
				break;
		case 3 ... 4: switch(countposition_tmp) //            
						{
						case 0: countposition_tmp=1; //   
								break;
						case 1: countposition_tmp=0; //   
						}
		}
	indx_opr.updatetextstring=TRUE; //    
	alter_opr.counterpositioncursor[indx_opr.settingnumber]=countposition_tmp; //        
	}

void OPR_DecodeRigtbutton(void) //   Rigt 
	{
	byte countposition_tmp=0; // 
	countposition_tmp=alter_opr.counterpositioncursor[indx_opr.settingnumber]; //   
	switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //  
		{
		case 0: countposition_tmp++; //      
				if(countposition_tmp>2) countposition_tmp=0; //    
				break;
		case 1: countposition_tmp++; //      
				if(countposition_tmp>5)  countposition_tmp=0; //    
				break;
		case 2: switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //    
					{
					case 0 ... 2: countposition_tmp++; //       
							if(countposition_tmp>2)  countposition_tmp=0; //    
							break;
					case 3 ... 4: asm("nop"); //  
					}
				break;
		case 3 ... 4: switch(countposition_tmp) //            
						{
						case 0: countposition_tmp=1; //   
								break;
						case 1: countposition_tmp=0; //   
						}
		}
	indx_opr.updatetextstring=TRUE; //    
	alter_opr.counterpositioncursor[indx_opr.settingnumber]=countposition_tmp; //       
	}

void OPR_DecodeUpbutton(void) //   Up 
	{
	switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //    
		{
		case 0: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //   
					{
					case 0: if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2
							else indx_opr.settingnumber=FALSE; //      1
							break;
					case 1: switch(indx_opr.settingnumber) //   
								{
								case FALSE:	switch(indx_opr.outputfirstprotocol) //  /  1 
												{
												case FALSE:	if(indx_opr.blockfirstoutitems==TRUE) //        1  
																{
																alter_opr.counteroutitems[FALSE]++; //     
																if(alter_opr.counteroutitems[FALSE]>4) alter_opr.counteroutitems[FALSE]=0; //    4-
																}
															else asm("nop"); //       
															break;
												case TRUE: alter_opr.counteritemprotocol[FALSE]++; //     1 
															if(alter_opr.counteritemprotocol[FALSE]>17) alter_opr.counteritemprotocol[FALSE]=0; //      17-
												}
											break;
								case TRUE: switch(indx_opr.outputsecondprotocol) //  /  2 
												{			
												case FALSE: if(indx_opr.blocksecondoutitems==TRUE) //        2  
																{
																alter_opr.counteroutitems[TRUE]++; //    
																if(alter_opr.counteroutitems[TRUE]>4) alter_opr.counteroutitems[TRUE]=0; //    4-
																} 
															else asm("nop"); //      
															break;
												case TRUE: alter_opr.counteritemprotocol[TRUE]++; //     2 
															if(alter_opr.counteritemprotocol[TRUE]>17) alter_opr.counteritemprotocol[TRUE]=0; //      17-
												}
								}
							break;
					case 2: switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //  
								{
								case 0: alter_opr.countertypebattery[indx_opr.settingnumber]++; //   
										if(alter_opr.countertypebattery[indx_opr.settingnumber]>4) alter_opr.countertypebattery[indx_opr.settingnumber]=0; //    4-  
										alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //       
										break;
								case 1: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<55536) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=10000; //     10000 
										break;
								case 2: alter_opr.countermodebattery[indx_opr.settingnumber]++; //    
										if(((eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])>0)&&(alter_opr.countermodebattery[indx_opr.settingnumber]>4))||((eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])==0)&&(alter_opr.countermodebattery[indx_opr.settingnumber]>2)))
											{
											alter_opr.countermodebattery[indx_opr.settingnumber]=0; //         ,      4-
											}
										break;
								case 3: asm("nop"); // 
								}
							break;
					case 3: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<64536) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=1000; //     1000 
							break;
					case 4: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<65436) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=100; //     100 
							break;
					case 5: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]<65526) alter_opr.settcapacitybattery[indx_opr.settingnumber]+=10; //     10 
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 1 ... 3: asm("nop"); // 
				break;
		case 4: if(alter_opr.counterpositioncursor[indx_opr.settingnumber]==0) //   
					{
					if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2
					else indx_opr.settingnumber=FALSE; //      1
					}
				else //     
					{
					alter_opr.counteroutparameter[indx_opr.settingnumber]++; //      
					if(((eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])>0)&&(alter_opr.counteroutparameter[indx_opr.settingnumber]>7))||((eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])==0)&&(alter_opr.counteroutparameter[indx_opr.settingnumber]>8))) 
						{
						alter_opr.counteroutparameter[indx_opr.settingnumber]=0; //        ,      7- 
						}
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 5 ... 6: asm("nop"); // 
		}
	}

void OPR_DecodeDownbutton(void) //   Down
	{
	switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //     
		{
		case 0: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //      
					{
					case 0: if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; //      2 
							else indx_opr.settingnumber=FALSE; //      1 
							break;
					case 1: switch(indx_opr.settingnumber) //   
								{
								case FALSE: switch(indx_opr.outputfirstprotocol) //  /  1 
												{
												case FALSE:	if(indx_opr.blockfirstoutitems==TRUE) //        1  
																{
																if(alter_opr.counteroutitems[FALSE]>0) alter_opr.counteroutitems[FALSE]--; //      
																else alter_opr.counteroutitems[FALSE]=4; //    
																}
															else asm("nop"); //      
															break;
												case TRUE: if(alter_opr.counteritemprotocol[FALSE]>0) alter_opr.counteritemprotocol[FALSE]--; //     1    
															else alter_opr.counteritemprotocol[FALSE]=17; //  17-   
												}
											break;
								case TRUE: switch(indx_opr.outputsecondprotocol) //  /  2 
												{
												case FALSE:	if(indx_opr.blocksecondoutitems==TRUE) //        2  
																{
																if(alter_opr.counteroutitems[TRUE]>0) alter_opr.counteroutitems[TRUE]--; //      
																else alter_opr.counteroutitems[TRUE]=4; //    
																}
															else asm("nop"); //      
															break;
												case TRUE: if(alter_opr.counteritemprotocol[TRUE]>0) alter_opr.counteritemprotocol[TRUE]--; //     2    
															else alter_opr.counteritemprotocol[TRUE]=17; //  17-   
												}
								}
							break;
					case 2: switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //   
								{
								case 0: if(alter_opr.countertypebattery[indx_opr.settingnumber]>0) alter_opr.countertypebattery[indx_opr.settingnumber]--; //       
										else alter_opr.countertypebattery[indx_opr.settingnumber]=4; //       
										alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //       
										break;
								case 1: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>9999) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=10000; //     10000 
										break;
								case 2: if(alter_opr.countermodebattery[indx_opr.settingnumber]>0) alter_opr.countermodebattery[indx_opr.settingnumber]--; //     
										else //    
											{
											if(eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])>0) alter_opr.countermodebattery[indx_opr.settingnumber]=4; //       
											else if(eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])==0) alter_opr.countermodebattery[indx_opr.settingnumber]=2; //      
											}
										break;
								case 3: asm("nop"); // 
								}
							break;
					case 3: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>999) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=1000; //     1000 
							break;
					case 4: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>99) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=100; //     100 
							break;
					case 5: if(alter_opr.settcapacitybattery[indx_opr.settingnumber]>9) alter_opr.settcapacitybattery[indx_opr.settingnumber]-=10; //     10 
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 1 ... 3:	asm("nop"); // 
				break;
		case 4: if(alter_opr.counterpositioncursor[indx_opr.settingnumber]==0) //   
					{
					if(indx_opr.settingnumber==FALSE) indx_opr.settingnumber=TRUE; ////      2
					else indx_opr.settingnumber=FALSE; //      1 
					}
				else //     
					{
					if(alter_opr.counteroutparameter[indx_opr.settingnumber]>0) alter_opr.counteroutparameter[indx_opr.settingnumber]--; //      
					else //     
						{
						if(eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])>0) alter_opr.counteroutparameter[indx_opr.settingnumber]=7; //        
						else if(eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])==0) alter_opr.counteroutparameter[indx_opr.settingnumber]=8; //        
						}
					}
				indx_opr.updatetextstring=TRUE; //   
				break;
		case 5 ... 6: asm("nop"); // 
		}
	}

void OPR_DecodeEnterbutton(void) //   Enter
	{
	switch(alter_opr.counterworkcycle[indx_opr.settingnumber]) //    
		{
		case 0: switch(alter_opr.counteroutitems[indx_opr.settingnumber]) //   
					{
					case 0: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //   
								{
								case 0: SYS_SwitchWorkmode(); //       
										break;
								case 1 ... 2: asm("nop"); //  
								}
							break;
					case 1: asm("nop"); //  
							break;
					case 2: switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //   
								{
								case 0 ... 2: asm("nop"); //  
										break;
								case 3: OPR_ReadvalueDeferred(); //     ""
										alter_opr.counteroutitems[indx_opr.settingnumber]++; //          
										break;
								case 4: eeprom_write_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber],0); //        "" 
										alter_opr.counteroutitems[indx_opr.settingnumber]=0; //        
										alter_opr.countermodebattery[indx_opr.settingnumber]=0; //     
								}
							alter_opr.counterpositioncursor[indx_opr.settingnumber]=1; //      
							indx_opr.updatetextstring=TRUE; //    
							break;
					case 3: switch(indx_opr.settingnumber) //  
								{
								case FALSE: if(alter_opr.settcapacitybattery[FALSE]>49) indx_opr.startfirstservices=TRUE; //     1    50    
											else asm("nop"); //  
											break;
								case TRUE: if(alter_opr.settcapacitybattery[TRUE]>49) indx_opr.startsecondservices=TRUE; //     2    50    
											else asm("nop"); //  
								}
							indx_opr.updatetextstring=TRUE; //    
							break;
					case 4: switch(alter_opr.counterpositioncursor[indx_opr.settingnumber]) //   
								{
								case 0: asm("nop"); //  
										break;
								case 1:	switch(indx_opr.settingnumber) //   
											{
											case FALSE: if(indx_opr.outputfirstprotocol==FALSE) //       1  
															{
															indx_opr.outputfirstprotocol=TRUE; //      
															if(alter_opr.counteritemprotocol[FALSE]>0) alter_opr.counteritemprotocol[FALSE]=0; //      
															}
														else indx_opr.outputfirstprotocol=FALSE; //       
														break;
											case TRUE: if(indx_opr.outputsecondprotocol==FALSE) //       2  
															{
															indx_opr.outputsecondprotocol=TRUE; //     
															if(alter_opr.counteritemprotocol[TRUE]>0) alter_opr.counteritemprotocol[TRUE]=0; //      
															}
														else indx_opr.outputsecondprotocol=FALSE; //        
											}
										indx_opr.updatetextstring=TRUE; //    
								}
					}
				break;
		case 1 ... 3:	asm("nop"); //  
				break;
		case 4: switch(alter_opr.counteroutparameter[indx_opr.settingnumber]) //  
					{
					case 0 ... 6: asm("nop"); // 
							break;
					case 7: switch(indx_opr.settingnumber) //  
								{
								case FALSE: if(indx_opr.stopfirstservices==FALSE) indx_opr.stopfirstservices=TRUE; //     1
											break;
								case TRUE: if(indx_opr.stopsecondservices==FALSE) indx_opr.stopsecondservices=TRUE; //     2
								}
							break;
					case 8: switch(indx_opr.settingnumber) //  
								{
								case FALSE: if(indx_opr.postponefirstservice==FALSE) indx_opr.postponefirstservice=TRUE; //     1
											break;
								case TRUE: if(indx_opr.postponesecondservice==FALSE) indx_opr.postponesecondservice=TRUE; //     2
								}
					}
				switch(indx_opr.settingnumber) //  
					{
					case FALSE: if((indx_opr.firstviolacontact==TRUE)&&(indx_opr.stopfirstservices==FALSE)) indx_opr.stopfirstservices=TRUE; //           1 
								break;
					case TRUE: if((indx_opr.secondviolacontact==TRUE)&&(indx_opr.stopsecondservices==FALSE)) indx_opr.stopsecondservices=TRUE; //           2 
					}
				break;
		case 5 ... 6: asm("nop"); // 
		}
	}

void OPR_ResetVariables(void) //   
	{
	switch(indx_opr.settingnumber) //   
		{
		case FALSE: indx_opr.finishfirstonecycle=FALSE; //   1 
					indx_opr.firstchargedischarge=FALSE; 
					indx_opr.connectfirstbattery=FALSE; 
					indx_opr.startfirstservices=FALSE; 
					indx_opr.stopfirstservices=FALSE; 
					indx_opr.postponefirstservice=FALSE; 
					indx_opr.onlyfirstcharging=FALSE; 
					indx_opr.lockfirstonlycharge=FALSE; 
					indx_opr.blockfirstoutitems=FALSE; 
					indx_opr.outputfirstprotocol=FALSE; 
					indx_opr.firstfullservice=FALSE; 
					indx_opr.firstviolacontact=FALSE; 
					break;
		case TRUE: indx_opr.finishsecondonecycle=FALSE; //   2 
					indx_opr.secondchargedischarge=FALSE; 
					indx_opr.connectsecondbattery=FALSE; 
					indx_opr.startsecondservices=FALSE; 
					indx_opr.stopsecondservices=FALSE; 
					indx_opr.postponesecondservice=FALSE; 
					indx_opr.onlysecondcharging=FALSE; 
					indx_opr.locksecondonlycharge=FALSE; 
					indx_opr.blocksecondoutitems=FALSE; 
					indx_opr.outputsecondprotocol=FALSE; 
					indx_opr.secondfullservice=FALSE; 
					indx_opr.secondviolacontact=FALSE; 
		}
	OPR_ResetExternaldata(indx_opr.settingnumber); //  
	if((indx_opr.startfirstservices==FALSE)&&(indx_opr.startsecondservices==FALSE)&&(indx_opr.onoffworkingservice==TRUE)) OPR_StartstopWorkcycle(FALSE); //    
	indx_opr.updatetextstring=TRUE; //     
	indx_opr.updateparameters=FALSE; //    
	indx_opr.prioritycomplete=FALSE; //     
	alter_opr.counteritemprotocol[indx_opr.settingnumber]=0; //    
	alter_opr.counterworkcycle[indx_opr.settingnumber]=0; //       
	alter_opr.countgeneralpurpose[0]=0; //    1
	alter_opr.countgeneralpurpose[1]=0; //    2 
	alter_opr.currentstatusprocess[indx_opr.settingnumber]=0; //   
	alter_opr.datanumbersensors[indx_opr.settingnumber]=0; //      
	alter_opr.increaseratevoltage[indx_opr.settingnumber]=0; //     
	alter_opr.increasetemperature[indx_opr.settingnumber]=0; //     
	alter_opr.initialtemperature[indx_opr.settingnumber]=0; //     
	alter_opr.counterpositioncursor[indx_opr.settingnumber]=0; //   
	alter_opr.locationcursorline[indx_opr.settingnumber]=0; //   
	alter_opr.counteroutitems[indx_opr.settingnumber]=0; //   
	alter_opr.countertypebattery[indx_opr.settingnumber]=0; //   
	alter_opr.countermodebattery[indx_opr.settingnumber]=0; //   
	alter_opr.counteroutparameter[indx_opr.settingnumber]=0; //       
	alter_opr.measuredtemperature[indx_opr.settingnumber]=0; //    
	alter_opr.displaytemperature[indx_opr.settingnumber]=0; //     
	alter_opr.measuredcurrentbattery[indx_opr.settingnumber]=0; //    
	alter_opr.maximumcurrentbattery[indx_opr.settingnumber]=0; //    /  
	alter_opr.measuredvoltagebattery[indx_opr.settingnumber]=0; //      
	alter_opr.measvoltageloadedbattery[indx_opr.settingnumber]=0; //     
	alter_opr.initialvoltagebattery[indx_opr.settingnumber]=0; //    /  
	alter_opr.measuredchargebattery[indx_opr.settingnumber]=0; //    
	alter_opr.maximumtemperature[indx_opr.settingnumber]=0; //     
	alter_opr.maximumoverheating[indx_opr.settingnumber]=0; //      
	alter_opr.summacurrentbattery[indx_opr.settingnumber]=0; //     
	alter_opr.summachargebattery[indx_opr.settingnumber]=0; //     
	alter_opr.settingcurrentbattery[indx_opr.settingnumber]=0; //    / 
	alter_opr.intresistancebattery[indx_opr.settingnumber]=0; //     
	alter_opr.miniresistancebattery[indx_opr.settingnumber]=0; //      
	alter_opr.countercycleservice[indx_opr.settingnumber]=0; //       
	alter_opr.settcapacitybattery[indx_opr.settingnumber]=100; //     
	}

void OPR_ResetExternaldata(bit indxnumberbattery_prm) //    
	{
	switch(alter_opr.countertypebattery[indxnumberbattery_prm]) //   
		{
		case 0 ... 1: NMC_ResetVariables(indxnumberbattery_prm); //   Ni-Mh  Ni-Cd  
				break;
		case 2 ... 3: LPI_ResetVariables(indxnumberbattery_prm); //   Li-Po  Li-Ion  
				break;
		case 4: LFE_ResetVariables(indxnumberbattery_prm); //   Li-Fe  
		}
	}

void OPR_ReadvalueDeferred(void) //      
	{
	bit indxchargedischarge_tmp=FALSE; //  
	byte indxonlycharging_tmp=0; 
	byte indxfullcharging_tmp=0; 
	if(eeprom_read_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber])>0) //     
		{
		alter_opr.countertypebattery[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[0][indx_opr.settingnumber]); //   
		alter_opr.countermodebattery[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[1][indx_opr.settingnumber]); //   
		alter_opr.currentstatusprocess[indx_opr.settingnumber]=eeprom_read_byte(&Opr_TypemodeBattery[2][indx_opr.settingnumber]); //    
		alter_opr.settcapacitybattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_SettingCapacity[indx_opr.settingnumber]); //   
		alter_opr.summachargebattery[indx_opr.settingnumber]=eeprom_read_dword(&Opr_SummaChargedischarge[indx_opr.settingnumber]); // /   
		alter_opr.initialvoltagebattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[0][indx_opr.settingnumber]); //     
		alter_opr.maximumcurrentbattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[1][indx_opr.settingnumber]); //     
		alter_opr.miniresistancebattery[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[2][indx_opr.settingnumber]); //      
		alter_opr.maximumtemperature[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[3][indx_opr.settingnumber]); //     
		alter_opr.maximumoverheating[indx_opr.settingnumber]=eeprom_read_word(&Opr_ParametersDeferred[4][indx_opr.settingnumber]); //      
		eeprom_write_byte(&Opr_IndexoutDeferred[indx_opr.settingnumber],0); //       
		switch(alter_opr.countermodebattery[indx_opr.settingnumber]) //   
			{
			case 0 ... 1: indxchargedischarge_tmp=TRUE; //     
					break;
			case 2: indxchargedischarge_tmp=FALSE; //     
					break;
			case 3 ... 4: asm("nop"); // 
			}
		switch(indx_opr.settingnumber) //  
			{
			case FALSE: indxonlycharging_tmp=eeprom_read_byte(&Opr_IndxonlyCharging[FALSE]); //      1 
						if(indxonlycharging_tmp==0) indx_opr.onlyfirstcharging=FALSE; //       
						else indx_opr.onlyfirstcharging=TRUE; //   
						indx_opr.lockfirstonlycharge=TRUE; //         1
						indxfullcharging_tmp=eeprom_read_byte(&Opr_IndxfullCharging[FALSE]); //      1 
						if(indxfullcharging_tmp==0) indx_opr.firstfullservice=FALSE; //         
						else indx_opr.firstfullservice=TRUE; //    
						break;
			case TRUE: indxonlycharging_tmp=eeprom_read_byte(&Opr_IndxonlyCharging[TRUE]); //      2 
						if(indxonlycharging_tmp==0) indx_opr.onlysecondcharging=FALSE; //       
						else indx_opr.onlysecondcharging=TRUE; //   
						indx_opr.locksecondonlycharge=TRUE; //         2 
						indxfullcharging_tmp=eeprom_read_byte(&Opr_IndxfullCharging[TRUE]); //      2 
						if(indxfullcharging_tmp==0) indx_opr.secondfullservice=FALSE; //         
						else indx_opr.secondfullservice=TRUE; //   
			}
		switch(alter_opr.countertypebattery[indx_opr.settingnumber]) //   
			{
			case 0: NMC_ReadnimhDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //   Ni-Mh  
					break;
			case 1: NMC_ReadnicdDeferred(indx_opr.settingnumber,indxchargedischarge_tmp); //   Ni-Cd  
					break;
			case 2: LPI_ReadlipoDeferred(indx_opr.settingnumber); //   Li-Po  
					break;
			case 3: LPI_ReadlionDeferred(indx_opr.settingnumber); //   Li-Ion  
					break;
			case 4: LFE_ReadlifeDeferred(indx_opr.settingnumber); //   Li-Fe  
			}
		}
	}

void OPR_WritevalueDeferred(bit numberbattery_prm) //     
	{
	bit indxchargedischarge_tmp=FALSE; // 
	byte indxonlycharging_tmp=0; 
	byte indxfullcharging_tmp=0; 
	if(eeprom_read_byte(&Opr_IndexoutDeferred[numberbattery_prm])==0) //      
		{
		eeprom_write_byte(&Opr_TypemodeBattery[0][numberbattery_prm],alter_opr.countertypebattery[numberbattery_prm]); //   
		eeprom_write_byte(&Opr_TypemodeBattery[1][numberbattery_prm],alter_opr.countermodebattery[numberbattery_prm]); //   
		eeprom_write_byte(&Opr_TypemodeBattery[2][numberbattery_prm],alter_opr.currentstatusprocess[numberbattery_prm]); //    
		eeprom_write_word(&Opr_SettingCapacity[numberbattery_prm],alter_opr.settcapacitybattery[numberbattery_prm]); //   
		eeprom_write_dword(&Opr_SummaChargedischarge[numberbattery_prm],alter_opr.summachargebattery[numberbattery_prm]); // /   
		eeprom_write_word(&Opr_ParametersDeferred[0][numberbattery_prm],alter_opr.initialvoltagebattery[numberbattery_prm]); //   / 
		eeprom_write_word(&Opr_ParametersDeferred[1][numberbattery_prm],alter_opr.maximumcurrentbattery[numberbattery_prm]); //   / 
		eeprom_write_word(&Opr_ParametersDeferred[2][numberbattery_prm],alter_opr.miniresistancebattery[numberbattery_prm]); //      / 
		eeprom_write_word(&Opr_ParametersDeferred[3][numberbattery_prm],alter_opr.maximumtemperature[numberbattery_prm]); //    
		eeprom_write_word(&Opr_ParametersDeferred[4][numberbattery_prm],alter_opr.maximumoverheating[numberbattery_prm]); //     
		eeprom_write_byte(&Opr_IndexoutDeferred[numberbattery_prm],1); //        
		switch(numberbattery_prm) //   
			{
			case FALSE: indxchargedischarge_tmp=indx_opr.firstchargedischarge; //  /  1 
						if(indx_opr.onlyfirstcharging==FALSE) indxonlycharging_tmp=0; //       
						else indxonlycharging_tmp=1; //    
						indxchargedischarge_tmp=indx_opr.firstfullservice; //      1 
						if(indxchargedischarge_tmp==FALSE) indxfullcharging_tmp=0; //       
						else indxfullcharging_tmp=1; //    
						eeprom_update_byte(&Opr_IndxonlyCharging[FALSE],indxonlycharging_tmp); //     eeprom  
						eeprom_update_byte(&Opr_IndxfullCharging[FALSE],indxfullcharging_tmp); //     eeprom  
						break;
			case TRUE: indxchargedischarge_tmp=indx_opr.secondchargedischarge; //  /  2 
						if(indx_opr.onlysecondcharging==FALSE) indxonlycharging_tmp=0; //      
						else indxonlycharging_tmp=1; //   
						indxchargedischarge_tmp=indx_opr.secondfullservice; //      2 
						if(indxchargedischarge_tmp==FALSE) indxfullcharging_tmp=0; //      
						else indxfullcharging_tmp=1; //   
						eeprom_update_byte(&Opr_IndxonlyCharging[TRUE],indxonlycharging_tmp); //     eeprom  
						eeprom_update_byte(&Opr_IndxfullCharging[TRUE],indxfullcharging_tmp); //     eeprom  
			}
		switch(alter_opr.countertypebattery[numberbattery_prm]) //   
			{
			case 0: NMC_WritenimhDeferred(numberbattery_prm,indxchargedischarge_tmp); //    Ni-Mh  
					break;
			case 1: NMC_WritenicdDeferred(numberbattery_prm,indxchargedischarge_tmp); //    Ni-d  
					break;
			case 2: LPI_WritelipoDeferred(numberbattery_prm); //    Li-Po  
					break;
			case 3: LPI_WritelionDeferred(numberbattery_prm); //    Li-Ion  
					break;
			case 4: LFE_WritelifeDeferred(numberbattery_prm); //    Li-Fe  
			}
		}
	}

byte OPR_SearchSensors(byte numbersensors_prm) //      
	{
	byte numbersensors_tmp=0; // 
	byte ininumbersensors_tmp=0; 
	byte endnumbersensors_tmp=0; 
	ininumbersensors_tmp=numbersensors_prm; //    
	endnumbersensors_tmp=ininumbersensors_tmp+5; //    
	while((ininumbersensors_tmp<endnumbersensors_tmp)&&(numbersensors_tmp==0)) //  
		{
		if(OWI_DetectPresence()==0) //    
			{
			OWI_TransferIdentifi(ininumbersensors_tmp); //      
			OWI_TransferRecall(); //     eeprom   
			OWI_DetectPresence(); // 
			OWI_TransferIdentifi(ininumbersensors_tmp); //  
			if(OWI_ReadramSensor()==TRUE) numbersensors_tmp=OWI_ReadbyteBuffer(2); //      
			}
		ininumbersensors_tmp++; //   
		}
	return numbersensors_tmp; //   
	}

void OPR_StartConverting(bit indxtimewaiting_prm,byte numbersensors_prm) //   
	{
	if(OWI_DetectPresence()==0) //    
		{
		OWI_TransferConverting(indxtimewaiting_prm,numbersensors_prm); //     
		}
	}

word OPR_ReadTemperature(byte numbersensors_prm) //    
	{
	word measuredvalue_tmp=0; // 
	if(OWI_DetectPresence()==0) //    
		{
		OWI_TransferIdentifi(numbersensors_prm); //     
		if(OWI_ReadramSensor()==TRUE) measuredvalue_tmp=OWI_ConversionDecimal(); //       
		}
	return measuredvalue_tmp; //   
	}

byte OPR_ReadnumberSensor(bit numberbattery_prm) //   
	{
	return alter_opr.datanumbersensors[numberbattery_prm]; //    
	}

byte OPR_ReadnumberProtocol(bit numberbattery_prm) //     
	{
	return eeprom_read_byte(&Opr_TypemodeBattery[3][numberbattery_prm]); //     
	}

void OPR_BlockingOutitems(void) //       
	{
	switch(indx_opr.settingnumber) //   
		{
		case FALSE: if(indx_opr.blockfirstoutitems==TRUE) indx_opr.blockfirstoutitems=FALSE; //       1 
					break;
		case TRUE: if(indx_opr.blocksecondoutitems==TRUE) indx_opr.blocksecondoutitems=FALSE; //       2  	
		}
	}

void OPR_UnblockingOutitems(void) //       
	{
	switch(indx_opr.settingnumber) //   
		{
		case FALSE: if(indx_opr.blockfirstoutitems==FALSE) indx_opr.blockfirstoutitems=TRUE; //       1
					break;
		case TRUE: if(indx_opr.blocksecondoutitems==FALSE) indx_opr.blocksecondoutitems=TRUE; //       2
		}
	}

void OPR_OutputitemsProtocol(bit numberbattery_prm) //      
	{
	word dataitemsprotocol_tmp=0; //  
	dataitemsprotocol_tmp=eeprom_read_word(&Opr_DataitemsProtocol[0][numberbattery_prm]); //    
	if(dataitemsprotocol_tmp==0) //      
		{
		switch(numberbattery_prm) //   
			{
			case FALSE: indx_opr.outputfirstprotocol=FALSE; //          1 
						break;
			case TRUE: indx_opr.outputsecondprotocol=FALSE; //          2 
			}
		indx_opr.updatetextstring=TRUE; //    
		}
	else //       
		{
		dataitemsprotocol_tmp=eeprom_read_word(&Opr_DataitemsProtocol[alter_opr.counteritemprotocol[numberbattery_prm]][numberbattery_prm]); //     
		switch(alter_opr.counteritemprotocol[numberbattery_prm]) //    
			{
			case 0: SYM_LineOut((byte)dataitemsprotocol_tmp,0,FALSE,numberbattery_prm,4); //      
					break;
			case 1: SYM_LineOut(14,0,FALSE,numberbattery_prm,1); // : :        
					SYM_OutdataNumber00000(dataitemsprotocol_tmp,6); //    
					break;
			case 2: SYM_LineOut(43,0,FALSE,numberbattery_prm,1); // : :    ,     
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //      
					break;
			case 3: SYM_LineOut(43,0,FALSE,numberbattery_prm,1); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //      
					break;
			case 4: SYM_LineOut(45,0,FALSE,numberbattery_prm,1); // : :  -     
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,9); //    
					break;
			case 5: SYM_LineOut(45,0,FALSE,numberbattery_prm,1); // : :  -    
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,9); //   
					break;
			case 6: SYM_LineOut(17,0,FALSE,numberbattery_prm,1); // : : -       
					SYM_OutdataNumber00000(dataitemsprotocol_tmp,7); //     
					break;
			case 7: SYM_LineOut(40,0,FALSE,numberbattery_prm,1); // : :   ,     
					SYM_OutdataNumber0_000(dataitemsprotocol_tmp,7); //       
					break;
			case 8: SYM_LineOut(21,0,FALSE,numberbattery_prm,1); // : :      * 
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,11); //      
					break;
			case 9: SYM_LineOut(23,0,FALSE,numberbattery_prm,1); // : :      *
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,11); //       
					break;
			case 10: SYM_LineOut(44,0,FALSE,numberbattery_prm,1); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //     
					break;
			case 11: SYM_LineOut(44,0,FALSE,numberbattery_prm,1); // : :    ,    
					SYM_OutdataNumber00_000(dataitemsprotocol_tmp,8); //      
					break;
			case 12: SYM_LineOut(46,0,FALSE,numberbattery_prm,1); // : :       
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,9); //   
					break;
			case 13: SYM_LineOut(46,0,FALSE,numberbattery_prm,1); // : :       
					SYM_OutdataNumber0000(dataitemsprotocol_tmp,9); //    
					break;
			case 14: SYM_LineOut(18,0,FALSE,numberbattery_prm,1); // : :       
					SYM_OutdataNumber00000(dataitemsprotocol_tmp,7); //     
					break;
			case 15: SYM_LineOut(41,0,FALSE,numberbattery_prm,1); // : :   ,    
					SYM_OutdataNumber0_000(dataitemsprotocol_tmp,7); //      
					break;
			case 16: SYM_LineOut(22,0,FALSE,numberbattery_prm,1); // : :      *
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,11); //      
					break;
			case 17: SYM_LineOut(24,0,FALSE,numberbattery_prm,1); // : :      * 
					SYM_OutdataNumber00((byte)dataitemsprotocol_tmp,11); //       
			}
		}
	}

void OPR_WritedataProtocol(bit numberbattery_prm) //    
	{
	switch(numberbattery_prm) //   
		{
		case FALSE:	switch(alter_opr.countermodebattery[FALSE]) //    1
						{
						case 0: switch(indx_opr.firstchargedischarge) // / 
									{
									case FALSE: asm("nop"); // 
												break; 
									case TRUE: OPR_DatadischargeProtocol(FALSE,FALSE); //       
									}
								break; 
						case 1: switch(indx_opr.firstchargedischarge) // / 
									{
									case FALSE: asm("nop"); // 
												break;
									case TRUE: OPR_DatadischargeProtocol(FALSE,TRUE); //      
									}
								break; 
						case 2: switch(indx_opr.firstchargedischarge) // / 
									{
									case FALSE: switch(indx_opr.firstfullservice) //     
													{
													case FALSE: OPR_DatachargeProtocol(FALSE,TRUE); //  a     
																break; 
													case TRUE: OPR_DatachargeProtocol(FALSE,FALSE); //  a     
													}
												break; 
									case TRUE: asm("nop"); //  
									}
								break; 
						case 3 ... 4: asm("nop"); // 
						}
					break;
		case TRUE: switch(alter_opr.countermodebattery[TRUE]) //    2
						{
						case 0: switch(indx_opr.secondchargedischarge) // /
									{
									case FALSE: asm("nop"); // 
												break;
									case TRUE: OPR_DatadischargeProtocol(TRUE,FALSE); //      
									}
								break;
						case 1: switch(indx_opr.secondchargedischarge) // /
									{
									case FALSE: asm("nop"); // 
												break;
									case TRUE: OPR_DatadischargeProtocol(TRUE,TRUE); //      
									}
								break;
						case 2: switch(indx_opr.secondchargedischarge) // /
									{
									case FALSE: switch(indx_opr.secondfullservice) //  
													{
													case FALSE: OPR_DatachargeProtocol(TRUE,TRUE); //  a    
																break;
													case TRUE: OPR_DatachargeProtocol(TRUE,FALSE); //  a    
													}
												break;
									case TRUE: asm("nop"); // 
									}
								break;
						case 3 ... 4: asm("nop"); // 
						}
		}
	}

void OPR_DatachargeProtocol(bit numberbattery_prm,bit indxresetdata_prm) //          
	{
	eeprom_write_word(&Opr_DataitemsProtocol[10][numberbattery_prm],alter_opr.initialvoltagebattery[numberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[11][numberbattery_prm],alter_opr.measuredvoltagebattery[numberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[12][numberbattery_prm],alter_opr.maximumcurrentbattery[numberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[13][numberbattery_prm],alter_opr.measuredcurrentbattery[numberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[14][numberbattery_prm],alter_opr.measuredchargebattery[numberbattery_prm]); //       
	eeprom_write_word(&Opr_DataitemsProtocol[15][numberbattery_prm],alter_opr.miniresistancebattery[numberbattery_prm]); //       
	eeprom_write_word(&Opr_DataitemsProtocol[16][numberbattery_prm],alter_opr.maximumtemperature[numberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[17][numberbattery_prm],alter_opr.maximumoverheating[numberbattery_prm]); //        
	if(indxresetdata_prm==TRUE) OPR_ResetdataProtocol(numberbattery_prm,TRUE); //         
	}

void OPR_DatadischargeProtocol(bit numberbattery_prm,bit indxresetdata_prm) //          
	{
	word dataitemsprotocol_tmp=0; //  
	dataitemsprotocol_tmp=OPR_TypebatteryProtocol(numberbattery_prm); //     
	eeprom_write_byte(&Opr_TypemodeBattery[3][numberbattery_prm],alter_opr.datanumbersensors[numberbattery_prm]); //   
	eeprom_write_word(&Opr_DataitemsProtocol[0][numberbattery_prm],dataitemsprotocol_tmp); //   
	eeprom_write_word(&Opr_DataitemsProtocol[1][numberbattery_prm],alter_opr.settcapacitybattery[numberbattery_prm]); //   
	eeprom_write_word(&Opr_DataitemsProtocol[2][numberbattery_prm],alter_opr.initialvoltagebattery[numberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[3][numberbattery_prm],alter_opr.measuredvoltagebattery[numberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[4][numberbattery_prm],alter_opr.maximumcurrentbattery[numberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[5][numberbattery_prm],alter_opr.measuredcurrentbattery[numberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[6][numberbattery_prm],alter_opr.measuredchargebattery[numberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[7][numberbattery_prm],alter_opr.miniresistancebattery[numberbattery_prm]); //      
	eeprom_write_word(&Opr_DataitemsProtocol[8][numberbattery_prm],alter_opr.maximumtemperature[numberbattery_prm]); //     
	eeprom_write_word(&Opr_DataitemsProtocol[9][numberbattery_prm],alter_opr.maximumoverheating[numberbattery_prm]); //      
	if(indxresetdata_prm==TRUE) OPR_ResetdataProtocol(numberbattery_prm,FALSE); //        
	}

void OPR_ResetdataProtocol(bit numberbattery_prm,bit indxchargedischarge_prm) //    
	{
	bit indxendresetcycle_tmp=FALSE; //  
	byte databeginnarray_tmp=0; 
	byte dataendingarray_tmp=0; 
	word dataitemsprotocol_tmp=0; 
	switch(indxchargedischarge_prm) //  / 
		{
		case FALSE: databeginnarray_tmp=10; //      
					dataendingarray_tmp=17; //      
					while(indxendresetcycle_tmp==FALSE) //     
						{
						eeprom_write_word(&Opr_DataitemsProtocol[databeginnarray_tmp][numberbattery_prm],0); //      
						databeginnarray_tmp++; //  
						if(databeginnarray_tmp>dataendingarray_tmp) indxendresetcycle_tmp=TRUE; //     
						}
					break;
		case TRUE: dataitemsprotocol_tmp=OPR_TypebatteryProtocol(numberbattery_prm); //     
					eeprom_write_byte(&Opr_TypemodeBattery[3][numberbattery_prm],alter_opr.datanumbersensors[numberbattery_prm]); //   
					eeprom_write_word(&Opr_DataitemsProtocol[0][numberbattery_prm],dataitemsprotocol_tmp); //   
					eeprom_write_word(&Opr_DataitemsProtocol[1][numberbattery_prm],alter_opr.settcapacitybattery[numberbattery_prm]); //   
					databeginnarray_tmp=2; //      
					dataendingarray_tmp=9; //      
					while(indxendresetcycle_tmp==FALSE) //     
						{
						eeprom_write_word(&Opr_DataitemsProtocol[databeginnarray_tmp][numberbattery_prm],0); //    
						databeginnarray_tmp++; //  
						if(databeginnarray_tmp>dataendingarray_tmp) indxendresetcycle_tmp=TRUE; //     
						}
		}
	}

bit OPR_ControlViolconnect(bit numberbattery_prm,word measurecurrentbattery_prm) //      
	{
	bit indxconnectbattery_tmp=FALSE; //  
	switch(alter_opr.countertypebattery[numberbattery_prm]) //   
		{
		case 0 ... 1: if(((alter_opr.measvoltageloadedbattery[numberbattery_prm]>=OPRMAXLIMNMC_VOLTAGE)||(alter_opr.measvoltageloadedbattery[numberbattery_prm]<=OPRMINLIMNMC_VOLTAGE))&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //       /   Ni-Cd  Ni-Mh  
				break;
		case 2 ... 3: if(((alter_opr.measvoltageloadedbattery[numberbattery_prm]>=OPRMAXLIMLPI_VOLTAGE)||(alter_opr.measvoltageloadedbattery[numberbattery_prm]<=OPRMINLIMLPI_VOLTAGE))&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //       /   Li-Po  Li-Ion  
				break;
		case 4: if(((alter_opr.measvoltageloadedbattery[numberbattery_prm]>=OPRMAXLIMLFE_VOLTAGE)||(alter_opr.measvoltageloadedbattery[numberbattery_prm]<=OPRMINLIMLFE_VOLTAGE))&&(measurecurrentbattery_prm<=5)) indxconnectbattery_tmp=TRUE; //       /   Li-Fe  
		}
	return indxconnectbattery_tmp; //   
	}																													

word OPR_TypebatteryProtocol(bit numberbattery_prm) //     
	{
	word dataitemsprotocol_tmp=0; //  
	switch(alter_opr.countertypebattery[numberbattery_prm]) //   
		{
		case 0: switch(alter_opr.datanumbersensors[numberbattery_prm]) //   
					{
					case 1 ... 10: dataitemsprotocol_tmp=9; //    : : .  Ni-Mh 
					}
				break;
		case 1: switch(alter_opr.datanumbersensors[numberbattery_prm]) //   
					{
					case 11 ... 20: dataitemsprotocol_tmp=10; //    : : .  Ni-Cd 
					}
				break;
		case 2: switch(alter_opr.datanumbersensors[numberbattery_prm]) //   
					{
					case 21 ... 30: dataitemsprotocol_tmp=11; //    : : .  Li-Po 
					}
				break;
		case 3: switch(alter_opr.datanumbersensors[numberbattery_prm]) //   
					{
					case 31 ... 40: dataitemsprotocol_tmp=12; //    : : .  Li-Ion 
					}
				break;
		case 4: switch(alter_opr.datanumbersensors[numberbattery_prm]) //   
					{
					case 41 ... 50: dataitemsprotocol_tmp=13; //    : : .  Li-Fe 
					}
		}
	return dataitemsprotocol_tmp; //     
	}





























