/************************************************
* Operatingmode.h
*     
* : 02.11.2021 20:03:29
* :  .
*************************************************/

#pragma once

#include "Main.h"

#define OPRFIRST_CHARGE OCR1A //     1
#define OPRSECOND_CHARGE OCR1B //     2
#define OPRFIRST_DISCHARGE OCR0A //     1
#define OPRSECOND_DISCHARGE OCR0B //     2
#define OPRFAN_CONTROL OCR2A //   
#define OPRCIRCUIT_RESISTANCE 100 //   / 0,01 
#define OPRMAXLIMNMC_VOLTAGE 2000 //     Ni-Cd  Ni-Mh  
#define OPRMINLIMNMC_VOLTAGE 300 //     Ni-Cd  Ni-Mh  
#define OPRMAXLIMLPI_VOLTAGE 4700 //     Li-Po  Li-Ion  
#define OPRMINLIMLPI_VOLTAGE 2000 //     Li-Po  Li-Ion 
#define OPRMAXLIMLFE_VOLTAGE 4150 //     Li-Fe 
#define OPRMINLIMLFE_VOLTAGE 1000 //     Li-Fe   
#define OPRDETECTNMC_VOLTAGE 1700 //     Ni-Cd  Ni-Mh  
#define OPRDETECTLPI_VOLTAGE 4300 //     Li-Po  Li-Ion  
#define OPRDETECTLFE_VOLTAGE 3700 //     Li-Fe  

typedef struct
	{
	bit finishfirstonecycle:1; //     1
	bit finishsecondonecycle:1; //     2       
	bit onoffworkingservice:1; // /                  
	bit startingworkcycle:1; //     
	bit settingnumber:1; //        
	bit processnumber:1; //      
	bit firstchargedischarge:1; // /   1
	bit secondchargedischarge:1; // /   2
	bit updatetextstring:1; //    
	bit updateparameters:1; //    
	bit startfirstservices:1; //    1
	bit startsecondservices:1; //    2
	bit stopfirstservices:1; //    1
	bit stopsecondservices:1; //    2 
	bit postponefirstservice:1; //    1 
	bit postponesecondservice:1; //    2 
	bit connectfirstbattery:1; //   1
	bit connectsecondbattery:1; //   2
	bit onlyfirstcharging:1; //    1 
	bit onlysecondcharging:1; //    2 
	bit lockfirstonlycharge:1; //       1
	bit locksecondonlycharge:1; //       2 
	bit blockfirstoutitems:1; //     1 
	bit blocksecondoutitems:1; //     2 
	bit outputfirstprotocol:1; //      1 
	bit outputsecondprotocol:1; //      2 
	bit firstfullservice:1; //     1 
	bit secondfullservice:1; //     2 
	bit prioritycomplete:1; //      
	bit firstviolacontact:1; //     1 
	bit secondviolacontact:1; //     2 
	}bit_opr;

typedef struct
	{
	byte counteritemprotocol[2]; //    1[0]  2[1] 
	byte currentstatusprocess[2]; //     1[0]  2[1] 
	byte datanumbersensors[2]; //     1[0]  2[1] 
	byte counterworkcycle[2]; //    1[0]  2[1]
	byte counterpositioncursor[2]; //    1[0]  2[1]
	byte locationcursorline[2]; //         1[0]  2[1]
	byte counteroutitems[2]; //     1[0]  2[1]
	byte countertypebattery[2]; //    1[0]  2[1]
	byte countermodebattery[2]; //    1[0]  2[1]
	byte counteroutparameter[2]; //      1[0]  2[1]
	byte displaytemperature[2]; //    1[0]  2[1]
	byte countercycleservice[2]; //      1[0]  2[1]  
	word increaseratevoltage[2]; //       1[0]  2[1]
	word increasetemperature[2]; //       1[0]  2[1]
	word measuredtemperature[2]; //    1[0]  2[1] 
	word initialtemperature[2]; //    1[0]  2[1] 
	word countgeneralpurpose[2]; //   1[0]  2[1]  
	word settcapacitybattery[2]; //   1[0]  2[1]
	word measuredcurrentbattery[2]; // /  1[0]  2[1]
	word measuredvoltagebattery[2]; //    1[0]  2[1] 
	word measvoltageloadedbattery[2]; //   1[0]  2[1] 
	word maximumtemperature[2]; //   1[0]  2[1] 
	word maximumoverheating[2]; //    1[0]  2[1] 
	word measuredchargebattery[2]; //  /  /  1[0]  2[1] 
	word settingcurrentbattery[2]; //   /  1[0]  2[1] 
	word intresistancebattery[2]; //   1[0]  2[1] 
	word counterinterrupt; //    64 
	word initialvoltagebattery[2]; //   /  1[0]  2[1] 
	word maximumcurrentbattery[2]; //   /  1[0]  2[1] 
	word miniresistancebattery[2]; //    /  1[0]  2[1] 
	dword summacurrentbattery[2]; //    1[0]  2[1]
	dword summachargebattery[2]; //  /  /  1[0]  2[1]
	}var_opr;

void OPR_MainMode(bit indxupdateline_prm); //   
void OPR_SettingParameters(void); //    
void OPR_DefineModeservice(void); //    
void OPR_OperationalBattery(void); //    
void OPR_CancellOperational(void); //     
void OPR_CompleteOperational(void); //     
void OPR_SearchBattery(void); //   
void OPR_NotconnectBattery(void); //    
void OPR_WorkcycleService(void); //     
void OPR_StartstopWorkcycle(bit indxstartstop_prm); //      
void OPR_ControlWorkcycle(byte datacodecontrol_prm); //    
void OPR_SmootCurrcharge(bit numberbattery_prm,bit settingdirect_prm,word numbercycles_prm); //    
void OPR_SmootCurrdischarge(bit numberbattery_prm,bit settingdirect_prm,word numbercycles_prm); //     
void OPR_OutitemBatterytype(void); //   
void OPR_OutitemBatterymode(void); //     
void OPR_OutserviceBatterymode(void); //     
void OPR_OutserviceParameters(void); //      
void OPR_DecodeLeftbutton(void); //   Left
void OPR_DecodeRigtbutton(void); //   Rigt 
void OPR_DecodeUpbutton(void); //   Up
void OPR_DecodeDownbutton(void); //   Down
void OPR_DecodeEnterbutton(void); //   Enter
void OPR_ResetVariables(void); //   
void OPR_ResetExternaldata(bit numberbattery_prm); //    
void OPR_CalculationParameters(void); //      
void OPR_ReadvalueDeferred(void); //      
void OPR_WritevalueDeferred(bit numberbattery_prm); //      
void OPR_StartConverting(bit indxtimewaiting_prm,byte numbersensors_prm); //    
void OPR_ControlAircooler(void); //     
void OPR_BlockingOutitems(void); //    
void OPR_UnblockingOutitems(void); //     
void OPR_OutputitemsProtocol(bit numberbattery_prm); //    
void OPR_WritedataProtocol(bit numberbattery_prm); //    
void OPR_DatachargeProtocol(bit numberbattery_prm,bit indxresetdata_prm); //     
void OPR_DatadischargeProtocol(bit numberbattery_prm,bit indxresetdata_prm); //     
void OPR_ResetdataProtocol(bit numberbattery_prm,bit indxchargedischarge_prm); //    / 
void OPR_NocontactBattery(void); //      
bit OPR_DetectBattery(void); //   
bit OPR_ControlStopindex(void); //      
bit OPR_ControlViolconnect(bit numberbattery_prm,word measurecurrentbattery_prm); //       
byte OPR_SearchSensors(byte numbersensors_prm); //      
byte OPR_ReadnumberSensor(bit numberbattery_prm); //    
byte OPR_ReadnumberProtocol(bit numberbattery_prm); //      
word OPR_TypebatteryProtocol(bit numberbattery_prm); //     
word OPR_MonitoringParameters(void); //       
word OPR_MonitoringTypebattery(void); //       
word OPR_ReadTemperature(byte numbersensors_prm); //     












