/*************************************************************
 * Owids18b20.h
 *      DS18B20   1-Wire
 * : 12.06.2022 12:13:15
 * :  .
 *************************************************************/ 

#pragma once

#include <avr/io.h>
#include "Main.h"

#define OWIBUS_INPUT PINC //  1-Wire
#define OWIBUS_CONTROL DDRC //   1-Wire
#define OWIBUS_BITDATA PINC5 //   1-Wire
#define OWIBUS_CONTDATA DDC5 //    1-Wire

//  DS18B20
#define OWIORDER_CONVERT 68 //  (0x44)
#define OWIORDER_READSCR 190 //   (0xBE)
#define OWIORDER_ROMSKIP 204 //   ROM (0xCC)
#define OWIORDER_SEARCHROM 240 //  ROM (0xF0)
#define OWIORDER_READROM 51 //  ROM (0x33)
#define OWIORDER_MATCHROM 85 //  ROM (0x55)
#define OWIORDER_WRITESCR 78 //  3-    (0x4E)
#define OWIORDER_COPYSCR 72 //  3-      (0x48)
#define OWIORDER_RECALL 184 //   3-      (0xB8)
#define OWIORDER_SEARCHALARM 236 //     (0xEC)

//     
#define OWIDELAY_RANGE5U 20 
#define OWIDELAY_RANGE10U 40
#define OWIDELAY_RANGE60U 240
#define OWIDELAY_RANGE65U 260
#define OWIDELAY_RANGE435U 1740
#define OWIDELAY_RANGE500U 2000
#define OWIDELAY_RANGE10M 40000

// 
void OWI_TransferByte(byte transferdata_prm); //    
void OWI_TransferBit(byte transferbitdata_prm); //    
void OWI_TransferIdentifi(byte numbersensor_prm); //   
void OWI_TransferConverting(bit indxtimewaiting_prm,byte numbersensor_prm); //    
void OWI_ConservIdentifi(byte numbersensor_prm); //    eeprom 
void OWI_InitializeBuses(void); //   1-wire
void OWI_TransferRecall(void); //    eeprom   
bit OWI_ReceiveIdentifi(void); //   
bit OWI_ReadramSensor(void); //   
byte OWI_DetectPresence(void); //      
byte OWI_ReceiveBit(void); //    
byte OWI_ReceiveByte(void); //    
byte OWI_CheckBytesum(byte currentamount_prm,byte checkdata_prm); //   
byte OWI_ReadbyteBuffer(byte indxarraydata_prm); //   
word OWI_ConversionDecimal (void); //       
word OWI_MeasuredTemperature(bit indxtimewaiting_prm,byte numbersensors_prm); //  







