/*******************************************************************
* Chargerbattery.c
* : 06.06.2022 12:30:08
* :  .
* :     v_1.4 
* : ATMega328P
*  : 16000000 
*  
* FuseHB=DD:
			BODLEVEL2-0=101;   BOD 2,7 
			EESAVE=1;   EEPROM 
			WDTON=1;   
			SPIEN=0;     SPI
			DWEN=1;   
			RSTDISBL=1;    
* FuseLB=F7:
			CKSEL3-0=0111;    8   
			SUT1-0=11;    
			CKOUT=1;   
			CKDIV8=1;    
* FuseExtB=07:
			BOOTRST=1;      
			BOOTSZ0=1;    
			BOOTSZ1=1;    
**********************************************************************/
 

#include <avr/io.h>
#include "Main.h"
#include "Lcdworkunit.h"
#include "Keybuttscan.h"
#include "Symbolout.h"
#include "Systemcontrol.h"
#include "Adconverter.h"
#include "Owids18b20.h"


int main(void)
	{
    DDRB=15; //PB0-PB3 ,  , PB4,PB5   
    PORTB=48; //  PB0-PB3 . 0
    DDRC=16; //PC4 ,  
    PORTC=0; // PC4 .0
    DDRD=255; // 
    PORTD=31; // PD0-PD4 .1   .0
    LCD_InitializeDevice(); //  LCD
    SYS_InitializeBeep(); //  
    ADC_InitializeDevice(); // 
    OWI_InitializeBuses(); //  1-wire   
    SYS_InitializePwmcontrol(); //  
	SYM_LoadingDegrees(); //  
    SYM_LineOut(0,0,FALSE,FALSE,0); // :  v_1.4 2022
	SYS_TimeWaiting(2000); // 2 
	SYS_OutsignalBeep(50,1); //    50 

    while (1)
		{
		SYS_MainMode(); //  
		}
	}

